PAGE 66,132
TITLE ** B10_06__.ASM - Programma per la gestione di FINESTRE in Pagine Video0
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_06__.ASM                         (INT 10H, Funzione 06H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Verifica l'effetto della Funzione che sposta in   ALTO  aree|
;|               di AL righe di bytes, dentro una Finestra in Pagina0 limita-|
;|               ta tra i punti in alto a sinistra (CH riga, CL colonna) e in|
;|               basso a destra (DH riga, DL colonna) riempita con  spazi  di|
;|               colore BH.                                                  |
;|                                                                           |
;|               Il programma costituisce un buon esempio di gestione di  og-|
;|               getti in modo "dinamico", cio sottoposti a  caratteristiche|
;|               intrinseche DIPENDENTI da quelle omologhe di oggetti simili,|
;|               realizzati in precedenza.                                   |
;\---------------------------------------------------------------------------/

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN      KEYwait:NEAR
        EXTRN      BIOSmsg:NEAR
        EXTRN      VIA_cur:NEAR
        EXTRN      BIOchr1:NEAR
        EXTRN      SET_cur:NEAR
        PUBLIC     ATTRIB     ;Attributo di colore


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_06__

;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
RigaAlto DB     00H           ;Numero della   Riga  in alto a sinistra
ColnAlto DB     00H           ;Numero della Colonna in alto a sinistra
RigaBass DB     00H           ;Numero della   Riga  in basso a  destra
ColnBass DB     00H           ;Numero della Colonna in basso a  destra
Colore   DB     00H           ;Codice dell'attributo di colore utilizzato
NumRighe DB     00H           ;Numero di righe previsto per la Finestra
ATTRIB   DB     00H           ;Attributo di colore per la Libreria


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : Scroll                                                      |
;| DESCRIZIONE : Inizializza la Funzione sotto test assumendo i parametri  ad|
;|               essa necessari dalle variabile del programma: le  coordinate|
;|               dell'angolo in alto a  sinistra  da [RigaAlto],[ColnAlto]  e|
;|               dell'angolo in basso  a  destra da [RigaBass],[ColnBass]; il|
;|               colore con cui riempire la Finestra da [Colore] e il  numero|
;|               di righe da spostare da [NumRighe]; esegue poi la Funzione e|
;|               aspetta la pressione di un tasto qualunque.                 |
;\---------------------------------------------------------------------------/
Scroll: MOV   CH,CS:[RigaAlto];
        MOV   CL,CS:[ColnAlto];
        MOV   DH,CS:[RigaBass]; La Funzione 06H viene ora collaudata per  pro-
        MOV   DL,CS:[ColnBass]; durre una serie di Finestre concentriche otte-
        MOV   BH,CS:[Colore]  ; nute manipolando dinamicamente i  parametri ad
        MOV   AL,CS:[NumRighe]; essa necessari
        MOV     AH,06H        ;
        INT     10H           ;
                              ;
        CALL    KEYwait       ; Rimane in attesa della pressione di un tasto
        RET                   ;


;*****************************************************************************
                              ; ----------------------------------------------
B10_06__ proc   NEAR          ;       AREA DEDICATA AL MAIN PROGRAM
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
                              ;/---------------------------------------------\
                              ;|      Inizializzazione  delle  Variabili     |
                              ;\---------------------------------------------/
        CALL    VIA_cur       ; Evita  la  visualizzazione  del  Cursore
 MOV Byte Ptr CS:[RigaAlto],00; Inizializza il Numero Riga  in alto a sinistra
 MOV Byte Ptr CS:[ColnAlto],00; Inizializza il Numero Colonna in alto sinistra
 MOV Byte Ptr CS:[RigaBass],24; Inizializza il Numero Riga  in basso a  destra
 MOV Byte Ptr CS:[ColnBass],79; Inizializza il Numero Colonna in basso  destra
 MOV Byte Ptr  CS:[Colore],7FH; Inizializza il Codice  colore  della  finestra
 MOV Byte Ptr CS:[NumRighe],00; Inizializza il Numero di righe per la Finestra
                              ;/---------------------------------------------\
                              ;|      Fase di collaudo  con ClearScreen      |
                              ;\---------------------------------------------/
                              ; La Funzione 06H viene  collaudata  al  fine di
                              ; produrre  un ClearScreen  (AL=00H);  l'area da
                              ; controllare  va da CH=riga=00H, CL=colonna=00H
        CALL    Scroll        ; (angolo in alto a sinistra)  a DH=riga=18H=25,
                              ; DL=colonna=4FH=79 (angolo in basso a destra) e
                              ; viene  riempita  con  spazi  NERI  su  BIANCO
                              ;/---------------------------------------------\
                              ;| Fase di collaudo di traccia Cornici Interne |
                              ;\---------------------------------------------/
        MOV     CX,5          ; Predispone  il  collaudo   per  cinque cornici
XXX00:  PUSH    CX            ;
        MOV     AL,02H        ;
        ADD   CS:[RigaAlto],AL;
        ADD   CS:[ColnAlto],AL; Aggiorna le sei variabili associate  ai  para-
        SUB   CS:[RigaBass],AL; metri necessari alla Funzione 06H in  modo  da
        SUB   CS:[ColnBass],AL; predisporre una serie di cornici  concentriche
  SUB Byte Ptr CS:[Colore],10H;
        ADD     AL,AL         ;
        SUB   CS:[NumRighe],AL;
                              ; La Funzione 06H viene ora collaudata per  pro-
        CALL    Scroll        ; durre una serie di Finestre concentriche otte-
                              ; nute manipolando dinamicamente i  parametri ad
                              ; essa necessari
        POP     CX
        LOOP    XXX00
                              ;/---------------------------------------------\
                              ;|  Fase di collaudo testi dentro la  Cornice  |
                              ;\---------------------------------------------/
        MOV   DH,CS:[RigaBass]; Fissa la corretta posizione di stampa dei  ca-
        MOV   DL,CS:[ColnAlto]; ratteri sulla riga in basso dell'ultima  Fine-
        CALL    SET_cur       ; stra proposta DH=[RigaAlto], DL=[ColnAlto]

        MOV     CH,00H        ; Calcola in CX il corretto numero di  caratteri
        MOV   CL,CS:[ColnBass]; da stampare  dentro  la  riga  corrente  della
        SUB   CL,CS:[ColnAlto]; Finestra
        INC     CX            ;
        MOV     AH,CS:[Colore]; Preleva  il  colore  dell'ultima  Finestra
        MOV     CS:[ATTRIB],AH;
        MOV     AL,"*"        ;
XXX01:  CALL    BIOchr1       ; Provvede alla stampa  dei  caratteri  previsti
        LOOP    XXX01         ;
                              ;/---------------------------------------------\
        CALL    KEYwait       ;|Rimane in attesa della pressione di un tasto |
                              ;\---------------------------------------------/
        MOV     CH,00H        ; Calcola in CX il corretto numero di spostamen-
        MOV   CL,CS:[RigaBass]; ti da eseguire dentro l'ultima Finestra  posta
        SUB   CL,CS:[RigaAlto]; a video
        INC     CX            ;
XXX02:  PUSH    CX            ;
 MOV Byte Ptr CS:[NumRighe],01; La Funzione 06H viene attivata per gestire  lo
        CALL    Scroll        ; scrolling delle rige dentro la Finestra
        POP     CX            ;
        LOOP    XXX02         ;

        MOV     AH,4CH        ; Torna al DOS
        INT     21H           
                              
B10_06__ ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
