PAGE 66,132
TITLE ** B10_0Cgr.ASM - Programma per la gestione dei Pixel nei  MODI  GRAFICI
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_0Cgr.ASM                         (INT 10H, Funzione 0CH)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Verifica la stampa di 64 righe di Pixel in MODO GRAFICO; da-|
;|               ta la diversit dei MODI GRAFICI possibili il  colore  usato|
;|               per il test viene cambiato ogni volta:                      |
;|                                                                           |
;|                    BIANCO   per quelli monocromatici                      |
;|                    ROSA     per quelli a    4 colori                      |
;|                    ROSSO    per quelli a   16 colori                      |
;|                    VIOLETTO per quello a  256 colori.                     |
;|                                                                           |
;|             /------*------------------*-----*-----*-----------*------*---\|
;|             | MODO |   RISOLUZIONE    |ORIZ.|VERT.|   COLORE  |PAGINA|   ||
;|             |      |     GRAFICA      | CX  | DX  | AL        |BH    |   ||
;|             *------*-----*----*-------*-----*-----*-----*-----*---*--*---*|
;|             |AL=04H|40x25|8x8 |320x200|0-319|0-199|0-3  | 4   | 0 |1 |CGA||
;|             |AL=05H|40x25|8x8 |320x200|0-319|0-199|0-3  | 4   | 0 |1 |CGA||
;|             |AL=06H|80x25|8x8 |640x200|0-639|0-199|0-1  |mono | 0 |1 |CGA||
;|             |AL=0DH|40x25|8x8 |320x200|0-319|0-199|0-15 | 16  |0-7|8 |EGA||
;|             |AL=0EH|80x25|8x8 |640x200|0-639|0-199|0-15 | 16  |0-3|4 |EGA||
;|             |AL=0FH|80x25|8x14|640x350|0-639|0-349|0-1  |mono |0-1|2 |EGA||
;|             |AL=10H|80x25|8x14|640x350|0-639|0-349|0-15 | 16  |0-1|2 |EGA||
;|             |AL=11H|80x30|8x16|640x480|0-639|0-479|0-1  |mono |0-1|2 |VGA||
;|             |AL=12H|80x30|8x16|640x480|0-639|0-479|0-15 | 16  |0-1|2 |VGA||
;|             |AL=13H|40x25|8x8 |320x200|0-319|0-199|0-255| 256 | 0 |1 |VGA||
;|             \------*-----*----*-------*-----*-----*-----*-----*---*--*---/|
;|                                                                           |
;|               Con l'occasione vengono collaudate nei MODI GRAFICI le  Pro-|
;|               cedure di Libreria adatte alla gestione di stampa di  carat-|
;|               teri a livello BIOS ("BIOchr1",  usata anche da "Byt2Asc"  e|
;|               "BIOSmsg") e "SET_cur", per la gestione della posizione  del|
;|               Cursore (che, anche se non si vede, pu essere fissato nella|
;|               coordinata carattere desiderata).                           |
;\---------------------------------------------------------------------------/

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN    SET_cur:NEAR
        EXTRN    BIOSmsg:NEAR
        EXTRN    Byt2Asc:NEAR
        EXTRN    BIOchr1:NEAR
        EXTRN    KEYwait:NEAR
        PUBLIC   ATTRIB

;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_0Cgr

;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB  DB   1FH              ;Codice d'attributo colore per "BIOchr1"
Colonn  DW 0000H              ;Numero della Colonna corrente di Pixel
NumPix  DW 0000H              ;Numero di Pixel adatto al MODO GRAFICO corrente
Testo1  DB " Test in MODO ",00H
Testo2  DB "H, Premi un tasto",00H
Testo3  DB "** Fatto ** Premi ancora",00H


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : SETmodo                                                     |
;| DESCRIZIONE : Predispone il MODO GRAFICO desiderato, assumendone il numero|
;|               dal registro AL; data la diversit dei MODI GRAFICI possibi-|
;|               li assume da AH un colore di volta in volta diverso, in modo|
;|               coerente (BIANCO/monocromatico; ROSA/4 colori;  ROSSO/16 co-|
;|               lori e VIOLETTO/256 colori); dopo aver stampati  i  previsti|
;|               [NumPix]*64 Pixel rimane in attesa della pressione di un ta-|
;|               sto qualunque, con un  messaggio  scritto  nella risoluzione|
;|               del MODO corrente, per tornare al programma chiamante.      |
;\---------------------------------------------------------------------------/
SEtmodo:PUSH    AX            ; Fissa il MODO VIDEO GRAFICO desiderato e  pre-
        PUSH    AX            ; dispone il colore ricevuto in ingresso  in  AH
        MOV     CS:[ATTRIB],AH; anche per la stampa dei testi (nella variabile
        MOV     AH,00H        ; [ATTRIB] a beneficio della "BIOchr1")
        INT     10H           ;
        MOV     DH,24         ;
        MOV     DL,02         ; Collauda in ambiente grafico la Procedura del-
  CMP Word Ptr CS:[NumPix],320; la Libreria che opera il puntamento del Curso-
        JZ      XXX00         ; re, fissando una posizione che dipende dal nu-
        ADD     DL,20         ; mero di  colonne  del  MODO  GRAFICO  corrente
XXX00:  CALL    SET_cur       ;
        LEA     SI,Testo1     ;
        CALL    BIOSmsg       ; Mostra il messaggio di presentazione del test
        POP     AX            ; e al tempo stesso collauda le Procedure della
        CALL    Byt2Asc       ; Libreria "GIOBE.LIB" che stampano caratteri e
        LEA     SI,Testo2     ; messaggi a livello BIOS in  ambiente grafico;
        CALL    BIOSmsg       ; Aspetta  poi   la   pressione   di  un  tasto
        CALL    KEYwait       ;
        POP     AX            ;
        MOV     AL,AH         ; Copia il codice colore in AL, adatto  al  MODO
        MOV     BH,00H        ; GRAFICO corrente e inizializza la pagina video
        MOV     DX,0000H      ; Inizializza la prima Riga, DX=0000H
        MOV     CX,64         ; Inizializza il numero di righe da stampare
XXX01:  PUSH    CX            ;
        MOV     CS:[Colonn],00; Inizializza  la prima Colonna , [Colonn]=0000H
        MOV     CX,CS:[NumPix]; Predisposizione  la  stampa  di [NumPix] Pixel
XXX02:  PUSH    CX            ; /--------------------------------------------\
        MOV     CX,CS:[Colonn]; |        Stampa della Riga corrente          |
        MOV     AH,0CH        ; \--------------------------------------------/
        INT     10H           ; Funzione BIOS che scrive  un punto (PIXEL) sul
        INC     CS:[Colonn]   ; video nella corretta  coordinata  grafica data
        POP     CX            ; da DX (riga) e CX (colonna), nella pagina BH e
        LOOP    XXX02         ; con il colore AL
        POP     CX            ;
        INC     DX            ; Continua  la  stampa  sulla  Riga  successiva
        LOOP    XXX01         ;
        MOV     DH,24         ;
        MOV     DL,02         ; Mostra  il  messaggio  di  chiusura  del test
  CMP Word Ptr CS:[NumPix],320; e al tempo stesso collauda le Procedure della
        JZ      XXX03         ; Libreria "GIOBE.LIB" che stampano caratteri e
        ADD     DL,20         ; messaggi a livello  BIOS  anche  in  ambiente
XXX03:  CALL    SET_cur       ; grafico, fissando una posizione  che  dipende
        LEA     SI,Testo3     ; dal numero colonne del  MODO GRAFICO corrente
        CALL    BIOSmsg       ;
        CALL    KEYwait       ;
        RET


;*****************************************************************************
                              ; ----------------------------------------------
B10_0Cgr proc   NEAR          ;       AREA DEDICATA AL MAIN PROGRAM
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        MOV    CS:[NumPix],320; Inizializza Numero Colonna per MODI a 40 colon
        MOV     AL,04H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,02H        ; |MODO 04H|40x25|8x8 |320x200| 4 colori   |CGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,05H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,02H        ; |MODO 05H|40x25|8x8 |320x200| 4 colori   |CGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,0DH        ; /--------*-----*----*-------*------------*---\
        MOV     AH,04H        ; |MODO 0DH|40x25|8x8 |320x200|16 colori   |EGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV    CS:[NumPix],640; Inizializza Numero Colonna per MODI a 80 colon
        MOV     AL,06H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,01H        ; |MODO 06H|80x25|8x8 |640x200|bianco/nero |CGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,0EH        ; /--------*-----*----*-------*------------*---\
        MOV     AH,04H        ; |MODO 0EH|80x25|8x8 |640x200|16 colori   |EGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,0FH        ; /--------*-----*----*-------*------------*---\
        MOV     AH,01H        ; |MODO 0FH|80x25|8x14|640x350|monocrimatic|EGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,10H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,04H        ; |MODO 10H|80x25|8x14|640x350|16 colori   |EGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,11H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,01H        ; |MODO 11H|80x30|8x16|640x480|monocromatic|VGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,12H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,04H        ; |MODO 12H|80x30|8x16|640x480|16 colori   |VGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV    CS:[NumPix],320; Inizializza Numero Colonna per MODI a 40 colon
        MOV     AL,13H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,3AH        ; |MODO 13H|40x25|8x8 |320x200|256 colori  |VGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,03H        ;
        MOV     AH,00H        ; Ripristina in uscita il  MODO  TESTO  standard
        INT     10H           ;
                              
        MOV     AH,4CH        ;Torna al DOS 
        INT     21H           
                              
B10_0Cgr ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
