PAGE 66,132
TITLE ** B10_0Dgr.ASM - Programma per la gestione dei Pixel nei  MODI  GRAFICI
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_0Dgr.ASM                         (INT 10H, Funzione 0DH)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Verifica la Funzione 0DH per la lettura  di  Pixel  in  MODO|
;|               GRAFICO; la prova  condotta nel MODO GRAFICO 13H, 40x25,8x8|
;|               con risoluzione 320x200 a 256 colori.                       |
;|                                                                           |
;|               Con l'occasione vengono collaudate nei MODI GRAFICI le  Pro-|
;|               cedure di Libreria adatte alla gestione di stampa di  carat-|
;|               teri a livello BIOS ("BIOchr1",  usata anche da "Byt2Asc"  e|
;|               "BIOSmsg") e "SET_cur", per la gestione della posizione  del|
;|               Cursore (che, anche se non si vede, pu essere fissato nella|
;|               coordinata carattere desiderata).                           |
;\---------------------------------------------------------------------------/

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN      KEYwait:NEAR
        EXTRN      Byt2Asc:NEAR
        EXTRN      BIOchr1:NEAR
        EXTRN      BIOSmsg:NEAR
        EXTRN      SET_cur:NEAR
        PUBLIC     ATTRIB     ;Attributo di colore

;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_0Dgr

;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB  DB 0EH                ;Attributo di Colore
Colonn  DW 0000H              ;Colonna corrente nella stampa grafica
Testo1  DB "Il Pixel puntato ha colore ",00H
Testo2  DB "Colore ",00H
Testo3  DB "",00H


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : STAmess                                                     |
;| DESCRIZIONE : Provvede alla stampa di alcuni messaggi a corredo  del  test|
;|               e al  tempo stesso  collauda  le  Procedure  della  Libreria|
;|               "GIOBE.LIB" che stampano caratteri e messaggi a livello BIOS|
;|               (e quella di puntamento del Cursore) anche in ambiente  gra-|
;|               fico.                                                       |
;\---------------------------------------------------------------------------/
STAmess:PUSH    AX
        MOV     DH,06         ;
        MOV     DL,08         ;
        CALL    SET_cur       ;
        LEA     SI,Testo3     ;
        CALL    BIOSmsg       ;
        INC     DH            ;
        MOV     DL,01         ;
        CALL    SET_cur       ; Mostra il messaggio con le caratteristiche  di
        LEA     SI,Testo2     ; colore corrente
        CALL    BIOSmsg       ;
        LEA     SI,Testo3     ;
        CALL    BIOSmsg       ;
        INC     DH            ;
        MOV     DL,08         ;
        CALL    SET_cur       ;
        LEA     SI,Testo3     ;
        CALL    BIOSmsg       ;
        MOV     DH,03         ;
        MOV     DL,01         ;
        CALL    SET_cur       ; Mostra il messaggio di presentazione del test
  MOV Byte Ptr CS:[ATTRIB],0FH; anche in questo caso viene manomessa la  Pro-
        LEA     SI,Testo1     ; cedure "BIOchr1" per sostituire il  valore di
        CALL    BIOSmsg       ; BH nel settore di stampa del carattere al fi-
        POP     AX            ; ne di gestire anche lo sfondo (con BH=0FH  si
        CALL    Byt2Asc       ; fissa Sfondo Bianco)
        MOV     AL,"H"        ;
        CALL    BIOchr1       ;
        CALL    KEYwait       ;
        RET





;*****************************************************************************
                              ; ----------------------------------------------
B10_0Dgr proc   NEAR          ;      AREA DEDICATA AL MAIN PROGRAM
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        MOV     AL,13H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,00H        ; |MODO 13H|40x25|8x8 |320x200|256 colori  |VGA|
        INT     10H           ; \--------*-----*----*-------*------------*---/
                              ; ---------------------------------------------\
                              ;     Fase di scrittura  dei Pixel colorati    |
                              ; ---------------------------------------------/
        MOV     CX,247        ; Predisposizione la stampa di 247 Pixel
        MOV     AL,01H        ; Copia il codice colore in AL, adatto  al  MODO
        MOV     DX,0000H      ; GRAFICO corrente, e inizializza la posizone di
        MOV     CS:[Colonn],DX; stampa del primo Pixel
                              ;
XXX00:  PUSH    CX            ;
        MOV     CX,CS:[Colonn]; Predispone sulla prima riga 224 Pixel colorati
        INC     CS:[Colonn];  ; con aiuto della Funzione BIOS 0CH, che  scrive
        MOV     AH,0CH        ; ciascuno di essi nella coordinata grafica data
        INT     10H           ; da DX (riga) e CX (colonna) con il  colore  AL
        POP     CX            ;
        INC     AL            ;
        LOOP    XXX00         ;
                              ; ---------------------------------------------\
        CALL    KEYwait       ; Rimane in attesa della pressione di un tasto |
                              ; ---------------------------------------------/
                              ; ---------------------------------------------\
                              ;       Fase di lettura dei Pixel colorati     |
                              ; ---------------------------------------------/
        MOV     CX,0000H      ;
        MOV     CS:[Colonn],DX; Inizializza la Colonna  di  stampa  del  primo
        MOV     BH,00H        ; Pixel e la Pagina video principale e predispo-
        MOV     CX,247        ; ne la lettura di 247 Pixel
XXX01:  PUSH    CX
        PUSH    DX
        MOV     CX,CS:[Colonn]; Funzione BIOS che assume in  AL  il  codice di
        MOV     DX,0000H      ; colore del punto (PIXEL) posto sul video sulla
        MOV     AH,0DH        ; Riga grafica DX=0000H a partire dalla  Colonna
        INT     10H           ; CX=0000H, nella pagina BH
        MOV     CS:[ATTRIB],AL; Salva il codice di colore in [ATTRIB] per le
        PUSH    AX            ; procedure di stampa dei testi
        MOV     CX,CS:[Colonn]; Scrive un punto BIANCO di riferimento    sulla
        MOV     DX,0002H      ; Riga grafica DX=0002H a partire dalla  Colonna
        MOV     AL,0FH        ; CX=0000H, nella pagina BH, con lo scopo di in-
        MOV     AH,0CH        ; dicare la posizione alla quale si riferisce il
        INT     10H           ; dato esadecimale che verr stampato  tra  poco
        POP     AX
        CALL    STAmess       ; Mostra i messaggi di commento
        INC     CS:[Colonn];  ;
        POP     DX            ; Aggiorna la Colonna del Pixel  sotto  test  e
        POP     CX            ; continua  fino  al  termine  dell'indagine
        LOOP    XXX01         ;
        MOV     AL,03H        ;
        MOV     AH,00H        ; Ripristina in uscita il  MODO  TESTO  standard
        INT     10H           ;
                              
        MOV     AH,4CH        ;Torna al DOS 
        INT     21H           

B10_0Dgr ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
