TITLE ** B10_1000.ASM - Scrive un Registro di Tavolozza
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1000.ASM                         (INT 10H, Funzione 10H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Prova l'INT 10H, Funzione 10H (SottoFunzione 00H) che  asso-|
;|               cia un determinato colore AD UNO DEI 16 REGISTRI DELLA TAVO-|
;|               LOZZA COLORE, indicato in ingresso da BL (nel range 00H0FH)|
;|               associandogli il colore specificato in BH, scelto  tra i  64|
;|               possibili valori.                                           |
;|                                                                           |
;|               L'esempio proposto da  questo  programma  concentra  la  sua|
;|               azione sul codice d'attributo 0FH (BIANCO BRILLANTE su NERO,|
;|               con riferimento alla TAVOLOZZA di DEFAULT (cio al  registro|
;|               0FH del Controller d'Attributo 03C0H);  con  riferimento  ad|
;|               una TABELLA di codici ALTERNATIVI ad esso vengono  associati|
;|               in sequenza tutte le possibilit cromatiche associabili agli|
;|               altri attributi, scelte fatte i colori "smorzati", "normali"|
;|               e "brillanti" (rispettivamente 1/3, 2/3 e 3/3  di  luminosi-|
;|               t); cos per esempio il BIANCO BRILLANTE su NERO potr  di-|
;|               ventare un un rosso con gradazioni:                         |
;|                      "spenta" (1/3) BH = 00 100 000 = nuovo codice: 20H   |
;|                     "normale" (2/3) BH = 00 000 100 = nuovo codice: 04H   |
;|                   "brillante" (3/3) BH = 00 100 100 = nuovo codice: 24H   |
;\---------------------------------------------------------------------------/
        _ESC   EQU   1BH

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CAMBIAcol:NEAR
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   Byt2Asc:NEAR
        EXTRN   BIOchr1:NEAR
        EXTRN   KEYwait:NEAR
        PUBLIC  ATTRIB        ;Attributo di colore


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_1000


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB  DB   00H
DepoKEY DB   00H
Out_0   DB  "  Premere "                                       ,00H
Out_1   DB  "  un tasto "                                      ,00H
Out_2   DB  " per continuare,    oppure [Q]uit per uscire  "   ,00H
Out_3   DB  " per uscire                  "                    ,00H
Text0   DB  "                ANALISI DEL PROBLEMA A LIVELLO BIOS"
Text1   DB                                  "                " ,00H
Corn0   DB  "Ŀ"       ,00H
Corn1   DB  "                                        "       ,00H
Corn3   DB  "Ĵ"       ,00H
Corn2   DB  ""       ,00H

Nero0   DB   " TAVOLOZZA STANDARD - Nero    Normale   "        ,00H
Blu_0   DB   " TAVOLOZZA STANDARD - Blu     Normale   "        ,00H
Verd0   DB   " TAVOLOZZA STANDARD - Verde   Normale   "        ,00H
Azzu0   DB   " TAVOLOZZA STANDARD - Azzurro Normale   "        ,00H
Ross0   DB   " TAVOLOZZA STANDARD - Rosso   Normale   "        ,00H
Mage0   DB   " TAVOLOZZA STANDARD - Magenta Normale   "        ,00H
Gial0   DB   " TAVOLOZZA STANDARD - Marrone Normale   "        ,00H
Bian0   DB   " TAVOLOZZA STANDARD - Bianco  Normale   "        ,00H

Grig1   DB   " TAVOLOZZA STANDARD - Grigio            "        ,00H
Bele1   DB   " TAVOLOZZA STANDARD - Blu     Elettrico "        ,00H
Vchi1   DB   " TAVOLOZZA STANDARD - Verde    Chiaro   "        ,00H
Cele1   DB   " TAVOLOZZA STANDARD - Azzurro  Chiaro   "        ,00H
Rosa1   DB   " TAVOLOZZA STANDARD - Rosa              "        ,00H
Mchi1   DB   " TAVOLOZZA STANDARD - Magenta  Chiaro   "        ,00H
Gchi1   DB   " TAVOLOZZA STANDARD - Giallo            "        ,00H
Bbri1   DB   " TAVOLOZZA STANDARD -  Bianco Brillante "        ,00H
Altro   DB   " TAVOLOZZA ALTERNATIVA Bianco Brillante "        ,00H

TabCol1 DB   "* Bianco  Brillante * ",00H
        DB   "* Bianco  Normale   * ",00H
        DB   "* Bianco  Spento    * ",00H
        DB   "* Marrone Brillante * ",00H
        DB   "* Marrone Normale   * ",00H
        DB   "* Marrone Spento    * ",00H
        DB   "* Magenta Brillante * ",00H
        DB   "* Magenta Normale   * ",00H
        DB   "* Magenta Spento    * ",00H
        DB   "* Rosso   Brillante * ",00H
        DB   "* Rosso   Normale   * ",00H
        DB   "* Rosso   Spento    * ",00H
        DB   "* Azzurro Brillante * ",00H
        DB   "* Azzurro Normale   * ",00H
        DB   "* Azzurro Spento    * ",00H
        DB   "* Verde   Brillante * ",00H
        DB   "* Verde   Normale   * ",00H
        DB   "* Verde   Spento    * ",00H
        DB   "* Blu     Brillante * ",00H
        DB   "* Blu     Normale   * ",00H
        DB   "* Blu     Spento    * ",00H
        DB   "* Nero    Brillante * ",00H
        DB   "* Nero    Normale   * ",00H
        DB   "* Nero    Spento    * ",00H

                    ;/-----------------*----------------\/----------------\
TabCol  DB   3FH    ;|Bianco  Brillante| 3FH=00 111 111 ||****************|
        DB   07H    ;|Bianco  Normale  | 07H=00 000 111 ||****************|
        DB   38H    ;|Bianco  Spento   | 38H=00 111 000 ||****************|
                    ;*-----------------*----------------*|****************|
        DB   36H    ;|Giallo           | 36H=00 110 110 ||****************|
        DB   06H    ;|Marrone Normale  | 06H=00 000 110 ||****************|
        DB   30H    ;|Marrone Spento   | 30H=00 110 000 ||****************|
                    ;*-----------------*----------------*|****************|
        DB   2BH    ;|Magenta Brillante| 2BH=00 101 101 ||****************|
        DB   05H    ;|Magenta Normale  | 05H=00 000 101 ||****************|
        DB   28H    ;|Magenta Spento   | 28H=00 101 000 ||****************|
                    ;*-----------------*----------------*|****************|
        DB   24H    ;|Rosso   Brillante| 24H=00 100 100 ||****************|
        DB   04H    ;|Rosso   Normale  | 04H=00 000 100 ||****************|
        DB   20H    ;|Rosso   Spento   | 20H=00 100 000 ||****************|
                    ;*-----------------*----------------*|****************|
        DB   1BH    ;|Azzurro Brillante| 1BH=00 011 011 ||****************|
        DB   03H    ;|Azzurro Normale  | 03H=00 000 011 ||****************|
        DB   18H    ;|Azzurro Spento   | 18H=00 011 000 ||****************|
                    ;*-----------------*----------------*|****************|
        DB   12H    ;|Verde   Brillante| 12H=00 010 010 ||****************|
        DB   02H    ;|Verde   Normale  | 02H=00 000 010 ||****************|
        DB   10H    ;|Verde   Spento   | 10H=00 010 000 ||****************|
                    ;*-----------------*----------------*|****************|
        DB   09H    ;|Blu     Brillante| 09H=00 001 001 ||****************|
        DB   01H    ;|Blu     Normale  | 01H=00 000 001 ||****************|
        DB   08H    ;|Blu     Spento   | 08H=00 001 000 ||****************|
                    ;*-----------------*----------------*|****************|
        DB   00H    ;|Nero    Brillante| 00H=00 000 000 ||****************|
        DB   00H    ;|Nero    Normale  | 00H=00 000 000 ||****************|
        DB   00H    ;|Nero    Spento   | 00H=00 000 000 ||****************|
                    ;\-----------------*----------------/\----------------/
      ;/--------------\;/-----------------*----------------*-----------------\
      ;|DB      3FH   |;|Bianco  Brillante| 3FH=00 111 111 |*****************|
      ;|              |;*-----------------*----------------/**** Default ****|
      ;|              |;|Per garantire la portabilit verso il basso,cio per|
      ;|              |;|assicurare la simulazione CGA  da  parte della  VGA,|
      ;|              |;|il registro di tavolozza n0FH per l'attributo BIAN-|
      ;|              |;|CO BRILLANTE dovr essere riportato a questo  valore|
      ;|              |;|di default, di norma presente appunto in CGA.       |
      ;\--------------/;\----------------------------------------------------/


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;|PROCEDURA  : DeskTop                                                       |
;|DESCRIZIONE: Predispone la cornice esterna  alle  stringhe  utilizzate  dal|
;|             test e i messaggi con attributo di colore crescente           |
;\---------------------------------------------------------------------------/
DeskTop:CALL    VIA_cur
        MOV     CH,00         ;
        MOV     CL,00         ;
        MOV     DH,24         ; Produce un ClearScreen con aiuto della Funzio-
        MOV     DL,79         ; ne 06H dell'INT 10H BIOS (NB:CH=RigaAlto,  CL=
        MOV     BH,0FH        ; =ColnAlto, DH=RigaBass, DL=ColnBass, BH=Colore
        MOV     AL,00         ; e AL=0 (scorrere TUTTE le righe dello schermo)
        MOV     AH,06H        ;
        INT     10H           ;
        M_msgC Corn0,03,12,0EH;
        MOV     CX,15         ;
base_:  MOV     BH,19         ;
        SUB     BH,CL         ;
        M_msgC Corn1,BH,12,0EH; Predispone la cornice esterna
        LOOP    base_         ;
        M_msgC Corn3,19,12,0EH;
        M_msgC Corn1,20,12,0EH;
        M_msgC Corn1,21,12,0EH;
        M_msgC Corn2,22,12,0EH;
        M_msgC Nero0,04,13,00H;
        M_msgC Blu_0,05,13,01H;
        M_msgC Verd0,06,13,02H;
        M_msgC Azzu0,07,13,03H;
        M_msgC Ross0,08,13,04H;
        M_msgC Mage0,09,13,05H;
        M_msgC Gial0,10,13,06H; Stringhe con codici di  colore STANDARD
        M_msgC Bian0,11,13,07H; (esclusa quella associata all'attributo
        M_msgC Grig1,12,13,08H; 0FH sotto test)
        M_msgC Bele1,13,13,09H;
        M_msgC Vchi1,14,13,0AH;
        M_msgC Cele1,15,13,0BH;
        M_msgC Rosa1,16,13,0CH;
        M_msgC Mchi1,17,13,0DH;
        M_msgC Gchi1,18,13,0EH;
        RET

;/---------------------------------------------------------------------------\
;| PROCEDURA   : codici                                                      |
;| DESCRIZIONE : Stampa una interpretazione esadecimale e binaria, nella for-|
;|               ma xx rgb RGB del codice colore della TAVOLOZZA ALTERNATIVA |
;|               ed aggiunge il suo valore esadecimale e un messaggio in gra-|
;|               do di tradurre alfabeticamente tale codice                  |
;\---------------------------------------------------------------------------/
codici: PUSH    AX            ;
        PUSH    CX            ;
        PUSH    DX            ;
        PUSH    BX            ;
        LEA     SI,TabCol1    ;
        MOV     AX,23         ; Stampa il messaggio con il nome  del  colore
        MUL     BL            ; effettivamente scelto per l'attributo BIANCO
        ADD     SI,AX         ; BRILLANTE
        M_CURSOR 21,14        ;
        CALL    BIOSmsg       ;
        POP     BX            ;
        PUSH    BX            ;
        MOV     BL,BH         ;
        PUSH    BX            ;
        MOV     CX,8          ;
AAA0:   ROL     BL,1          ;
        PUSHF                 ;
        CMP     CL,6          ;
        JNZ     AAA1          ;
        MOV     AL," "        ;
        CALL    BIOchr1       ;
        JMP    SHORT AAA2     ;
AAA1:   CMP     CL,3          ;
        JNZ     AAA2          ;
        MOV     AL," "        ; Stampa l'interpretazione "xxrgbRGB" del codice
        CALL    BIOchr1       ; colore collocato nel 16 refgistro di attribu-
AAA2:   POPF                  ; to di colore del Controller d'Attributo(03C0H)
        MOV     AL,"0"        ;
        JNC     AAA3          ;
        MOV     AL,"1"        ;
AAA3:   CALL    BIOchr1       ;
        LOOP    AAA0          ;
        MOV     AL," "        ;
        CALL    BIOchr1       ;
        MOV     AL," "        ;
        CALL    BIOchr1       ;
        POP     BX            ;
        MOV     AL,BH         ;
        CALL    Byt2Asc       ;
        CALL    KEYwait       ;
        MOV    CS:[DepoKEY],AL;
        POP     BX            ;
        POP     DX            ; Controlla la tastiera ed esce
        POP     CX            ;
        POP     AX            ;
        RET                   ;


;*****************************************************************************
                              ; ----------------------------------------------
B10_1000 proc   NEAR          ;       AREA DEDICATA AL MAIN PROGRAM
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        CALL    DeskTop       ; /--------------------------------------------\
        M_msgC  Text0 ,1,1,1FH; |    Inizializza la pagina Video del test    |
        M_msgC  Out_0,24,1,1FH; |                    e                       |
        M_COLOR 9FH           ; |                                            |
        M_msgN Out_1          ; |    propone il Testo di presentazione       |
        M_COLOR 1FH           ; |                                            |
        M_msgN Out_2          ; \--------------------------------------------/
        MOV     BL,00         ; /--------------------------------------------\
        LEA     DI,TabCol     ; |                                            |
        MOV     BH,CS:[DI]    ; |                                            |
        PUSH    BX            ; |Predispone le condizioni DEFAULT per il "Re-|
        MOV     BL,0FH        ; |gistro di TAVOLOZZA"  n0FH  del "Controller|
        MOV     AL,00H        ; |d'Attributo", associato  a  BIANCO BRILLANTE|
        MOV     AH,10H        ; |                                            |
        INT     10H           ; |                                            |
        POP     BX            ; \--------------------------------------------/
                              ; Predispone la stampa di tutte le stringhe  co-
                              ; lorate con la TAVOLOZZA STANDARD  di  default,
        M_msgC Bbri1,20,13,0FH; compresa quella associata al registro 0FH  del
        CALL    codici        ; Controlle d'Attributo, dedicata  all'attributo
                              ; BIANCO BRILLANTE
        MOV    AL,CS:[DepoKEY];
        CMP     AL,_ESC       ;
        JZ      XXX01         ; Consente l'uscita dal  test  prima  della  sua
        AND     AL,11011111B  ; conclusione  per   pressione  del   tasto  "Q"
        CMP     AL,'Q'        ;
        JZ      XXX01         ;
                              ; ---------------------------------------------\
                              ; Ridefinizione   del   "Registro di TAVOLOZZA"|
                              ; n0FH del "Controller d'Attributo", associato|
                              ; di norma al colore BIANCO BRILLANTE          |
                              ; ---------------------------------------------/
        MOV     CX,24         ; Inizializza il numero di coloi da provare
        MOV     BL,00         ;
XXX00:  PUSH    CX            ; Organizza un puntatore dinamico  ai  contenuti
        LEA     DI,TabCol     ; della tabella di codici colore ALTERNATIVI  da
        MOV     BH,00H        ; usare al posto di quello STANDARD per l'attri-
        ADD     DI,BX         ; buto il BIANCO BRILLANTE, e lo prepara  in  BH
        MOV     BH,CS:[DI]    ; a beneficio della funzione BIOS specifica
        PUSH    BX            ;
        MOV     AL,00H        ; Con AL=0 associa al 16 registro  di tavolozza
        MOV     BL,0FH        ; il colore appena assunto dalla tabella TabCol,
        MOV     AH,10H        ; (BH=CS:[DI]) inteso come colore  da  associare
        INT     10H           ; all'attributo BIANCO BRILLANTE
        POP     BX            ;
                              ; Emissione della stringa con  attributo  BIANCO
        M_msgC Altro,20,13,0FH; BRILLANTE con colore in  accordo con il valore
        CALL    codici        ; estratto dalla tabella "TabCol" ( TAVOLOZZA
                              ; ALTERNATIVA)
        POP     CX            ;
        MOV    AL,CS:[DepoKEY];
        CMP     AL,_ESC       ;
        JZ      XXX01         ; Consente l'uscita dal  test  prima  della  sua
        AND     AL,11011111B  ; conclusione  per   pressione  del   tasto  "Q"
        CMP     AL,'Q'        ;
        JZ      XXX01         ;
        INC     BL            ; Prosegue con il test fino alla fine
        LOOP    XXX00         ;
                              ;/---------------------------------------------\
                              ;|Ripristina le condizioni di Default          |
                              ;\---------------------------------------------/
XXX01:  MOV     BH,3FH        ;
        MOV     BL,0FH        ; Con AL=0  associa  il colore STANDARD (BH=3FH)
        PUSH    BX            ; previsto per il 16 registro di tavolozza  co-
        MOV     AX,1000H      ; lore (BL=0FH) per il BIANCO BRILLANTE
        INT     10H           ;
        POP     BX            ;
        M_msgC Text1,24,1,1FH ;/---------------------------------------------\
        M_msgN  Out_0         ;|                                             |
        M_COLOR 9FH           ;|     Propone il Testo di uscita              |
        M_msgN Out_1          ;|                                             |
        M_COLOR 1FH           ;|                                             |
        M_msgN Out_3          ;\---------------------------------------------/
                              ; Predispone la stampa di tutte le stringhe  co-
        MOV     BL,00H        ; lorate con la TAVOLOZZA STANDARD  di  default,
        M_msgC Bbri1,20,13,0FH; compresa quella associata al registro 0FH  del
        CALL    codici        ; Controlle d'Attributo, dedicata  all'attributo
                              ; BIANCO BRILLANTE
        M_msgC Text1,24,1,0FH ;
        MOV     CX,04         ;
XXX02:  M_msgN  Text1         ;
        LOOP    XXX02

        PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;

B10_1000 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
