PAGE 66,132
TITLE ** B10_1012.ASM - Scrive tutti i Registri di Colore del DAC
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1012.ASM                         (INT 10H, Funzione 10H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Prova l'INT 10H con parametro 12H che associa un determinato|
;|               colore ad un gruppo di REGISTRI di Colore del DAC del Video.|
;|                                                                           |
;|               Il programma si occupa di cambiare i Registri di Colore  del|
;|               DAC con terne di codici corrispondenti a diverse  situazioni|
;|               cromatiche;  il primo quadro forza le  terne  corrispondenti|
;|               alle gradazioni CGA standard, ribadendo quelli di default ma|
;|               con Giallo al posto di Marrone; il secondo quadro  inserisce|
;|               nei Registri le terne, appositamente  calcolate  per  questo|
;|               programma, corrispondenti ai toni  di Grigio  che  sarebbero|
;|               presenti se si richiedesse l'intervento della  SottoFunzione|
;|               33H della Funzione 12H di INT 10H ("Abilita il calcolo della|
;|               Scala dei Grigi"); seguono poi sette quadri con sedici delle|
;|               possibili 64 gradazioni  per  ogni  colore  fondamentale; la|
;|               prova coinvolge i Registri di Colore del DAC da 00H a 07H (i|
;|               primi otto) e da 38H a 3FH che, in uscita, vengono ricarica-|
;|               ti con i valori originali per tornare a garantire la  porta-|
;|               bilit verso il basso, cio per  assicurare  la  simulazione|
;|               CGA da parte della VGA.                                     |
;|                                                                           |
;|               La stampa di testi con questi attributi dar risultati  sor-|
;|               prendenti.                                                  |
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CAMBIAcol:NEAR
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   Byt2Asc:NEAR
        EXTRN   KEYwait:NEAR
        PUBLIC  ATTRIB        ;Attributo di colore


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_1012


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB  DB   00H
Out_0   DB  "                 Premere  "                              ,00H
Out_1   DB  "un tasto"                                                ,00H
Out_2   DB  "  per continuare                 "                       ,00H
Text0   DB  "                ANALISI DEL PROBLEMA A LIVELLO BIOS"
Text1   DB                                  "                "        ,00H
Text2   DB  "Controllo Registri DAC 00H07H/38H3FH con colori "      ,00H
Text3   DB                                               "STANDARD"   ,00H
Text4   DB                                               "GRIGI   "   ,00H
Text5   DB                                               "VERDI   "   ,00H
Text6   DB                                               "ROSSI   "   ,00H
Text7   DB                                               "BLU     "   ,00H
Text8   DB                                               "MAGENTA "   ,00H
Text9   DB                                               "GIALLI  "   ,00H
TextA   DB                                               "AZZURRI "   ,00H
TextB   DB                                               "BIANCHI "   ,00H
Testo0  DB   " PROVA con Attributo   H "                              ,00H
;       DB                              " PROVA con Attributo   H "   ,00H
Corn0   DB  "ĿĿ"  ,00H
Corn1   DB  "                                                  "  ,00H
Corn2   DB  ""  ,00H
                    ;/-------------------------------------------------------\
                    ;| Calcolo Grigio  =  30% Rosso + 59% Verde + 11% Blu    |
                    ;*-------*-------------------------*---------------*-----*
Grigi DB 00H,00H,00H;|Nero   |0.3*00H+0.59*00H+0.11*00H|  0 +  0  +  0 | 0.00|
      DB 05H,05H,05H;|Blu    |0.3*00H+0.59*00H+0.11*2AH|  0 +  0  +4.62| 4.62|
      DB 19H,19H,19H;|Verde  |0.3*00H+0.59*2AH+0.11*00H|  0 +24.78+  0 |24.78|
      DB 1DH,1DH,1DH;|Azzurro|0.3*00H+0.59*2AH+0.11*2AH|  0 +24.78+4.62|29.40|
      DB 0DH,0DH,0DH;|Rosso  |0.3*2AH+0.59*00H+0.11*00H|12.6+  0  +  0 |12.60|
      DB 11H,11H,11H;|Magenta|0.3*2AH+0.59*00H+0.11*2AH|12.6+  0  +4.62|17.22|
      DB 25H,25H,25H;|Marrone|0.3*2AH+0.59*2AH+0.11*00H|12.6+24.78+  0 |37.38|
      DB 2AH,2AH,2AH;|Bianco |0.3*2AH+0.59*2AH+0.11*2AH|12.6+24.78+4.62|42.00|
                    ;*-------*-------------------------*---------------*-----*
      DB 02H,02H,02H;|Grigio |0.3*00H+0.59*00H+0.11*15H|  0 +  0  +2.31| 2.31|
      DB 07H,07H,07H;|Blu El.|0.3*00H+0.59*00H+0.11*3FH|  0 +  0  +6.93| 6.93|
      DB 1BH,1BH,1BH;|Verde  |0.3*00H+0.59*2AH+0.11*15H|  0 +24.78+2.31|27.09|
      DB 20H,20H,20H;|Celeste|0.3*00H+0.59*2AH+0.11*3FH|  0 +24.78+6.93|31.71|
      DB 0FH,0FH,0FH;|Rosa   |0.3*2AH+0.59*00H+0.11*15H|12.6+  0  +2.31|14.91|
      DB 14H,14H,14H;|Magenta|0.3*2AH+0.59*00H+0.11*3FH|12.6+  0  +6.93|19.53|
      DB 28H,28H,28H;|Giallo |0.3*2AH+0.59*2AH+0.11*15H|12.6+24.78+2.31|39.69|
      DB 2CH,2CH,2CH;|Bianco |0.3*2AH+0.59*2AH+0.11*3FH|12.6+24.78+6.93|44.31|
                    ;\-------*-------------------------*---------------*-----/
        ;--------R---V---B----------------------------------------------------
Blu     DB      00H,00H,00H   ;/---------------------------------------------\
        DB      00H,00H,04H   ;|                                             |
        DB      00H,00H,08H   ;|                                             |
        DB      00H,00H,0CH   ;|                                             |
        DB      00H,00H,10H   ;|                                             |
        DB      00H,00H,14H   ;|Predispone per lo Sfondo  dei  caratteri  ad |
        DB      00H,00H,18H   ;|alta luminosit  (e per il  Primo  Piano  di |
        DB      00H,00H,1CH   ;|quelli su sfondo NERO) sette gradazioni cre- |
        ;--------R---V---B----;|scenti di  BLU  (lo sfondo  NERO  si  lascia |
        DB      00H,00H,20H   ;|inalterato, per evitare di coinvolgere nella |
        DB      00H,00H,24H   ;|modifica il piano di presentazione del test) |
        DB      00H,00H,28H   ;|                                             |
        DB      00H,00H,2CH   ;|                                             |
        DB      00H,00H,30H   ;|                                             |
        DB      00H,00H,34H   ;|                                             |
        DB      00H,00H,38H   ;|                                             |
        DB      00H,00H,3CH   ;\---------------------------------------------/
        ;--------R---V---B----------------------------------------------------
Verdi   DB      00H,00H,00H   ;/---------------------------------------------\
        DB      00H,04H,00H   ;|                                             |
        DB      00H,08H,00H   ;|                                             |
        DB      00H,0CH,00H   ;|                                             |
        DB      00H,10H,00H   ;|                                             |
        DB      00H,14H,00H   ;|Predispone per lo Sfondo  dei  caratteri  ad |
        DB      00H,18H,00H   ;|alta luminosit  (e per il  Primo  Piano  di |
        DB      00H,1CH,00H   ;|quelli su sfondo NERO) sette gradazioni cre- |
        ;--------R---V---B-----|scenti di VERDE (lo sfondo  NERO  si  lascia |
        DB      00H,20H,00H   ;|inalterato, per evitare di coinvolgere nella |
        DB      00H,24H,00H   ;|modifica il piano di presentazione del test) |
        DB      00H,28H,00H   ;|                                             |
        DB      00H,2CH,00H   ;|                                             |
        DB      00H,30H,00H   ;|                                             |
        DB      00H,34H,00H   ;|                                             |
        DB      00H,38H,00H   ;|                                             |
        DB      00H,3CH,00H   ;\---------------------------------------------/
        ;--------R---V---B----------------------------------------------------
Azzur   DB      00H,00H,00H   ;/---------------------------------------------\
        DB      00H,04H,04H   ;|                                             |
        DB      00H,08H,08H   ;|                                             |
        DB      00H,0CH,0CH   ;|                                             |
        DB      00H,10H,10H   ;|                                             |
        DB      00H,14H,14H   ;|Predispone per lo Sfondo  dei  caratteri  ad |
        DB      00H,18H,18H   ;|alta luminosit  (e per il  Primo  Piano  di |
        DB      00H,1CH,1CH   ;|quelli su sfondo NERO) sette gradazioni cre- |
        ;--------R---V---B-----|scenti di AZZURRO (lo sfondo NERO si  lascia |
        DB      00H,20H,20H   ;|inalterato, per evitare di coinvolgere nella |
        DB      00H,24H,24H   ;|modifica il piano di presentazione del test) |
        DB      00H,28H,28H   ;|                                             |
        DB      00H,2CH,2CH   ;|                                             |
        DB      00H,30H,30H   ;|                                             |
        DB      00H,34H,34H   ;|                                             |
        DB      00H,38H,38H   ;|                                             |
        DB      00H,3CH,3CH   ;\---------------------------------------------/
        ;--------R---V---B----------------------------------------------------
Rossi   DB      00H,00H,00H   ;/---------------------------------------------\
        DB      04H,00H,00H   ;|                                             |
        DB      08H,00H,00H   ;|                                             |
        DB      0CH,00H,00H   ;|                                             |
        DB      10H,00H,00H   ;|                                             |
        DB      14H,00H,00H   ;|Predispone per lo Sfondo  dei  caratteri  ad |
        DB      18H,00H,00H   ;|alta luminosit  (e per il  Primo  Piano  di |
        DB      1CH,00H,00H   ;|quelli su sfondo NERO) sette gradazioni cre- |
        ;--------R---V---B-----|scenti di ROSSO (lo sfondo  NERO  si  lascia |
        DB      20H,00H,00H   ;|inalterato, per evitare di coinvolgere nella |
        DB      24H,00H,00H   ;|modifica il piano di presentazione del test) |
        DB      28H,00H,00H   ;|                                             |
        DB      2CH,00H,00H   ;|                                             |
        DB      30H,00H,00H   ;|                                             |
        DB      34H,00H,00H   ;|                                             |
        DB      38H,00H,00H   ;|                                             |
        DB      3CH,00H,00H   ;\---------------------------------------------/
        ;--------R---V---B----------------------------------------------------
Magen   DB      00H,00H,00H   ;/---------------------------------------------\
        DB      04H,00H,04H   ;|                                             |
        DB      08H,00H,08H   ;|                                             |
        DB      0CH,00H,0CH   ;|                                             |
        DB      10H,00H,10H   ;|                                             |
        DB      14H,00H,14H   ;|Predispone per lo Sfondo  dei  caratteri  ad |
        DB      18H,00H,18H   ;|alta luminosit  (e per il  Primo  Piano  di |
        DB      1CH,00H,1CH   ;|quelli su sfondo NERO) sette gradazioni cre- |
        ;--------R---V---B-----|scenti di MAGENTA (lo sfondo  NERO si lascia |
        DB      20H,00H,20H   ;|inalterato, per evitare di coinvolgere nella |
        DB      24H,00H,24H   ;|modifica il piano di presentazione del test) |
        DB      28H,00H,28H   ;|                                             |
        DB      2CH,00H,2CH   ;|                                             |
        DB      30H,00H,30H   ;|                                             |
        DB      34H,00H,34H   ;|                                             |
        DB      38H,00H,38H   ;|                                             |
        DB      3CH,00H,3CH   ;\---------------------------------------------/
        ;--------R---V---B----------------------------------------------------
Giall   DB      00H,00H,00H   ;/---------------------------------------------\
        DB      04H,04H,00H   ;|                                             |
        DB      08H,08H,00H   ;|                                             |
        DB      0CH,0CH,00H   ;|                                             |
        DB      10H,10H,00H   ;|                                             |
        DB      14H,14H,00H   ;|Predispone per lo Sfondo  dei  caratteri  ad |
        DB      18H,18H,00H   ;|alta luminosit  (e per il  Primo  Piano  di |
        DB      1CH,1CH,00H   ;|quelli su sfondo NERO) sette gradazioni cre- |
        ;--------R---V---B-----|scenti di GIALLO (lo sfondo  NERO  si lascia |
        DB      20H,20H,00H   ;|inalterato, per evitare di coinvolgere nella |
        DB      24H,24H,08H   ;|modifica il piano di presentazione del test) |
        DB      28H,28H,00H   ;|                                             |
        DB      2CH,2CH,00H   ;|                                             |
        DB      30H,30H,00H   ;|                                             |
        DB      34H,34H,00H   ;|                                             |
        DB      38H,38H,00H   ;|                                             |
        DB      3CH,3CH,00H   ;\---------------------------------------------/
        ;--------R---V---B----------------------------------------------------
Bianc   DB      00H,00H,00H   ;/---------------------------------------------\
        DB      04H,04H,04H   ;|                                             |
        DB      08H,08H,08H   ;|                                             |
        DB      0CH,0CH,0CH   ;|                                             |
        DB      10H,10H,10H   ;|                                             |
        DB      14H,14H,14H   ;|Predispone per lo Sfondo  dei  caratteri  ad |
        DB      18H,18H,18H   ;|alta luminosit  (e per il  Primo  Piano  di |
        DB      1CH,1CH,1CH   ;|quelli su sfondo NERO) sette gradazioni cre- |
        ;--------R---V---B-----|scenti di BIANCO (lo sfondo NERO  si  lascia |
        DB      20H,20H,20H   ;|inalterato, per evitare di coinvolgere nella |
        DB      24H,24H,24H   ;|modifica il piano di presentazione del test) |
        DB      28H,28H,28H   ;|                                             |
        DB      2CH,2CH,2CH   ;|                                             |
        DB      30H,30H,30H   ;|                                             |
        DB      34H,34H,34H   ;|                                             |
        DB      38H,38H,38H   ;|                                             |
        DB      3CH,3CH,3CH   ;\---------------------------------------------/

                              ;/------------------------\  /-----*-----*-----\
                              ;|   Default Colore DAC   |  |Rosso|Verde| Blu |
        ;--------R---V---B----;*------------------------*  *-----*-----*-----*
ColNorm DB      00H,00H,00H   ;|    Nero    Normale     |  | 00H | 00H | 00H |
        DB      00H,00H,2AH   ;|    Blu     Normale     |  | 00H | 00H | 2AH |
        DB      00H,2AH,00H   ;|    Verde   Normale     |  | 00H | 2AH | 00H |
        DB      00H,2AH,2AH   ;|    Azzurro Normale     |  | 00H | 2AH | 2AH |
        DB      2AH,00H,00H   ;|    Rosso   Normale     |  | 2AH | 00H | 00H |
        DB      2AH,00H,2AH   ;|    Magenta Normale     |  | 2AH | 00H | 2AH |
        DB      2AH,2AH,00H   ;|    Giallo  Normale     |  | 2AH | 2AH | 00H |
        DB      2AH,2AH,2AH   ;|    Bianco  Normale     |  | 2AH | 2AH | 2AH |
                              ;*------------------------*  *-----*-----*-----*
        DB      15H,15H,15H   ;|    Grigio              |  | 00H | 00H | 00H |
        DB      15H,15H,3FH   ;|    Blu     Elettrico   |  | 00H | 00H | 2AH |
        DB      15H,3FH,15H   ;|    Verde   Chiaro      |  | 00H | 2AH | 00H |
        DB      15H,3FH,3FH   ;|    Celeste             |  | 00H | 2AH | 2AH |
        DB      3FH,15H,15H   ;|    Rosa                |  | 2AH | 00H | 00H |
        DB      3FH,15H,3FH   ;|    Magenta Chiaro      |  | 2AH | 00H | 2AH |
        DB      3FH,3FH,15H   ;|    Giallo  Brillante   |  | 2AH | 2AH | 00H |
        DB      3FH,3FH,3FH   ;|    Bianco  Brillante   |  | 2AH | 2AH | 2AH |
                              ;\------------------------/  \-----*-----*-----/

Dati    DB       0FH,00H      ;\/--------------------------------------------\
        DB       1FH,01H      ;||                                            |
        DB       2FH,02H      ;||                                            |
        DB       3FH,03H      ;||                                            |
        DB       4FH,04H      ;||                                            |
        DB       5FH,05H      ;|| Colori  effettivamente  utilizzati  nella  |
        DB       6FH,06H      ;|| stampa  dei  testi (l'effetto   comunque  |
        DB       7FH,07H      ;|| determinato dal registro DAC in esercizio  |
        DB       8FH,08H      ;|| nel momento della stampa)                  |
        DB       9FH,09H      ;||                                            |
        DB      0AFH,0AH      ;||                                            |
        DB      0BFH,0BH      ;||                                            |
        DB      0CFH,0CH      ;||                                            |
        DB      0DFH,0DH      ;||                                            |
        DB      0EFH,0EH      ;||                                            |
        DB      0FFH,0FH      ;/\--------------------------------------------/


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : STAdat                                                      |
;| DESCRIZIONE : Organizza la stampa di una riga di informazioni,  con il te-|
;|               sto indicato in ingresso da SI, con il colore puntato  da DI|
;|               e nella posizione di stampa fissata da DH=riga, DL=colonna) |
;\---------------------------------------------------------------------------/
STAdat: MOV     BL,16         ; Punta il colore desiderato (in sostanza  crea
        SUB     BL,CL         ; in BX lo spiazzamento a  partire  dalla  base
        ADD     BL,BL         ; della Tabella Dati puntata in ingresso da DI
        MOV     AL,CS:[DI+BX] ;
        M_COLOR AL            ;
        PUSH    AX            ;
        INC     DH            ;
        CALL    SET_cur       ;
        LEA     SI,Testo0     ; Prende il colore in [ATTRIB], fissa  la  posi-
        CALL    BIOSmsg       ; zione e stampa la frase, aggiungendo il codice
        POP     AX            ; esadecimale dell'Attributo di colore  corrente
        PUSH    DX            ;
        ADD     DL,21         ;
        CALL    SET_cur       ;
        CALL    Byt2Asc       ;
        POP     DX            ;
        RET                   ;

;/---------------------------------------------------------------------------\
;| PROCEDURA   : Prova                                                       |
;| DESCRIZIONE : Predispone OTTO Registri di Colore del DAC in accordo con le|
;|               terne suggerite nella tabella indirizzata in ingresso da DX.|
;\---------------------------------------------------------------------------/
Prova:  PUSH    SI
        PUSH    ES
        MOV     AX,CS
        MOV     ES,AX

        MOV     CX,8          ; La Funzione BIOS aggiorna il contenuto di CX=8
        MOV     BX,0          ; Registri di Colore del DAC del Video a partire
        MOV     AL,12H        ; da quello indicato da BX=00H;  i  valori  sono
        MOV     AH,10H        ; prelevati dalle terne  Rosso-Verde-Blu  predi-
        INT     10H           ; sposte nella Tabella puntata da ES:DX

        ADD     DX,8*3

        MOV     CX,8          ; La Funzione BIOS aggiorna il contenuto di CX=8
        MOV     BX,38H        ; Registri di Colore del DAC del Video a partire
        MOV     AL,12H        ; da quello indicato da BX=38H;  i  valori  sono
        MOV     AH,10H        ; prelevati dalle terne  Rosso-Verde-Blu  predi-
        INT     10H           ; sposte nella Tabella puntata da ES:DX

        POP     ES
        M_msgC  Text2,22,4,0EH; /--------------------------------------------\
        POP     SI            ; |Stampa il messaggio adeguato, personalizzato|
        CALL   BIOSmsg        ; |Testi con i Registri di Colore DAC coinvolti|
        CALL   KEYwait        ; |nella prova                                 |
        RET                   ; \--------------------------------------------/


;*****************************************************************************
                              ; ----------------------------------------------
B10_1012 proc   NEAR          ;       AREA DEDICATA AL MAIN PROGRAM
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        MOV     CH,00         ; /--------------------------------------------\
        MOV     CL,00         ; |                                            |
        MOV     DH,24         ; |Produce un ClearScreen con aiuto della  Fun-|
        MOV     DL,79         ; |zione 06H dell'INT 10H BIOS (NB:CH=RigaAlto,|
        MOV     BH,0FH        ; |CL=ColnAlto,  DH=RigaBass,  DL=ColnBass, BH=|
        MOV     AL,00         ; |BH=Colore e AL=0 (scorrere  TUTTE  le  righe|
        MOV     AH,06H        ; |dello schermo)                              |
        INT     10H           ; |                                            |
        CALL    VIA_cur       ; *--------------------------------------------*
        M_msgC  Text0 ,1,1,1FH; |                                            |
        M_msgC  Out_0,24,1,1FH; |    Inizializza la pagina Video del test    |
        M_COLOR 9FH           ; |                    e                       |
        M_msgN Out_1          ; |    propone il Testo di presentazione       |
        M_COLOR 1FH           ; |                                            |
        M_msgN Out_2          ; |                                            |
        M_msgC  Text2,22,4,0EH; |                                            |
        M_msgN  Text3         ; \--------------------------------------------/
        MOV     DH,02         ; /--------------------------------------------\
        PUSH    DX            ; |   Emissione di stringhe con attributo  di  |
        M_msgC Corn0,DH,07,0EH; |  colore riferito al contenuto DAC STANDARD |
        MOV     CX,16         ; \--------------------------------------------/
XXX00:  INC     DH            ;
        M_msgC Corn1,DH,07,0EH; Predispone la cornice esterna
        LOOP    XXX00         ;
        INC     DH            ;
       M_msgC  Corn2,DH,07,0EH;
        MOV     BL,06H        ; Associa al Registro di Tavolozza BL=06H il co-
        MOV     BH,06H        ; lore BH="Giallo" (al posto del valore  di  de-
        MOV     AL,00H        ; fault BH=14H="Marrone") con l'aiuto della Sot-
        MOV     AH,10H        ; toFunzione 00H della Funzione dell'INT 10H
        INT     10H           ;
        POP     DX            ;
        PUSH    DX            ;
        MOV     BH,00H        ; Stampa la Stringa Testo0 con i colori   della
        MOV     CX,16         ; prima colonna della  Tabella "Dati" (tutti in
        MOV     DL,08         ; BIANCO BRILLANTE su sfondo  senza FLASH, cio
        LEA     DI,Dati       ;       0FH,1FH,2FH,3FH,4FH,5FH,6FH,7FH
XXX01:  CALL    STAdat        ;
        LOOP    XXX01         ;
        POP     DX            ;
        MOV     CX,16         ; Stampa la Stringa Testo0 con i colori   della
        MOV     DL,35         ; seconda colonna  della  Tabella "Dati" (tutti
        LEA     DI,Dati+1     ; con attributo NORMALE  su  sfondo  NERO, cio
XXX02:  CALL    STAdat        ;     00H,01H,02H,03H,04H,05H,06H,07H
        LOOP    XXX02         ;
        CALL    KEYwait       ;
        LEA     DX,Grigi      ; /--------------------------------------------\
        LEA     SI,Text4      ; |Predispone la TAVOLOZZA con colori GRIGI    |
        CALL    Prova         ; \--------------------------------------------/
        LEA     DX,Blu        ; /--------------------------------------------\
        LEA     SI,Text7      ; |Predispone la TAVOLOZZA con colori BLU      |
        CALL    Prova         ; \--------------------------------------------/
        LEA     DX,Verdi      ; /--------------------------------------------\
        LEA     SI,Text5      ; |Predispone la TAVOLOZZA con colori VERDI    |
        CALL    Prova         ; \--------------------------------------------/
        LEA     DX,Azzur      ; /--------------------------------------------\
        LEA     SI,TextA      ; |Predispone la TAVOLOZZA con colori AZZURRI  |
        CALL    Prova         ; \--------------------------------------------/
        LEA     DX,Rossi      ; /--------------------------------------------\
        LEA     SI,Text6      ; |Predispone la TAVOLOZZA con colori ROSSI    |
        CALL    Prova         ; \--------------------------------------------/
        LEA     DX,Magen      ; /--------------------------------------------\
        LEA     SI,Text8      ; |Predispone la TAVOLOZZA con colori MAGENTA  |
        CALL    Prova         ; \--------------------------------------------/
        LEA     DX,Giall      ; /--------------------------------------------\
        LEA     SI,Text9      ; |Predispone la TAVOLOZZA con colori GIALLI   |
        CALL    Prova         ; \--------------------------------------------/
        LEA     DX,Bianc      ; /--------------------------------------------\
        LEA     SI,TextB      ; |Predispone la TAVOLOZZA con colori BIANCHI  |
        CALL    Prova         ; \--------------------------------------------/

        MOV     BL,06H        ; Associa di nuovo al Registro di Tavolozza BL =
        MOV     BH,14H        ; 06H il colore di default BH=14H="Marrone"  (al
        MOV     AL,00H        ; posto del valore BH=06H="Giallo")  forzato  in
        MOV     AH,10H        ; precedenza per garantire un efficiente funzio-
        INT     10H           ; namento  del programma

        LEA     DX,ColNorm    ; /--------------------------------------------\
        LEA     SI,Text3      ; |Ripristina la TAVOLOZZA con colori STANDARD |
        CALL    Prova         ; \--------------------------------------------/
        M_msgC Text1,24,1,0FH
        MOV     CX,04         ;
XXX03:  M_msgN  Text1         ;
        LOOP    XXX03         ;

        PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;

B10_1012 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
