;
; il programma di collaudo della SottoFunzione 13H, B10_1013,  molto prezioso;
; esso contiene una tabella di terne di codici identica a quella memorizzata
; nei Registri di Colore del DAC dal MODO GRAFICO 13H a 256 colori, con la sola
; modifica della prima terna di ogni gruppo di 16, che  viene forzata a
; 00H,00H,00H: i valori originali infatti (mantenenuti comunque come commento),
; puntati come  noto dal Registro di Tavolozza N 00H (a sua volta attivato
; dal nibble 0000 dell'Attributo), oltre a influenzare il colore di Primo Piano
; serve anche per lo Sfondo dei caratteri posti a Video. Se la prima cosa pu
; essere apprezzabile la seconda disturba molto l'effetto degli altri colori
; che, pertanto, si preferiscono presentati su Sfondo NERO.
;
; L'utilit del programma consiste nel fatto che pu costituire una valida base
; di partenza per creare un proprio set di 16 Tavolozze, facilmente commutabili
; tra di loro; l'esperienza sottolineata poco fa insegna che, comunque, conviene
; rinunciare al primo Registro di Colore DAC di ogni gruppo per garantire la
; disponibilit dello Sfondo NERO; dal momento che la scelta  stata fatta la
; Tavolozza dei 16 colori rimarr attiva fino alla successiva eventuale modifica
; (anche al rientro al DOS).
;
PAGE 66,132
TITLE ** B10_1013.ASM - Imposta la Tavolozza attiva e il suo tipo
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1013.ASM                         (INT 10H, Funzione 10H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Prova l'INT 10H, Funzione 10H (SottoFunzione 13H) al fine di|
;|               scegliere la Fonte per la Decodifica del Colore nella stampa|
;|               a Video; si lavora in MODO TESTO standard 03H.              |
;|                                                                           |
;|               In sostanza viene chiamata prima con BL=00H per stabilire il|
;|               numero di Pagine di Colori (Tavolozze) disponibili, indicato|
;|               da BH; poich siamo in MODO TESTO si   scelta l'opportunit|
;|               di dividere il Set dei Registri DAC in 16 Pagine da 16 Regi-|
;|               stri ciascuna (00H0FH, 10H1FH,..,F0HFFH) imponendo BH=01.|
;|                                                                           |
;|               Quindi la SottoFunzione viene chiamata pi volte con  BL=01H|
;|               per stabilire quale tra le possibili Pagine di Colore predi-|
;|               sposte nella prima fase si desidera lavorare; il numero del-|
;|               la Pagina selezionata viene passato in  BH,  scegliendo  tra|
;|               le sedici possibili Pagine da 16 Registri ciascuna, BH=0HFH|
;|                                                                           |
;|               Viene cos resa possibile la veloce commutazione tra una Pa-|
;|               gina e l'altra del gruppo selezionato; in altre parole, dopo|
;|               aver predisposto i colori nei registri  DAC, a gruppi di 16,|
;|                facile passare da un gruppo ad un altro semplicemente  con|
;|               un comando, SottoFunzione 13H/BL=01H, Funzione 10H, INT 10H.|
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CAMBIAcol:NEAR
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   BIOchr1:NEAR
        EXTRN   Byt2Asc:NEAR
        EXTRN   KEYwait:NEAR
        PUBLIC  ATTRIB        ;Attributo di colore


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_1013


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
DepoDAC DB   00H              ; DepoDAC=Registro di Colore del DAC
DepoDH  DB   00H              ; DepoDH=Rosso
DepoCH  DB   00H              ; DepoCH=Verde
DepoCL  DB   00H              ; DepoCL=Blu
ATTRIB  DB   00H
Out_0   DB  "                     Premere  "                          ,00H
Out_1   DB  "un tasto"                                                ,00H
Out_2   DB  "  per continuare                      "                  ,00H
Text0  DB "           Cambio della Tavolozza Attiva   a LIVELLO BIOS   "
Text1  DB                                  "                 "        ,00H
Testo0  DB   " PROVA con Attributo   H "                              ,00H
;       DB                              " PROVA con Attributo   H "   ,00H
Corn0   DB  "ĿĿ"  ,00H
Corn1   DB  "                                                  "  ,00H
Corn2   DB  ""  ,00H
Corn3   DB  "ĿĿ"                                      ,00H
Corn4   DB  "              "                                      ,00H
Corn5   DB  ""                                      ,00H

;/-----------\;/-------------------------------------------------------------\
;|           |;|Per poter apprezzare il colore di Primo Piano delle varie Ta-|
;|           |;|volozze la terna di codici puntata dal Registro di  Tavolozza|
;|   NOTA    |;|00H si  lasciata in tutti e 16 i casi al valore  00H,00H,00H|
;|           |;|invece di quella prevista dal Set di 256 colori originali dei|
;|           |;|MODI GRAFICI                                                 |
;\-----------/;\-------------------------------------------------------------/
              ;/---*---*---\  ;/-----*---------------------------------------\
              ;|Ros|Ver|Blu|  ;|Color| Colore di default nel Registro del DAC|
              ;*---*---*---*  ;*-----*---------------------------------------*
TabCol  DB      00H,00H,00H   ;| 00H | Nero    Normale   CGA                 |
        DB      00H,00H,2AH   ;| 01H | Blu     Normale   CGA                 |
        DB      00H,2AH,00H   ;| 02H | Verde   Normale   CGA                 |
        DB      00H,2AH,2AH   ;| 03H | Azzurro Normale   CGA                 |
        DB      2AH,00H,00H   ;| 04H | Rosso   Normale   CGA                 |
        DB      2AH,00H,2AH   ;| 05H | Magenta Normale   CGA                 |
        DB      2AH,15H,00H   ;| 06H | Marrone Normale   CGA                 |
        DB      2AH,2AH,2AH   ;| 07H | Bianco  Normale   CGA                 |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      15H,15H,15H   ;| 08H | Grigio            CGA                 |
        DB      15H,15H,3FH   ;| 09H | Blu     Elettrico CGA                 |
        DB      15H,3FH,15H   ;| 0AH | Verde   Chiaro    CGA                 |
        DB      15H,3FH,3FH   ;| 0BH | Celeste           CGA                 |
        DB      3FH,15H,15H   ;| 0CH | Rosa              CGA                 |
        DB      3FH,15H,3FH   ;| 0DH | Magenta Chiaro    CGA                 |
        DB      3FH,3FH,15H   ;| 0EH | Giallo            CGA                 |
        DB      3FH,3FH,3FH   ;| 0FH | Bianco  Brillante CGA                 |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| 10H | gradazione Grigia per Nero    Normale |
        DB      05H,05H,05H   ;| 11H | gradazione Grigia per Blu     Normale |
        DB      08H,08H,08H   ;| 12H | gradazione Grigia per Verde   Normale |
        DB      0BH,0BH,0BH   ;| 13H | gradazione Grigia per Azzurro Normale |
        DB      0EH,0EH,0EH   ;| 14H | gradazione Grigia per Rosso   Normale |
        DB      11H,11H,11H   ;| 15H | gradazione Grigia per Magenta Normale |
        DB      14H,14H,14H   ;| 16H | gradazione Grigia per Marrone Normale |
        DB      18H,18H,18H   ;| 17H | gradazione Grigia per Bianco  Normale |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      1CH,1CH,1CH   ;| 18H | gradazione Grigia per Grigio          |
        DB      20H,20H,20H   ;| 19H | gradazione Grigia per Blu  Elettrico  |
        DB      24H,24H,24H   ;| 1AH | gradazione Grigia per Verde   Chiaro  |
        DB      28H,28H,28H   ;| 1BH | gradazione Grigia per Celeste         |
        DB      2DH,2DH,2DH   ;| 1CH | gradazione Grigia per Rosa            |
        DB      32H,32H,32H   ;| 1DH | gradazione Grigia per Magenta Chiaro  |
        DB      38H,38H,38H   ;| 1EH | gradazione Grigia per Giallo          |
        DB      3FH,3FH,3FH   ;| 1FH | gradazione Grigia per Bianco Brillante|
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| 20H | Sarebbe 00H,00H,3FH - Vedi NOTA -     |
        DB      10H,00H,3FH   ;| 21H |                                       |
        DB      1FH,00H,3FH   ;| 22H |                                       |
        DB      2FH,00H,3FH   ;| 23H |        BLU  a SATURAZIONE MASSIMA     |
        DB      3FH,00H,3FH   ;| 24H |             a ALTA INTENSITA`         |
        DB      3FH,00H,2FH   ;| 25H |                                       |
        DB      3FH,00H,1FH   ;| 26H |                                       |
        DB      3FH,00H,10H   ;| 27H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      3FH,00H,00H   ;| 28H |                                       |
        DB      3FH,10H,00H   ;| 29H |                                       |
        DB      3FH,1FH,00H   ;| 2AH |                                       |
        DB      3FH,2FH,00H   ;| 2BH |       ROSSO a SATURAZIONE MASSIMA     |
        DB      3FH,3FH,00H   ;| 2CH |             a ALTA INTENSITA`         |
        DB      2FH,3FH,00H   ;| 2DH |                                       |
        DB      1FH,3FH,00H   ;| 2EH |                                       |
        DB      10H,3FH,00H   ;| 2FH |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| 30H | Sarebbe 00H,3FH,00H - Vedi NOTA -     |
        DB      00H,3FH,10H   ;| 31H |                                       |
        DB      00H,3FH,1FH   ;| 32H |                                       |
        DB      00H,3FH,2FH   ;| 33H |       VERDE a SATURAZIONE MASSIMA     |
        DB      00H,3FH,3FH   ;| 34H |             a ALTA INTENSITA`         |
        DB      00H,2FH,3FH   ;| 35H |                                       |
        DB      00H,1FH,3FH   ;| 36H |                                       |
        DB      00H,10H,3FH   ;| 37H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      1FH,1FH,3FH   ;| 38H |                                       |
        DB      27H,1FH,3FH   ;| 39H |                                       |
        DB      2FH,1FH,3FH   ;| 3AH |                                       |
        DB      37H,1FH,3FH   ;| 3BH |        BLU  a SATURAZIONE MEDIA       |
        DB      3FH,1FH,3FH   ;| 3CH |             a ALTA INTENSITA`         |
        DB      3FH,1FH,37H   ;| 3DH |                                       |
        DB      3FH,1FH,2FH   ;| 3EH |                                       |
        DB      3FH,1FH,27H   ;| 3FH |                                       |
               ;-R-*-V-*-B-   ;͵
        DB      00H,00H,00H   ;| 40H | Sarebbe 3FH,1FH,1FH - Vedi NOTA -     |
        DB      3FH,27H,1FH   ;| 41H |                                       |
        DB      3FH,2FH,1FH   ;| 42H |                                       |
        DB      3FH,37H,1FH   ;| 43H |       ROSSO a SATURAZIONE MEDIA       |
        DB      3FH,3FH,1FH   ;| 44H |             a ALTA INTENSITA`         |
        DB      37H,3FH,1FH   ;| 45H |                                       |
        DB      2FH,3FH,1FH   ;| 46H |                                       |
        DB      27H,3FH,1FH   ;| 47H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      1FH,3FH,1FH   ;| 48H |                                       |
        DB      1FH,3FH,27H   ;| 49H |                                       |
        DB      1FH,3FH,2FH   ;| 4AH |                                       |
        DB      1FH,3FH,37H   ;| 4BH |                                       |
        DB      1FH,3FH,3FH   ;| 4CH |       VERDE a SATURAZIONE MEDIA       |
        DB      1FH,37H,3FH   ;| 4DH |             a ALTA INTENSITA`         |
        DB      1FH,2FH,3FH   ;| 4EH |                                       |
        DB      1FH,27H,3FH   ;| 4FH |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| 50H | Sarebbe 2DH,2DH,3FH - Vedi NOTA -     |
        DB      31H,2DH,3FH   ;| 51H |                                       |
        DB      36H,2DH,3FH   ;| 52H |                                       |
        DB      3AH,2DH,3FH   ;| 53H |        BLU  a SATURAZIONE BASSA       |
        DB      3FH,2DH,3FH   ;| 54H |             a ALTA INTENSITA`         |
        DB      3FH,2DH,3AH   ;| 55H |                                       |
        DB      3FH,2DH,36H   ;| 56H |                                       |
        DB      3FH,2DH,31H   ;| 57H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      3FH,2DH,2DH   ;| 58H |                                       |
        DB      3FH,31H,2DH   ;| 59H |                                       |
        DB      3FH,36H,2DH   ;| 5AH |                                       |
        DB      3FH,3AH,2DH   ;| 5BH |       ROSSO a SATURAZIONE BASSA       |
        DB      3FH,3FH,2DH   ;| 5CH |             a ALTA INTENSITA`         |
        DB      3AH,3FH,2DH   ;| 5DH |                                       |
        DB      36H,3FH,2DH   ;| 5EH |                                       |
        DB      31H,3FH,2DH   ;| 5FH |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| 60H | Sarebbe 2DH,3FH,2DH - Vedi NOTA -     |
        DB      2DH,3FH,31H   ;| 61H |                                       |
        DB      2DH,3FH,36H   ;| 62H |                                       |
        DB      2DH,3FH,3AH   ;| 63H |       VERDE a SATURAZIONE BASSA       |
        DB      2DH,3FH,3FH   ;| 64H |             a ALTA INTENSITA`         |
        DB      2DH,3AH,3FH   ;| 65H |                                       |
        DB      2DH,36H,3FH   ;| 66H |                                       |
        DB      2DH,31H,3FH   ;| 67H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,1CH   ;| 68H |                                       |
        DB      07H,00H,1CH   ;| 69H |                                       |
        DB      0EH,00H,1CH   ;| 6AH |                                       |
        DB      15H,00H,1CH   ;| 6BH |        BLU  a SATURAZIONE MASSIMA     |
        DB      1CH,00H,1CH   ;| 6CH |             a MEDIA INTENSITA`        |
        DB      1CH,00H,15H   ;| 6DH |                                       |
        DB      1CH,00H,0EH   ;| 6EH |                                       |
        DB      1CH,00H,07H   ;| 6FH |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| 70H | Sarebbe 1CH,00H,00H - Vedi NOTA -     |
        DB      1CH,07H,00H   ;| 71H |                                       |
        DB      1CH,0EH,00H   ;| 72H |                                       |
        DB      1CH,15H,00H   ;| 73H |       ROSSO a SATURAZIONE MASSIMA     |
        DB      1CH,1CH,00H   ;| 74H |             a MEDIA INTENSITA`        |
        DB      15H,1CH,00H   ;| 75H |                                       |
        DB      0EH,1CH,00H   ;| 76H |                                       |
        DB      07H,1CH,00H   ;| 77H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,1CH,00H   ;| 78H |                                       |
        DB      00H,1CH,07H   ;| 79H |                                       |
        DB      00H,1CH,0EH   ;| 7AH |                                       |
        DB      00H,1CH,15H   ;| 7BH |       VERDE a SATURAZIONE MASSIMA     |
        DB      00H,1CH,1CH   ;| 7CH |             a MEDIA INTENSITA`        |
        DB      00H,15H,1CH   ;| 7DH |                                       |
        DB      00H,0EH,1CH   ;| 7EH |                                       |
        DB      00H,07H,1CH   ;| 7FH |                                       |
               ;-R-*-V-*-B-   ;͵
        DB      00H,00H,00H   ;| 80H | Sarebbe 0EH,0EH,1CH - Vedi NOTA -     |
        DB      11H,0EH,1CH   ;| 81H |                                       |
        DB      15H,0EH,1CH   ;| 82H |                                       |
        DB      18H,0EH,1CH   ;| 83H |        BLU  a SATURAZIONE MEDIA       |
        DB      1CH,0EH,1CH   ;| 84H |             a MEDIA INTENSITA`        |
        DB      1CH,0EH,18H   ;| 85H |                                       |
        DB      1CH,0EH,15H   ;| 86H |                                       |
        DB      1CH,0EH,11H   ;| 87H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      1CH,0EH,0EH   ;| 88H |                                       |
        DB      1CH,11H,0EH   ;| 89H |                                       |
        DB      1CH,15H,0EH   ;| 8AH |                                       |
        DB      1CH,18H,0EH   ;| 8BH |       ROSSO a SATURAZIONE MEDIA       |
        DB      1CH,1CH,0EH   ;| 8CH |             a MEDIA INTENSITA`        |
        DB      18H,1CH,0EH   ;| 8DH |                                       |
        DB      15H,1CH,0EH   ;| 8EH |                                       |
        DB      11H,1CH,0EH   ;| 8FH |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| 90H | Sarebbe 0EH,1CH,0EH - Vedi NOTA -     |
        DB      0EH,1CH,11H   ;| 91H |                                       |
        DB      0EH,1CH,15H   ;| 92H |                                       |
        DB      0EH,1CH,18H   ;| 93H |       VERDE a SATURAZIONE MEDIA       |
        DB      0EH,1CH,1CH   ;| 94H |             a MEDIA INTENSITA`        |
        DB      0EH,18H,1CH   ;| 95H |                                       |
        DB      0EH,15H,1CH   ;| 96H |                                       |
        DB      0EH,11H,1CH   ;| 97H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      14H,14H,1CH   ;| 98H |                                       |
        DB      16H,14H,1CH   ;| 99H |                                       |
        DB      18H,14H,1CH   ;| 9AH |                                       |
        DB      1AH,14H,1CH   ;| 9BH |        BLU  a SATURAZIONE BASSA       |
        DB      1CH,14H,1CH   ;| 9CH |             a MEDIA INTENSITA`        |
        DB      1CH,14H,1AH   ;| 9DH |                                       |
        DB      1CH,14H,18H   ;| 9EH |                                       |
        DB      1CH,14H,16H   ;| 9FH |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| A0H | Sarebbe 1CH,14H,14H - Vedi NOTA -     |
        DB      1CH,16H,14H   ;| A1H |                                       |
        DB      1CH,18H,14H   ;| A2H |                                       |
        DB      1CH,1AH,14H   ;| A3H |       ROSSO a SATURAZIONE BASSA       |
        DB      1CH,1CH,14H   ;| A4H |             a MEDIA INTENSITA`        |
        DB      1AH,1CH,14H   ;| A5H |                                       |
        DB      18H,1CH,14H   ;| A6H |                                       |
        DB      16H,1CH,14H   ;| A7H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      14H,1CH,14H   ;| A8H |                                       |
        DB      14H,1CH,16H   ;| A9H |                                       |
        DB      14H,1CH,18H   ;| AAH |                                       |
        DB      14H,1CH,1AH   ;| ABH |       VERDE a SATURAZIONE BASSA       |
        DB      14H,1CH,1CH   ;| ACH |             a MEDIA INTENSITA`        |
        DB      14H,1AH,1CH   ;| ADH |                                       |
        DB      14H,18H,1CH   ;| AEH |                                       |
        DB      14H,16H,1CH   ;| AFH |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| B0H | Sarebbe 00H,00H,10H - Vedi NOTA -     |
        DB      04H,00H,10H   ;| B1H |                                       |
        DB      08H,00H,10H   ;| B2H |                                       |
        DB      0CH,00H,10H   ;| B3H |        BLU  a SATURAZIONE MASSIMA     |
        DB      10H,00H,10H   ;| B4H |             a BASSA INTENSITA`        |
        DB      10H,00H,0CH   ;| B5H |                                       |
        DB      10H,00H,08H   ;| B6H |                                       |
        DB      10H,00H,04H   ;| B7H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      10H,00H,00H   ;| B8H |                                       |
        DB      10H,04H,00H   ;| B9H |                                       |
        DB      10H,08H,00H   ;| BAH |                                       |
        DB      10H,0CH,00H   ;| BBH |       ROSSO a SATURAZIONE MASSIMA     |
        DB      10H,10H,00H   ;| BCH |             a BASSA INTENSITA`        |
        DB      0CH,10H,00H   ;| BDH |                                       |
        DB      08H,10H,00H   ;| BEH |                                       |
        DB      04H,10H,00H   ;| BFH |                                       |
               ;-R-*-V-*-B-   ;͵
        DB      00H,00H,00H   ;| C0H | Sarebbe 00H,10H,00H - Vedi NOTA -     |
        DB      00H,10H,04H   ;| C1H |                                       |
        DB      00H,10H,08H   ;| C2H |                                       |
        DB      00H,10H,0CH   ;| C3H |       VERDE a SATURAZIONE MASSIMA     |
        DB      00H,10H,10H   ;| C4H |             a BASSA INTENSITA`        |
        DB      00H,0CH,10H   ;| C5H |                                       |
        DB      00H,08H,10H   ;| C6H |                                       |
        DB      00H,04H,10H   ;| C7H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      08H,08H,10H   ;| C8H |                                       |
        DB      0AH,08H,10H   ;| C9H |                                       |
        DB      0CH,08H,10H   ;| CAH |                                       |
        DB      0EH,08H,10H   ;| CBH |        BLU  a SATURAZIONE MEDIA       |
        DB      10H,08H,10H   ;| CCH |             a BASSA INTENSITA`        |
        DB      10H,08H,0EH   ;| CDH |                                       |
        DB      10H,08H,0CH   ;| CEH |                                       |
        DB      10H,08H,0AH   ;| CFH |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| D0H | Sarebbe 10H,08H,08H - Vedi NOTA -     |
        DB      10H,0AH,08H   ;| D1H |                                       |
        DB      10H,0CH,08H   ;| D2H |                                       |
        DB      10H,0EH,08H   ;| D3H |       ROSSO a SATURAZIONE MEDIA       |
        DB      10H,10H,08H   ;| D4H |             a BASSA INTENSITA`        |
        DB      0EH,10H,08H   ;| D5H |                                       |
        DB      0CH,10H,08H   ;| D6H |                                       |
        DB      0AH,10H,08H   ;| D7H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      08H,10H,08H   ;| D8H |                                       |
        DB      08H,10H,0AH   ;| D9H |                                       |
        DB      08H,10H,0CH   ;| DAH |                                       |
        DB      08H,10H,0EH   ;| DBH |       VERDE a SATURAZIONE MEDIA       |
        DB      08H,10H,10H   ;| DCH |             a BASSA INTENSITA`        |
        DB      08H,0EH,10H   ;| DDH |                                       |
        DB      08H,0CH,10H   ;| DEH |                                       |
        DB      08H,0AH,10H   ;| DFH |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| E0H | Sarebbe 0BH,0BH,10H - Vedi NOTA -     |
        DB      0CH,0BH,10H   ;| E1H |                                       |
        DB      0DH,0BH,10H   ;| E2H |                                       |
        DB      0FH,0BH,10H   ;| E3H |        BLU  a SATURAZIONE BASSA       |
        DB      10H,0BH,10H   ;| E4H |             a BASSA INTENSITA`        |
        DB      10H,0BH,0FH   ;| E5H |                                       |
        DB      10H,0BH,0DH   ;| E6H |                                       |
        DB      10H,0BH,0CH   ;| E7H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      10H,0BH,0BH   ;| E8H |                                       |
        DB      10H,0CH,0BH   ;| E9H |                                       |
        DB      10H,0DH,0BH   ;| EAH |                                       |
        DB      10H,0FH,0BH   ;| EBH |       ROSSO a SATURAZIONE BASSA       |
        DB      10H,10H,0BH   ;| ECH |             a BASSA INTENSITA`        |
        DB      0FH,10H,0BH   ;| EDH |                                       |
        DB      0DH,10H,0BH   ;| EEH |                                       |
        DB      0CH,10H,0BH   ;| EFH |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| F0H | Sarebbe 0BH,10H,0BH - Vedi NOTA -     |
        DB      0BH,10H,0CH   ;| F1H |                                       |
        DB      0BH,10H,0DH   ;| F2H |                                       |
        DB      0BH,10H,0FH   ;| F3H |       VERDE a SATURAZIONE BASSA       |
        DB      0BH,10H,10H   ;| F4H |             a BASSA INTENSITA`        |
        DB      0BH,0FH,10H   ;| F5H |                                       |
        DB      0BH,0DH,10H   ;| F6H |                                       |
        DB      0BH,0CH,10H   ;| F7H |                                       |
               ;-R-*-V-*-B-   ;*-----*---------------------------------------*
        DB      00H,00H,00H   ;| F8H |       NERO su NERO                    |
        DB      00H,00H,00H   ;| F9H |       NERO su NERO                    |
        DB      00H,00H,00H   ;| FAH |       NERO su NERO                    |
        DB      00H,00H,00H   ;| FBH |       NERO su NERO                    |
        DB      00H,00H,00H   ;| FCH |       NERO su NERO                    |
        DB      00H,00H,00H   ;| FDH |       NERO su NERO                    |
        DB      00H,00H,00H   ;| FEH |       NERO su NERO                    |
        DB      00H,00H,00H   ;| FFH |       NERO su NERO                    |
               ;-R-*-V-*-B-   ;\-----*---------------------------------------/
        ;---------------------------------------------------------------------
Dati    DB       0FH,00H      ;\/--------------------------------------------\
        DB       1FH,01H      ;||                                            |
        DB       2FH,02H      ;||                                            |
        DB       3FH,03H      ;||                                            |
        DB       4FH,04H      ;||                                            |
        DB       5FH,05H      ;||                                            |
        DB       6FH,06H      ;||                                            |
        DB       7FH,07H      ;|| Colori  effettivamente  utilizzati  nella  |
        DB       8FH,08H      ;|| stampa  dei  testi                         |
        DB       9FH,09H      ;||                                            |
        DB      0AFH,0AH      ;||                                            |
        DB      0BFH,0BH      ;||                                            |
        DB      0CFH,0CH      ;||                                            |
        DB      0DFH,0DH      ;||                                            |
        DB      0EFH,0EH      ;||                                            |
        DB      0FFH,0FH      ;/\--------------------------------------------/


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : STAdat                                                      |
;| DESCRIZIONE : Organizza la stampa di una riga di informazioni,  con il te-|
;|               sto indicato in ingresso da SI, con il colore puntato  da DI|
;|               e nella posizione di stampa fissata da DH=riga, DL=colonna) |
;\---------------------------------------------------------------------------/
STAdat: PUSH    BX            ;
        MOV     BL,16         ; Punta il colore desiderato (in sostanza  crea
        SUB     BL,CL         ; in BX lo spiazzamento a  partire  dalla  base
        ADD     BL,BL         ; della Tabella Dati puntata in ingresso da DI
        MOV     AL,CS:[DI+BX] ;
        M_COLOR AL            ;
        PUSH    AX            ;
        INC     DH            ;
        CALL    SET_cur       ;
        LEA     SI,Testo0     ; Prende il colore in [ATTRIB], fissa  la  posi-
        CALL    BIOSmsg       ; zione e stampa la frase, aggiungendo il codice
        POP     AX            ; esadecimale dell'Attributo di colore  corrente
        PUSH    DX            ;
        PUSH    BX            ;
        ADD     DL,21         ;
        CALL    SET_cur       ;
        CALL    Byt2Asc       ;
        POP     BX            ;
        POP     DX            ;
        POP     BX            ;
        RET                   ;

;/---------------------------------------------------------------------------\
;| PROCEDURA   : LeggiDAC                                                    |
;| DESCRIZIONE : Lascia nelle variabili [DepoCL], [DepoCH] e [DepoDH] le  tre|
;|               gradazioni RVG, rispettivamente Blu, Verde e Rosso,  del Re-|
;|               gistro di Colore del DAC puntato dal contenuto corrente del-|
;|               la variabile [DepoDAC]=Numero del Registro DAC corrente     |
;\---------------------------------------------------------------------------/
LeggiDAC:MOV    BH,00H        ; Funzione BIOS che restituisce nei registri CH,
        MOV    BL,CS:[DepoDAC]; (Verde), CL (Blu) e DH (Rosso) le  tre  grada-
        MOV     AL,15H        ; zioni RBG del Registro di Colore del DAC  pun-
        MOV     AH,10H        ; tato da BX (DepoDAC=Registro DAC corrente)
        INT     10H           ;
        MOV     CS:[DepoCL],CL; DepoCL=Blu
        MOV     CS:[DepoCH],CH; DepoCH=Verde
        MOV     CS:[DepoDH],DH; DepoDH=Rosso
        RET

;/---------------------------------------------------------------------------\
;| PROCEDURA   : StaDAC                                                      |
;| DESCRIZIONE : Stampa nella corretta posizione  i  valori esadecimali della|
;|               terna RVG  corrente,  rispettivamente per Blu, Verde e Rosso|
;\---------------------------------------------------------------------------/
StaDAC:
        M_COLOR 07H           ;
        MOV     DL,58         ;
        CALL    SET_cur       ;
        MOV    AL,CS:[DepoDAC]; DAC=Registro di Colore del DAC
        CALL    Byt2Asc       ;
        MOV     AL,"H"        ;
        CALL    BIOchr1       ;
        MOV     DL,63         ;
        CALL    SET_cur       ;
        M_COLOR 4FH           ;
        MOV     AL,CS:[DepoDH]; DepoDH=Rosso
        INC     DI            ;
        CALL    Byt2Asc       ;
        MOV     AL,"H"        ;
        CALL    BIOchr1       ;
        MOV     DL,67         ;
        CALL    SET_cur       ;
        M_COLOR 2FH           ;
        MOV     AL,CS:[DepoCH]; DepoCH=Verde
        INC     DI            ;
        CALL    Byt2Asc       ;
        MOV     AL,"H"        ;
        CALL    BIOchr1       ;
        MOV     DL,71         ;
        CALL    SET_cur       ;
        M_COLOR 1FH           ;
        MOV     AL,CS:[DepoCL]; DepoCL=Blu
        INC     DI            ;
        CALL    Byt2Asc       ;
        MOV     AL,"H"        ;
        CALL    BIOchr1       ;
        RET

;/---------------------------------------------------------------------------\
;| PROCEDURE   : Prova/Prova_                                                |
;| DESCRIZIONE : Visualizzano i valori correnti delle terne DAC correnti pre-|
;|               senti sulla Riga di dati corrente                           |
;\---------------------------------------------------------------------------/
Prova_: MOV     CX,8          ;
        JMP     SHORT Prova__ ;
Prova:  MOV     CX,16         ;
        MOV     DH,05         ;
Prova__:Call    Prova0        ;
        RET                   ;
       ;----------------------- ----------------------------------------------
Prova0: PUSH    DI            ;
        PUSH    BX            ;
Prova1: PUSH    CX            ;
                              ; Lascia nelle variabili [DepoCL]=Blu, [DepoCH]=
        PUSH    DX            ; =Verde e [DepoDH]=Rosso le tre gradazioni  RVG
        CALL    LeggiDAC      ; del Registro di Colore  del  DAC  puntato  dal
        POP     DX            ; contenuto  corrente  della variabile [DepoDAC]
                              ; =Numero del Registro DAC corrente
                              ; Stampa nella corretta posizione i  valori esa-
        CALL    StaDAC        ; decimali della terna RVG corrente, rispettiva-
                              ; mente per Blu, Verde e Rosso
        POP     CX            ;
        INC     CS:[DepoDAC]  ; Punta il Registro di Colore del DAC succesivo
        INC     DH            ; e cambia riga di stampa
        LOOP    Prova1        ;
        POP     BX            ;
        POP     DI            ;
        RET                   ;



;*****************************************************************************
                              ; ----------------------------------------------
B10_1013 proc   NEAR          ;      AREA DEDICATA AL MAIN PROGRAM
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        PUSH    ES            ; /--------------------------------------------\
        MOV     AX,CS         ; |   Scrittura dei 256 Registri di Colore DAC |
        MOV     ES,AX         ; \--------------------------------------------/
        LEA     DX,TabCol     ; Funzione BIOS che aggiorna il contenuto di  CX
        MOV     CX,256 ;NumReg; Registri di Colore del DAC del Video a partire
        MOV     BX,00H;NuPrReg; da quello di ordine BX; i valori sono preleva-
        MOV     AL,12H        ; ti  dalle  terne  Rosso-Verde-Blu  predisposte
        MOV     AH,10H        ; nella Tabella puntata da ES:DX
        INT     10H           ;
        POP     ES            ;

        MOV     BL,00H ;Quante; Funzione BIOS che stabilisce,se BL=00H, il nu-
        MOV     BH,01H ;NumPag; mero di Tavolozze possibili: con BH=01H  rende
        MOV     AL,13H        ; disponibili 16 pagine da 16 Registri di  Tavo-
        MOV     AH,10H        ; lozza EGA; con BH=00H 4 pagine da  64 Registri
        INT     10H           ; di Colore DAC

        MOV     CH,00         ; /--------------------------------------------\
        MOV     CL,00         ; |                                            |
        MOV     DH,24         ; |Produce un ClearScreen con aiuto della  Fun-|
        MOV     DL,79         ; |zione 06H dell'INT 10H BIOS (NB:CH=RigaAlto,|
        MOV     BH,0FH        ; |CL=ColnAlto,  DH=RigaBass,  DL=ColnBass, BH=|
        MOV     AL,00         ; |BH=Colore e AL=0 (scorrere  TUTTE  le  righe|
        MOV     AH,06H        ; |dello schermo)                              |
        INT     10H           ; |                                            |
        CALL    VIA_cur       ; *--------------------------------------------*
        M_msgC  Text0 ,1,1,1FH; |                                            |
        M_msgC  Out_0,24,1,1FH; |    Inizializza la pagina Video del test    |
        M_COLOR 9FH           ; |                    e                       |
        M_msgN Out_1          ; |    propone il Testo di presentazione       |
        M_COLOR 1FH           ; |                                            |
        M_msgN Out_2          ; \--------------------------------------------/
        MOV     DH,04         ;
        M_msgC Corn0,DH,03,07H;
        M_msgN  Corn3         ;
        MOV     CX,16         ;
XXX00:  INC     DH            ;
        M_msgC Corn1,DH,03,07H; Predispone la cornice esterna
        M_msgN  Corn4         ;
        LOOP    XXX00         ;
        INC     DH            ;
       M_msgC  Corn2,DH,03,07H;  0EH
        M_msgN  Corn5         ;
        MOV     DH,04         ;
        PUSH    DX            ;
        MOV     BH,00H        ; Stampa la Stringa Testo0 con i colori   della
        MOV     CX,16         ; prima colonna della  Tabella "Dati" (tutti in
        MOV     DL,04         ; BIANCO BRILLANTE su sfondo con e senza FLASH:
        LEA     DI,Dati       ;       0FH,1FH,2FH,3FH,4FH,5FH,6FH,7FH
XXX01:  CALL    STAdat        ;       8FH,9FH,AFH,BFH,CFH,DFH,EFH,FFH
        LOOP    XXX01         ;
        POP     DX            ;
        MOV     CX,16         ;   Stampa la Stringa Testo0 con i colori della
        MOV     DL,31         ;     seconda colonna  della  Tabella "Dati"
        LEA     DI,Dati+1     ;     (tutti con attributo su  sfondo  NERO:
XXX02:  CALL    STAdat        ;        00H,01H,02H,03H,04H,05H,06H,07H
        LOOP    XXX02         ;        08H,09H,0AH,0BH,0CH,0DH,0EH,0FH
        MOV     CX,16         ;
 MOV Byte Ptr CS:[DepoDAC],00H; DepoDAC=Registro DAC corrente
XXX03:  PUSH    CX            ;
        PUSH    BX            ; /--------------------------------------------\
        MOV     BL,01H  ;Quale; | Attiva la Pagina di Colori corrente        |
        MOV     BH,16         ; \--------------------------------------------/
        SUB     BH,CL  ;NumPag; Funzione BIOS che stabilisce, con BL=01H, qua-
        MOV     AL,13H        ; le delle possibili pagine di colore desiderata
        MOV     AH,10H        ; scegliendo tra BH=00H0FH per una delle 16  da
        INT     10H           ; 16 Registri di Tavolozza EGA (o tra BH=00H03H
        POP     BX            ; per una delle 4 da 64  Registri di Colore DAC)
        CALL    Prova         ;
        CALL    KEYwait       ;
        POP     CX            ;
        LOOP    XXX03         ;

       ;/--------------------------------------------------------------------\
       ;|Prima di riprendere la Tavolozza di colori standard (cio quella che|
       ;|punta i Registri DAC 00H07H e 38H3FH) ribadisce il MODO TESTO cor-|
_OUT:  ;|rente, 03H, al fine di ricaricare i primi 64 Registri di Colore,  di|
       ;|norma diversi da quelli predisposti all'inizio del programma nei 256|
       ;|Registri di Colore del DAC, adatti al MODO GRAFICO 13H              |
       ;\--------------------------------------------------------------------/
        MOV     AL,83H        ;/-------------------*------*-----*----*-------\
        MOV     AH,00H        ;|MODO TESTO STANDARD|AL=03H|80x25|8x16|640x400|
        INT     10H           ;\-------------------*------*-----*----*-------/
        CALL    VIA_cur       ; La Richiesta di Modo reinizializza il Cursore
        MOV     BL,01H  ;Quale; Funzione BIOS che stabilisce, con BL=01H, qua-
        MOV     BH,00H ;NumPag; le delle possibili pagine di colore desiderata
        MOV     AL,13H        ; scegliendo la prima, di default, con i 16  Re-
        MOV     AH,10H        ; gistri di Tavolozza che puntano i Registri DAC
        INT     10H           ; 00H07H  e 38H3FH associate ai colori NORMALI
 MOV Byte Ptr CS:[DepoDAC],00H;
        MOV     DH,05         ;
        CALL    Prova_        ; Stampa il contenuto dei  Registri  DAC  corri-
 MOV Byte Ptr CS:[DepoDAC],38H; spondenti
        MOV     DH,13         ;
        CALL    Prova_        ;
        CALL    KEYwait       ;
        M_msgC Text1,24,1,0FH ;
        MOV     CX,06         ;                                              |
XXX04:  M_msgN  Text1         ;                                              |
        LOOP    XXX04         ;                                              |
        CALL    RIP_cur       ;                                              |
        MOV     DH,23         ;     FASE STANDARD D'USCITA DAL PROGRAMMA     |
        MOV     DL,0          ;                                              |
        CALL    SET_cur       ;                                              |
        MOV     AH,4CH        ;                                              |
        INT     21H           ;

B10_1013 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
       ;
       ; MOV     AL,16 ;Quante ; Per rendere leggibili  i  messaggi,  qualunque
       ; MUL     BH            ; sia la terna corrente del Registro DAC puntata
       ; ADD     AX,0007H      ; dal Registro di Tavolozza associato all'Attru-
       ; MOV     BX,AX;NumRegis; buto 07H, per la loro stampa  si usa  la terna
       ; MOV     CH,00H        ; di default per il Registro DAC N3FH
       ; MOV     CL,00H        ;
       ; MOV     DH,00H        ;
       ; MOV     BH,00H        ;
       ; MOV    BL,CS:[DepoDAC];
       ; MOV     AL,10H        ; Funzione BIOS che scrive nel Registro di Colo-
       ; MOV     AH,10H        ; re del DAC puntato da BX le tre gradazioni RBG
       ; INT     10H           ; passare nei registri CH, CL e DH
                               ;
