PAGE 66,132
TITLE ** B10_1017.ASM -  Legge un blocco di Registri Colore del DAC
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1017.ASM                         (INT 10H, Funzione 10H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Prova l'INT 10H, Funzione 10H (SottoFunzione 17H): l'esempio|
;|               proposto analizza in blocco il contenuto di tutti i 256  Re-|
;|               gistri di Colore del DAC, organizzando  la  visualizzazione |
;|               delle rispettive terne di codici di colore RVB.             |
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CAMBIAcol:NEAR
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   Byt2Asc:NEAR
        EXTRN   BIOchr1:NEAR
        EXTRN   KEYwait:NEAR
        PUBLIC  ATTRIB        ;Attributo di colore


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_1017


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
TabCol DB   64*3 dup (00H)    ;Prime 64 Terne, Componenti RVB, Rosso-Verde-Blu
TabCo1 DB  192*3 dup (00H)    ;Altre 192=64*3 Terne Compon.RVB Rosso-Verde-Blu
ATTRIB DB   00H
Out_0  DB "                       Premere  "                             ,00H
Out_1  DB                                 "un tasto"                     ,00H
Out_2  DB                        "  per continuare                     " ,00H
Text0  DB " Lettura dei Codici di Colore del DAC a LIVELLO BIOS in MODO TESTO"
Text1  DB                                  "           "                 ,00H
Corn0  DB "Ŀ   "                                         ,00H
Corn1  DB "RegRosVerBlu   "                                         ,00H
Corn2  DB "Ĵ   "                                         ,00H
Corn3  DB "               "                                         ,00H
Corn4  DB "   "                                         ,00H


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : Riga                                                        |
;| DESCRIZIONE : Visualizza i valori correnti delle terne correnti presenti  |
;|               sulla Riga di dati corrente                                 |
;\---------------------------------------------------------------------------/
Riga:   M_COLOR 0FH           ;
        CALL    SET_cur       ;
        PUSH    BX            ;
        MOV     AL,BL         ; BL=Registro di Colore del DAC
        CALL    Byt2Asc       ;
        MOV     AL,"H"        ;
        CALL    BIOchr1       ;
        ADD     DL,04         ;
        CALL    SET_cur       ;
        M_COLOR 4FH           ;
        MOV     AL,CS:[DI]    ; Rosso
        INC     DI            ;
        CALL    Byt2Asc       ;
        MOV     AL,"H"        ;
        CALL    BIOchr1       ;
        ADD     DL,04         ;
        CALL    SET_cur       ;
        M_COLOR 2FH           ;
        MOV     AL,CS:[DI]    ; Verde
        INC     DI            ;
        CALL    Byt2Asc       ;
        MOV     AL,"H"        ;
        CALL    BIOchr1       ;
        ADD     DL,04         ;
        CALL    SET_cur       ;
        M_COLOR 1FH           ;
        MOV     AL,CS:[DI]    ; Blu
        INC     DI            ;
        CALL    Byt2Asc       ;
        MOV     AL,"H"        ;
        CALL    BIOchr1       ;
        POP     BX            ;
        INC     BX            ;
        RET                   ;

;/---------------------------------------------------------------------------\
;| PROCEDURA   : STAdati                                                     |
;| DESCRIZIONE : Visualizza i valori di tutte le terne correnti              |
;\---------------------------------------------------------------------------/
STAdati:PUSH    CX            ;
        MOV     CX,16         ;
        MOV     DH,5          ;
STAda0: INC     DH            ; Prima Colonna
        MOV     DL,2          ;
        CALL    Riga          ;
        LOOP    STAda0        ;
        MOV     CX,16         ;
        MOV     DH,5          ;
STAda1: INC     DH            ; Seconda Colonna
        MOV     DL,22         ;
        CALL    Riga          ;
        LOOP    STAda1        ;
        MOV     CX,16         ;
        MOV     DH,5          ;
STAda2: INC     DH            ; Terza Colonna
        MOV     DL,42         ;
        CALL    Riga          ;
        LOOP    STAda2        ;
        MOV     CX,16         ;
        MOV     DH,5          ;
STAda3: INC     DH            ; Quarta Colonna
        MOV     DL,62         ;
        CALL    Riga          ;
        LOOP    STAda3        ;
        CALL    KEYwait       ;
        POP     CX            ;
        RET                   ;


;*****************************************************************************
                              ; ----------------------------------------------
B10_1017 proc   NEAR          ;      AREA DEDICATA AL MAIN PROGRAM
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
       ;/--------------------------------------------------------------------\
       ;|Nei MODI TESTO sono usati solo i primi 64  Registri  di  Colore  del|
       ;|DAC; poich l'uso di MODI GRAFICI prima di questa prova  carica  nei|
       ;|192 Registri successivi ai primi 64 valori diversi da  00H, presente|
       ;|nella norma, al fine di evitare la visualizzazione di dati scorretti|
       ;|il loro contenuto viene forzato prevenivamente a questo valore.     |
       ;\--------------------------------------------------------------------/
        PUSH    ES            ; Comincia dal Registro N64 e provvede  ad  az-
        MOV     AX,CS         ; zerare i 64*3=192 registri successivi
        MOV     ES,AX         ;
        LEA     DX,TabCo1     ; La funzione BIOS aggiorna il contenuto  di  CX
        MOV     CX,192        ; Registri di Colore del DAC del Video a partire
        MOV     BX,64         ; da quello di ordine BX   viene  qui  usata per
        MOV     AL,12H        ; forzare a zero tutti i Registri DAC a  partire
        MOV     AH,10H        ; dal sessantaquattresimo,  dato  che  le  terne
        INT     10H           ; predisposte in ciascun Registro,  appartenenti
        POP     ES            ; alla Tabella puntata da ES:DX sono tutte nulle
        MOV     AL,03H        ;/-------------------*------*-----*----*-------\
        MOV     AH,00H        ;|MODO TESTO STANDARD|AL=03H|80x25|8x16|640x400|
        INT     10H           ;|-------------------*------*-----*----*-------/
        CALL    VIA_cur       ; /--------------------------------------------\
        MOV     DH,03         ; |                                            |
        M_msgC  Corn0,DH,1,0FH; |                                            |
        MOV     CX,3          ; |                                            |
XXX00:  M_msgN  Corn0         ; |                                            |
        LOOP    XXX00         ; |                                            |
        M_msgN  Corn0         ; |                                            |
        INC     DH            ; |                                            |
        M_msgC  Corn1,DH,1,0FH; |                                            |
        MOV     CX,3          ; |                                            |
XXX01:  M_msgN  Corn1         ; |                                            |
        LOOP    XXX01         ; |                                            |
        INC     DH            ; |                                            |
        M_msgC  Corn2,DH,1,0FH; |      Predispone le cornici di prova        |
        MOV     CX,3          ; |                                            |
XXX02:  M_msgN  Corn2         ; |                                            |
        LOOP    XXX02         ; |                                            |
        MOV     CX,16         ; |                                            |
XXX03:  PUSH    CX            ; |                                            |
        INC     DH            ; |            /------*---*---\               |
        M_msgC  Corn3,DH,1,0FH; |            |RegRos|Ver|Blu|               |
        MOV     CX,3          ; |            *------*---*---*               |
XXX04:  M_msgN  Corn3         ; |            |  H  H|  H|  H|               |
        LOOP    XXX04         ; |            \------*---*---/               |
        POP     CX            ; |                                            |
        LOOP    XXX03         ; |                                            |
        INC     DH            ; |                                            |
        M_msgC  Corn4,DH,1,0FH; |                                            |
        MOV     CX,3          ; |                                            |
XXX05:  M_msgN  Corn4         ; |                                            |
        LOOP    XXX05         ; *--------------------------------------------*
        M_msgC  Text0 ,1,1,1FH; |                                            |
        M_msgC  Out_0,24,1,1FH; |    Inizializza la pagina Video del test    |
        M_COLOR 9FH           ; |                    e                       |
        M_msgN Out_1          ; |    propone il Testo di presentazione       |
        M_COLOR 1FH           ; |                                            |
        M_msgN Out_2          ; \--------------------------------------------/
        PUSH    ES            ; /--------------------------------------------\
        MOV     AX,CS         ; |Lettura del Registri di Colore DAC corrente |
        MOV     ES,AX         ; \--------------------------------------------/
        LEA     DX,TabCol     ;
        MOV     CX,256        ; Funzione BIOS che legge  il  contenuto di  CX
        MOV     BX,0          ; Registri di Colore del DAC del Video a partire
        MOV     AL,17H        ; da quello di ordine BX; i valori sono  scritti
        MOV     AH,10H        ; in terne  Rosso-Verde-Blu  dentro  la  Tabella
        INT     10H           ; puntata da ES:DX, opportunamente predisposta
        POP     ES            ;
        LEA     DI,TabCol     ;
        MOV     BX,0          ;
        MOV     CX,4          ; Stampa completa dei Dati
XXX06:  CALL    STAdati       ;
        LOOP    XXX06         ;
_OUT:   M_msgC Text1,24,1,0FH ;
        MOV     CX,06         ;                                              |
XXX07:  M_msgN  Text1         ;                                              |
        LOOP    XXX07         ;                                              |
        CALL    RIP_cur       ;                                              |
        MOV     DH,23         ;     FASE STANDARD D'USCITA DAL PROGRAMMA     |
        MOV     DL,0          ;                                              |
        CALL    SET_cur       ;                                              |
        MOV     AH,4CH        ;                                              |
        INT     21H           ;


B10_1017 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
