PAGE 66,132
TITLE ** B10_101B.ASM - Trasforma colori in scala di grigi
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_101B.ASM                         (INT 10H, Funzione 10H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Prova l'INT 10H,  Funzione  10H (SottoFunzione 1BH); il pro-|
;|               gramma stampa le 16 terne  contenute  nei  primi Registri di|
;|               Colore del DAC  PRIMA  dell'azione della SottoFunzione sotto|
;|               test  e  le  16  terne forzate nei  medesimi  registri  DOPO|
;|               l'azione della SottoFunzione 1BH.                           |
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC
   
STAbyt  MACRO   Colonna       ;
        PUSH    DX            ;
        PUSH    AX            ;
        MOV     DL,Colonna    ; Macro personale del Programma che organizza
        CALL    SET_cur       ; la stampa di uno dei bytes della  terna  di
        CALL    Byt2Asc       ; colori contenuta in un Registro DAC, passa-
        MOV     AL,"H"        ; to il AL, sulla riga DH corrente
        CALL    BIOchr1       ;
        POP     AX            ;
        POP     DX            ;
        ENDM                  ;

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CAMBIAcol:NEAR
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   Byt2Asc:NEAR
        EXTRN   BIOchr1:NEAR
        EXTRN   KEYwait:NEAR
        PUBLIC  ATTRIB        ;Attributo di colore


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_101B


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
TabCol DB   16*3 dup (00H)    ;Prime 16 Terne, Componenti RVB, Rosso-Verde-Blu
DepoDH DB   00H               ; Deposito temporaneo  per  la  terna  associata
DepoCH DB   00H               ; al contenuto del Registro  di Colore  del  DAC
DepoCL DB   00H               ; corrente   (CH=Verde,  CL=Blu  e  DH=Rosso)
ATTRIB DB   00H
Out_0  DB "                    Premere  "                                ,00H
Out_1  DB                              "un tasto"                        ,00H
Out_2  DB                     "  per il Calcolo dei Grigi              " ,00H
Out_3  DB                     "  per tornare al DOS                    " ,00H
Text0  DB "      Lettura dei Primi 16 Registri di Colore DAC a LIVELLO BIOS"
Text1  DB                                  "             "               ,00H
Corn0  DB "Ŀ",00H
Corn1  DB " NGradaz.ColoreGradaz.Grigio         VERIFICA          ",00H
Corn2  DB "Ĵ",00H
Corn3  DB "  H                          0.30*   +0.59*   +0.11*    ",00H
Corn4  DB "",00H


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : LeggiDAC                                                    |
;| DESCRIZIONE : Assume nei registri CH(Verde), CL(Blu) e DH(Rosso)  le   tre|
;|               gradazioni RBG del Registro di Colore del DAC puntato in in-|
;|               gresso da BL e le lascia nelle tre variabili interne  a  ci|
;|               dedicate [DepoDH] (Rosso), [DepoCH] (Verde) e [DepoCL] (Blu)|
;\---------------------------------------------------------------------------/
LeggiDAC:PUSH   DX            ;
        MOV     BH,00H        ;
        MOV     AL,15H        ; DH=Rosso
        MOV     AH,10H        ; CH=Verde
        INT     10H           ; CL=Blu
        MOV     CS:[DepoDH],DH;
        MOV     CS:[DepoCH],CH;
        MOV     CS:[DepoCL],CL;
        POP     DX            ;
        RET

;/---------------------------------------------------------------------------\
;| PROCEDURA   : STAcolor                                                    |
;| DESCRIZIONE : Visualizza un blocco di 16 terne di  Dati  prelevandoli  dai|
;|               Registri di Colore DAC correnti.                            |
;\---------------------------------------------------------------------------/
STAcolor:MOV    CX,16         ;
        MOV     DH,5          ;
STAco0: PUSH    CX            ;
        MOV     DL,8          ;
        INC     DH            ;
        CALL    SET_cur       ;
        M_COLOR 0FH           ; Stampa  il  tratto  di  cornice  orizzontale
        LEA     SI,Corn3      ;
        CALL    BIOSmsg       ;
        M_COLOR 0EH           ;
        INC     DL            ;
        CALL    SET_cur       ; BL=Numero del Registro di Colore DAC corrente
        MOV     AL,BL         ;
        CALL    Byt2Asc       ;
        CALL    LeggiDAC      ; Restituisce nelle variabili interne [DepoCH],
        CALL    STAcol        ; [DepoDH] e [DepoCL] le tre gradazioni DAC
                              ; e le stampa al posto giusto
        POP     CX            ;
        INC     BL            ; Punta il prossimo Registro di Tavolozza e
        LOOP    STAco0        ; prosegue l'indagine
        INC     DH            ;
        RET                   ;
       ;----------------------- ---------------------------------------------
STAcol: M_COLOR 4FH           ; ----------\
        MOV     AL,CS:[DepoDH];           |
        M_COLOR 0CH           ; DH=Rosso  |
        STAbyt  14            ;           |
        STAbyt  46            ;           |
        MOV     AL,CS:[DepoCH];           |
        M_COLOR 0AH           ; CH=Verde  |Stampa le tre gradazioni
        STAbyt  18            ;           |
        STAbyt  55            ;           |
        MOV     AL,CS:[DepoCL];           |
        M_COLOR 09H           ; CL=Blu    |
        STAbyt  22            ;           |
        STAbyt  64            ; ----------/
        RET                   ;

;/---------------------------------------------------------------------------\
;| PROCEDURA   : STAgrigi                                                    |
;| DESCRIZIONE : Visualizza un blocco di 16 terne di  Dati  prelevandoli  dai|
;|               Registri di Colore DAC correnti.                            |
;\---------------------------------------------------------------------------/
STAgrigi:MOV    CX,16         ;
        MOV     DH,5          ;
STAgr0: PUSH    CX            ;
        INC     DH            ;
        CALL    LeggiDAC      ; Restituisce nelle variabili interne [DepoCH],
        M_COLOR 7FH           ; DH=Rosso=[DepoDH]
        MOV     AL,CS:[DepoDH];
        STAbyt  28            ;
        MOV     AL,CS:[DepoCH]; CH=Verde=[DepoCH]
        STAbyt  32            ;
        MOV     AL,CS:[DepoCL]; CL= Blu =[DepoCL]
        STAbyt  36            ;
        POP     CX            ;
        INC     BL            ;
        LOOP    STAgr0        ;
        RET                   ;


;*****************************************************************************
                              ; ----------------------------------------------
B10_101B proc   NEAR          ;|      AREA DEDICATA AL MAIN PROGRAM         ||
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        MOV     CH,00         ; /--------------------------------------------\
        MOV     CL,00         ; |                                            |
        MOV     DH,24         ; |Produce un ClearScreen con aiuto della  Fun-|
        MOV     DL,79         ; |zione 06H dell'INT 10H BIOS (NB:CH=RigaAlto,|
        MOV     BH,0FH        ; |CL=ColnAlto,  DH=RigaBass,  DL=ColnBass, BH=|
        MOV     AL,00         ; |BH=Colore e AL=0 (scorrere  TUTTE  le  righe|
        MOV     AH,06H        ; |dello schermo)                              |
        INT     10H           ; |                                            |
        CALL    VIA_cur       ; *--------------------------------------------*
        M_msgC  Text0 ,1,1,2FH; |                                            |
        M_msgC  Out_0,24,1,2FH; |    Inizializza la pagina Video del test    |
        M_COLOR 0AFH          ; |                    e                       |
        M_msgN Out_1          ; |    propone il Testo di presentazione       |
        M_COLOR 2FH           ; |                                            |
        M_msgN Out_2          ; \--------------------------------------------/
        M_msgC  Corn0, 3,8,0FH; /--------------------------------------------\
        M_msgC  Corn1, 4,8,0FH; |                                            |
        M_msgC  Corn2, 5,8,0FH; |      Predispone la cornice  di  prova      |
        MOV     BL,00H        ; |      e organizza la  stampa  completa      |
        CALL    STAcolor      ; |      dei dati in condizioni di colore      |
        M_msgC  Corn4,DH,8,0FH; |                                            |
        CALL    KEYwait       ; \--------------------------------------------/
                              ; Con AL=1BH trasforma il  valore  contenuto  in
                              ; CX Registri di Colore del  DAC (il  primo  dei
                              ; quali  indicato da  BX)  nel  valore "pesato"
        MOV     BX,0000H      ; equivalente della Scala dei Grigi:  in pratica
        MOV     CX,16         ; ciascun valore trovato viene trasformato in un
        MOV     AL,1BH        ; altro ottenuto dalla somma del 30% della  com-
        MOV     AH,10H        ; ponente Rosso pi il 59% della componente Ver-
        INT     10H           ; de  pi l'11% della componente Blu, sostituen-
                              ; do le tre componenti RVB  originali (che  ver-
                              ; ranno quindi perdute) con le nuove
                              ; /--------------------------------------------\
        M_msgC Out_3,24,40,2FH; |                                            |
        MOV     BL,00H        ; |   Seconda fase: analisi con Grigi          |
        CALL    STAgrigi      ; |                                            |
        CALL    KEYwait       ; \--------------------------------------------/

        MOV     BL,33H        ;
        MOV     AL,01H;disabil; Disabilita (AL=00H) il calcolo della Scala dei
        MOV     AH,12H        ; Grigi; l'azione si fa sentire quando si cambia
        INT     10H           ; il MODO VIDEO corrente (Funzione 00H, INT 10H)
        MOV     AL,83H        ;/-------------------*------*-----*----*-------\
        MOV     AH,00H        ;|MODO TESTO STANDARD|AL=03H|80x25|8x16|640x400|
        INT     10H           ;\-------------------*------*-----*----*-------/
        MOV     AH,4CH
        INT     21H
_OUT:   M_msgC Text1,24,1,0FH ;
        MOV     CX,06         ;
XXX03:  M_msgN  Text1         ;
        LOOP    XXX03  

        PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;

B10_101B ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare

                    ;/-------------------------------------------------------\
                    ;| Calcolo Grigio  =  30% Rosso + 59% Verde + 11% Blu    |
                    ;*-------*-------------------------*---------------*-----*
Grigi DB 00H,00H,00H;|Nero   |0.3*00H+0.59*00H+0.11*00H|  0 +  0  +  0 | 0.00|
      DB 05H,05H,05H;|Blu    |0.3*00H+0.59*00H+0.11*2AH|  0 +  0  +4.62| 4.62|
      DB 19H,19H,19H;|Verde  |0.3*00H+0.59*2AH+0.11*00H|  0 +24.78+  0 |24.78|
      DB 1DH,1DH,1DH;|Azzurro|0.3*00H+0.59*2AH+0.11*2AH|  0 +24.78+4.62|29.40|
      DB 0DH,0DH,0DH;|Rosso  |0.3*2AH+0.59*00H+0.11*00H|12.6+  0  +  0 |12.60|
      DB 11H,11H,11H;|Magenta|0.3*2AH+0.59*00H+0.11*2AH|12.6+  0  +4.62|17.22|
      DB 25H,25H,25H;|Marrone|0.3*2AH+0.59*2AH+0.11*00H|12.6+24.78+  0 |37.38|
      DB 2AH,2AH,2AH;|Bianco |0.3*2AH+0.59*2AH+0.11*2AH|12.6+24.78+4.62|42.00|
                    ;*-------*-------------------------*---------------*-----*
      DB 02H,02H,02H;|Grigio |0.3*00H+0.59*00H+0.11*15H|  0 +  0  +2.31| 2.31|
      DB 07H,07H,07H;|Blu El.|0.3*00H+0.59*00H+0.11*3FH|  0 +  0  +6.93| 6.93|
      DB 1BH,1BH,1BH;|Verde  |0.3*00H+0.59*2AH+0.11*15H|  0 +24.78+2.31|27.09|
      DB 20H,20H,20H;|Celeste|0.3*00H+0.59*2AH+0.11*3FH|  0 +24.78+6.93|31.71|
      DB 0FH,0FH,0FH;|Rosa   |0.3*2AH+0.59*00H+0.11*15H|12.6+  0  +2.31|14.91|
      DB 14H,14H,14H;|Magenta|0.3*2AH+0.59*00H+0.11*3FH|12.6+  0  +6.93|19.53|
      DB 28H,28H,28H;|Giallo |0.3*2AH+0.59*2AH+0.11*15H|12.6+24.78+2.31|39.69|
      DB 2CH,2CH,2CH;|Bianco |0.3*2AH+0.59*2AH+0.11*3FH|12.6+24.78+6.93|44.31|
                    ;\-------*-------------------------*---------------*-----/

