PAGE 66,132
TITLE ** B10_1103.ASM - Programma per la gestione della stampa  con  due  SET
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1103.ASM                         (INT 10H, Funzione 11H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Verifica la SottoFunzione 03H per autorizzare sullo  schermo|
;|               l'uso CONTEMPORANEO di due diversi FONT  di  caratteri;  per|
;|               questo le prime tre Tabelle VGA da 256 caratteri (nel  Terzo|
;|               Piano di Bit controllato dal GENERATORE di CARATTERI HARDWA-|
;|               RE) sono predisposte rispettivamente con i seguenti FONT:   |
;|               Tabella 00H (Offset 0000H): FONT 8*14 di default            |
;|               Tabella 01H (Offset 2000H): FONT 8*16 di default            |
;|               Tabella 02H (Offset 4000H): FONT 8*8 (DOUBLE-DOT) di default|
;|               Tabella 03H (Offset 6000H):  nessuna predisposizione  |
;|               Tabella 04H (Offset 8000H):  nessuna predisposizione  |
;|               Tabella 05H (Offset A000H):  nessuna predisposizione  |
;|               Tabella 06H (Offset C000H):  nessuna predisposizione  |
;|               Tabella 07H (Offset E000H):  nessuna predisposizione  |
;|                                                                           |
;|               La prova viene condotta DUE  volte  per  mostrare  l'effetto|
;|               prodotto dal controllo esercitato sul bit3 del Codice  d'At-|
;|               tributo per autorizzare o  meno  l'evidenziatura  sui  testi|
;|               stampati con il secondo SET di CARATTERI.                   |
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CambiaCol:NEAR ;usata da M_COLOR
        EXTRN   SET_cur:NEAR ;usata da M_CURSOR.MAC
        EXTRN   KEYwait:NEAR
        EXTRN   BIOSmsg:NEAR
        PUBLIC  ATTRIB       ;Attributo di colore

;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_1103


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
TESTO1  DB " Testo relativo al  PRIMO  SET di CARATTERI ",00H
TESTO2  DB " Testo relativo al SECONDO SET di CARATTERI ",00H
ATTRIB  DB 00H                ;Attributo di Colore


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : SetFONT                                                     |
;| DESCRIZIONE : Cancella l'immagine attualmente posta a video e  poi  attiva|
;|               una o due Tabelle con la configurazione di 256 caratteri ap-|
;|               partenenti a uno o due SET, in funzione del valore  presente|
;|               in ingresso in BL; ci fatto stampa i due messaggi di  prova|
;|               e rimane in attesa della pressione di un tasto qualunque.   |
;\---------------------------------------------------------------------------/
SetFONT:PUSH    BX
        MOV     CH,00         ;
        MOV     CL,00         ;
        MOV     DH,24         ; Produce un ClearScerre con aiuto della Funzio-
        MOV     DL,79         ; ne 06H dell'INT 10H BIOS (NB:CH=RigaAlto,  CL=
        MOV     BH,0FH        ; =ColnAlto, DH=RigaBass, DL=ColnBass, BH=Colore
        MOV     AL,00         ; e AL=0 (scorrere TUTTE le righe dello schermo)
        MOV     AH,06H        ;
        INT     10H           ;
        POP     BX
        MOV     AL,03H        ; SottoFunzione che consente (nei MODI TESTO) di
        MOV     AH,11H        ; attivare i SET di caratteri corrispondenti al-
        INT     10H           ; la codifica suggerita in ingresso in BL
       M_msgC TESTO1,10,10,06H; ---------------------------------------------
       M_msgC TESTO2,12,10,0EH; Mostra Messaggi e rimane in attesadi un tasto
        CALL    KEYwait       ; ---------------------------------------------
        RET

;/---------------------------------------------------------------------------\
;| PROCEDURA   : Prova                                                       |
;| DESCRIZIONE : Esegue effettivamente la Prova  desiderata  presentando  tre|
;|               situazioni consecutive, nelle quali sono attivi DUE SET CON-|
;|               TEMPORANEAMENTE attivati con il bit3 del Codice d'Attributo:|
;|                                                                           |
;|               1) bit3=0 Caratteri FONT 8*14 estratti dalla  Prima  Tabella|
;|                  bit3=1 Caratteri FONT 8*16 estratti dalla Seconda Tabella|
;|                                                                           |
;|               2) bit3=0 Caratteri FONT 8*16 estratti dalla Seconda Tabella|
;|                  bit3=1 Caratteri FONT 8*8 (DD) estratti dalla Terza Tab. |
;|                                                                           |
;|               3) bit3=0 Caratteri FONT 8*14 estratti dalla  Prima  Tabella|
;|                  bit3=1 Caratteri FONT 8*8 (DD) estratti dalla Terza Tab. |
;\---------------------------------------------------------------------------/
Prova:;/----------------\/--*--\/--*--*--\/--*--*--\ /--*--*--*--*--*--*--*--\
      ;|                ||b7|b6||b5|b3|b2||b4|b1|b0| |b7|b6|b5|b4|b3|b2|b1|b0|
        MOV   BL,04H   ;|*--*--**--*--*--**--*--*--*=*--*--*--*--*--*--*--*--*
      ;|                ||0 |0 ||0  0  1 ||0  0  0 | |0 |0 |0 |0 |0 |1 |0 |0 |
      ;\----------------/\--*--/\--------/\--------/ \--*--\--*--*--*--*--*--/
                              ; Attiva CONTEMPORANEAMENTE DUE SET di caratteri
                              ; specificati da BL, corrispondenti  alla  prima
                              ; e seconda Tabella nella RAM del Generatore VGA
        CALL    SetFONT       ; /--------------------------------------------\
                              ; | Prima  Tabella: 8*14 di default            |
                              ; |Seconda Tabella: 8*16 di default            |
                              ; \--------------------------------------------/
      ;/----------------\/--*--\/--*--*--\/--*--*--\ /--*--*--*--*--*--*--*--\
      ;|                ||b7|b6||b5|b3|b2||b4|b1|b0| |b7|b6|b5|b4|b3|b2|b1|b0|
        MOV     BL,09H ;|*--*--**--*--*--**--*--*--*=*--*--*--*--*--*--*--*--*
      ;|                ||0 |0 ||0  1  0 ||0  0  1 | |0 |0 |0 |0 |1 |0 |0 |1 |
      ;\----------------/\--*--/\--------/\--------/ \--*--\--*--*--*--*--*--/
                              ; Attiva CONTEMPORANEAMENTE DUE SET di caratteri
                              ; specificati da BL, corrispondenti alla seconda
                              ; e  terza  Tabella nella RAM del Generatore VGA
        CALL    SetFONT       ; /--------------------------------------------\
                              ; |Seconda Tabella: 8*16 di default            |
                              ; | Terza  Tabella: 8*8(DOUBLE-DOT) di default |
                              ; \--------------------------------------------/

      ;/----------------\/--*--\/--*--*--\/--*--*--\ /--*--*--*--*--*--*--*--\
      ;|                ||b7|b6||b5|b3|b2||b4|b1|b0| |b7|b6|b5|b4|b3|b2|b1|b0|
        MOV   BL,08H   ;|*--*--**--*--*--**--*--*--*=*--*--*--*--*--*--*--*--*
      ;|                ||0 |0 ||0  1  0 ||0  0  0 | |0 |0 |0 |0 |1 |0 |0 |0 |
      ;\----------------/\--*--/\--------/\--------/ \--*--\--*--*--*--*--*--/
                              ; Attiva CONTEMPORANEAMENTE DUE SET di caratteri
                              ; specificati da BL, corrispondenti  alla  prima
                              ; e  terza  Tabella nella RAM del Generatore VGA
        CALL    SetFONT       ; /--------------------------------------------\
                              ; | Prima  Tabella: 8*14 di default            |
                              ; | Terza  Tabella: 8*8(DOUBLE-DOT) di default |
        RET                   ; \--------------------------------------------/


;*****************************************************************************
                              ; ----------------------------------------------
B10_1103 proc   NEAR          ;      AREA DEDICATA AL MAIN PROGRAM         ||
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
                              ;/---------------------------------------------\
                              ;|Predispone i tre FONT nelle Tabelle VGA      |
                              ;\---------------------------------------------/
        MOV     BL,00H ;TabRAM; SottoFunzione che consente (nei MODI TESTO) di
        MOV     AL,01H ;8*14  ; caricare la Tabella 8*14 di default; il numero
        MOV     AH,11H        ; della Tabella nella RAM del Generatore   pas-
        INT     10H           ; sato in BL=TabRAM=00H (prima Tabella)
                              ; ----------------------------------------------
        MOV     BL,01H ;TabRAM; SottoFunzione che consente (nei MODI TESTO) di
        MOV     AL,04H ;8*16  ; caricare la Tabella 8*16 di default; il numero
        MOV     AH,11H        ; della Tabella nella RAM del Generatore   pas-
        INT     10H           ; sato in BL=TabRAM=01H (seconda Tabella)
                              ; ----------------------------------------------
        MOV     BL,02H ;TabRAM; SottoFunzione che consente (nei MODI TESTO) di
        MOV     AL,02H ;8*8   ; caricare la Tabella 8*8 (DOUBLE-DOT);il numero
        MOV     AH,11H        ; della Tabella nella RAM del Generatore   pas-
        INT     10H           ; sato in BL=TabRAM=02H (terza Tabella)
                              ;/---------------------------------------------\
                              ;|Prima Prova:bit3 "evidenziatore" DISABILITATO|
                              ;\---------------------------------------------/
                              ; Predispone i bit3bit0 del Registro d'abilita-
        MOV     BL,12H;NumReg ; zione del Piano Colore del Controller d'Attri-
        MOV     BH,07H;DatoReg; buto dell'Adattatore Video (puntato in ingres-
        MOV     AL,00H;SottoF ; so da BL=12H) con un valore adatto a DISABILI-
        MOV     AH,10H;Funzion; TARE l'azione di "evidenziamento" prodotta dal
        INT     10H           ; bit3 del codice d'Attributo dei Caratteri, co-
                              ; piandovi il valore di BH=07H, appunto 00000111
                              ; Esegue la  Prova  presentando  tre  situazioni
                              ; consecutive nelle quali sono attivi  DUE  FONT
                              ; CONTEMPORANEAMENTE, attivati  con il bit3  del
        ;/-------------------\; Codice d'Attributo dei Caratteri coinvolti:
        ;|                   |;  /------*------------------------------------\
        ;| bit3 DISABILITATO |; 1|bit3=0|FONT 8*14    (dalla  Prima  Tabella)|
        ;|                   |;  |bit3=1|FONT 8*16    (dalla Seconda Tabella)|
        ;\-------------------/;  *------*------------------------------------*
                              ; 2|bit3=0|FONT 8*16    (dalla Seconda Tabella)|
                              ;  |bit3=1|FONT 8*8 (DD)(dalla  Terza  Tabella)|
        CALL    Prova         ;  *------*------------------------------------*
                              ; 3|bit3=0|FONT 8*14    (dalla  Prima  Tabella)|
                              ;  |bit3=1|FONT 8*8 (DD)(dalla  Terza  Tabella)|
                              ;  \------*------------------------------------/
                              ; ---------------------------------------------\
                              ; Seconda Prova: bit3 "evidenziatore" ABILITATO|
                              ; ---------------------------------------------/
                              ; Predispone i bit3bit0 del Registro d'abilita-
        MOV     BL,12H;NumReg ; zione del Piano Colore del Controller d'Attri-
        MOV     BH,0FH;DatoReg; buto dell'Adattatore Video (puntato in ingres-
        MOV     AL,00H;SottoF ; so da BL=12H) con un valore adatto a  RIABILI-
        MOV     AH,10H;Funzion; TARE l'azione di "evidenziamento" prodotta dal
        INT     10H           ; bit3 del codice d'Attributo dei Caratteri, co-
                              ; piandovi il valore di BH=0FH, appunto 00001111
                              ; Esegue la  Prova  presentando  tre  situazioni
                              ; consecutive nelle quali sono attivi  DUE  FONT
                              ; CONTEMPORANEAMENTE, attivati  con il bit3  del
        ;/-------------------\; Codice d'Attributo dei Caratteri coinvolti:
        ;|                   |;  /------*------------------------------------\
        ;| bit3  RIABILITATO |; 1|bit3=0|FONT 8*14    (dalla  Prima  Tabella)|
        ;|                   |;  |bit3=1|FONT 8*16    (dalla Seconda Tabella)|
        ;\-------------------/;  *------*------------------------------------*
                              ; 2|bit3=0|FONT 8*16    (dalla Seconda Tabella)|
                              ;  |bit3=1|FONT 8*8 (DD)(dalla  Terza  Tabella)|
        CALL    Prova         ;  *------*------------------------------------*
                              ; 3|bit3=0|FONT 8*14    (dalla  Prima  Tabella)|
                              ;  |bit3=1|FONT 8*8 (DD)(dalla  Terza  Tabella)|
                              ;  \------*------------------------------------/
                              ;/---------------------------------------------\
                              ;| Fase Finale: Ripristino condizioni iniziali |
                              ;\---------------------------------------------/
      ;/----------------\/--*--\/--*--*--\/--*--*--\ /--*--*--*--*--*--*--*--\
      ;|                ||b7|b6||b5|b3|b2||b4|b1|b0| |b7|b6|b5|b4|b3|b2|b1|b0|
        MOV   BL,05H   ;|*--*--**--*--*--**--*--*--*=*--*--*--*--*--*--*--*--*
      ;|                ||0 |0 ||0  0  1 ||0  0  1 | |0 |0 |0 |0 |0 |1 |0 |1 |
      ;\----------------/\--*--/\--------/\--------/ \--*--\--*--*--*--*--*--/
                              ; Ripristina le condizioni d'ingresso  attivando
                              ; UN SOLO SET di caratteri, cio specificando in
                              ; BL un codice che punti comunque SOLO alla  se-
        CALL    SetFONT       ; conda Tabella nella RAM del Generatore VGA
                              ; /--------------------------------------------\
                              ; |Seconda Tabella: 8*16 di default            |
                              ; \--------------------------------------------/

        MOV     AH,4CH        ; Torna al DOS con la memoria liberata e con la
        INT     21H           ; chiusura di tutti i file

B10_1103 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
