PAGE 66,132
TITLE ** B10_1110.ASM - Caricatore di FONT predisposto direttamente nel progr.
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1110.ASM                         (INT 10H, Funzione 11H)|
;|                               /------------------------------------------\|
;| AUTORE      : Giorgio OBER    | Predispone SOLO alcuni caratteri ESTESI  ||
;| VERSIONE    : gennaio 1997    \------------------------------------------/|
;| DESCRIZIONE : Organizza il caricamento di alcuni CARATTERI ESTESI, assunti|
;|               da una TABELLA contenente i valori esadecimali corrisponden-|
;|               ti alle sequenze di 16 bytes di ciascun carattere), natural-|
;|               mente in MODO TESTO,  collocandoli dentro la  Prima  Tabella|
;|               gestita dal GENERATORE HARDWARE di CARATTERI.               |
;\---------------------------------------------------------------------------/
;/---------------------------------------------------------------------------\
;| NB:        Taluni moderni adattatori VGA nel MODO 03H TESTO standard 80*25|
;|            usano una "matrice di punti" 9*16 per proporre i Caratteri  sul|
;|            video (cio con risoluzione 80x25, 720x400, o 40x25, 360x400 in|
;|            MODO 01H); il nono bit (non presente nel  SET  sorgente)  VIENE|
;|            AGGIUNTO AUTOMATICAMENTE dal GENERATORE di  CARATTERI  HARDWARE|
;|            INTERNO alla destra dei normali otto Pixel  di  ogni  linea  di|
;|            scansione, con l'attributo dello sfondo (praticamente  una  co-|
;|            lonna invisibile) per TUTTI i caratteri ESCLUSI gli  ESTESI  da|
;|            C0H (=192="\") a DFH (=223=""), per i  quali  viene  duplicato|
;|            l'ottavo Pixel.                                                |
;|                                                                           |
;|            Questo programma sostituisce cinque ASCII ESTESI  per  dare  la|
;|            possibilit di inserire nei testi un piccolo Logo;  quindi  per|
;|            vederlo esattamente come ne disegno qui sotto riportato  ASSO-|
;|            LUTAMENTE NECESSARIO scegliere i sostituendi  tra  i  caratteri|
;|            ora indicati (C0HDFH),  possibilmente  evitando  di  eliminare|
;|            quelli che servono a creare le cornici, sempre molto utili; con|
;|            una diversa scelta avremo la delusione di vedere il nostro logo|
;|            stampato "a segmenti", cio con ciascun carattere  separato  da|
;|            una fastidiosa breve strisciolina vuota (il famoso nono bit la-|
;|            sciato spento). Per verificare questo disagio provare  a sosti-|
;|            tuire l'operando ~220~  con ~128~ nell'istruzione ~MOV  DX,220~|
;|            a livello dell'etichetta  ~Cambia~,  e  sostituire  la  stringa|
;|            DEMO_01 con la seguente ~ DB "",00H ~ (gi predisposta).  |
;| ------------------------------------------------------------------------- |
; Ŀ           ĿDĿDĿDĿDĿD 
;  Byte 00    
; ర Byte 02   ۱ 
;  Byte 03   ۰۱ 
;               Byte 04   ۰۱ 
;  EFFETTO  A   Byte 05   ۰۱ 
;  VIDEO   SU   Byte 06   ۰۰۰۰۰۰۱ 
;  SCHEDE  CHE  Byte 07   ۰۰۰۰۰۰۰۰۰۱ 
;  DUPLICANO    Byte 08   ۰۰۰۰۰۰۰۰۱ 
;  L'OTTAVO     Byte 09   ۰۰۰۰۰۰۰۰۱ 
;  BIT DI OGNI  Byte 10   ۰۰۰۰۰۰۰۰۰۱ 
;  LINEA   DI   Byte 11   ۰۰۰۰۰۰۱ 
;  PIXEL   DEL  Byte 12   ۰۱ 
;  CARATTERE    Byte 13   ۰۱ 
;               Byte 14   ۰۱ 
;  Byte 15   ۱ 
;  Byte 16    
;            99999 
;            12345678 12345678 12345678 12345678 12345678  
; ------------------------------------------------------------------------- 
; Ŀ             ĿĿĿĿĿ    
;  Byte 00         
; ర Byte 02         
;  Byte 03     ۰    
;               Byte 04     ۰    
;  EFFETTO  A   Byte 05     ۰    
;  VIDEO   SU   Byte 06     ۰۰۰۰۰۰    
;  SCHEDE  CHE  Byte 07     ۰۰۰۰۰۰۰۰۰    
; NON DUPLICANO Byte 08     ۰۰۰۰۰۰۰۰    
;  L'OTTAVO     Byte 09     ۰۰۰۰۰۰۰۰    
;  BIT DI OGNI  Byte 10     ۰۰۰۰۰۰۰۰۰    
;  LINEA   DI   Byte 11     ۰۰۰۰۰۰    
;  PIXEL   DEL  Byte 12     ۰    
;  CARATTERE    Byte 13     ۰    
;               Byte 14     ۰    
;  Byte 15         
;  Byte 16         
;                  
;              1234567812345678123456781234567812345678    
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CambiaCol:NEAR
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   KEYwait:NEAR

; DICHIARAZIONI PER I PROGRAMMI ESTERNI:
        PUBLIC  ATTRIB
        PUBLIC  B10_1110


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog

        ORG     0100H
INIZIO: JMP     B10_1110


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB  DB 0FH
COPYrt1 DB "Ŀ",00H
COPYrt2 DB "                                                             ",00H
COPYrt3 DB "",00H
COPYrt4 DB   "B10_1110 - Caricatore di CARATTERI ASCII ESTESI MODO TESTO"   ,00H
COPYrt5 DB    "vers.2.0                           by ing. Giorgio OBER"     ,00H
COPYrt6 DB    "    I nuovi caratteri sono regolarmente disponibili"         ,00H
DEMO_01 DB                       ""                                    ,00H
;DEMO_01 DB                      ""                                    ,00H
;Stringa per la prova con caratteri rimappati a partire dal 128.mo


;*****************************************************************************
                              ; ----------------------------------------------
B10_1110 proc  NEAR           ;        AREA DEDICATA AL MAIN PROGRAM  
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        MOV     AL,03H        ;/[ Con  ClearScreen]*------*-----*----*-------\
        MOV     AH,00H        ;|MODO TESTO STANDARD|AL=03H|80x25|8x16|640x400|
        INT     10H           ;\-------------------*------*-----*----*-------/
        CALL    VIA_cur       ; Rende il  cursore invisibile
                              ;/---------------------------------------------\
                              ;|   CARICA  I   NUOVI  CARATTERI  ORIGINALI   |
                              ;\---------------------------------------------/
        PUSH    ES            ; Predispone il segmento ES a  puntare  la  zona
        PUSH    CS            ; dei nostri dati, a beneficio della  successiva
        POP     ES            ; operazione di trasferimento  TABELLA caratteri
        LEA     BP,FontBUF    ; Carica la TABELLA di definizione dei caratteri
Cambia: MOV     DX,220 ;  "" ; preparati dall'utente all'indirizzo ES:BP nel-
        MOV     CX,5          ; la Prima Tabella dei FONT del GENERATORE HARD-
        MOV     BH,16         ; WARE (BL=0) in RAM; in BH  posto il desidera-
        MOV     BL,00H        ; to Numero di Bytes per carattere (16)  e in CX
        MOV     AL,10H        ; il Numero di caratteri definiti in  TABELLA  e
        MOV     AH,11H        ; quindi da caricare in Tabella  a  partire  dal
        INT     10H           ; carattere di numero DX; al posto del suo nume-
        POP     ES            ; ro  possibile specificare il suo valore ASCII
       M_msgC COPYrt1,1,10,0EH; ---------------------------------------------
       M_msgC COPYrt2,2,10,0EH;
       M_msgC COPYrt2,3,10,0EH; Organizza il piano di presentazione
       M_msgC COPYrt3,4,10,0EH;
       M_msgC COPYrt4,2,13,0FH;
       M_msgC COPYrt5,3,14,0FH; ---------------------------------------------
       M_msgC COPYrt6,6,14,0EH;I nuovi caratteri sono regolarmente disponibili
                              ; ---------------------------------------------
                              ; 
                              ; ۰
                              ; ۰۰۰۰۰۰
      M_msgC COPYrt1,10,10,0EH; ۰۰۰۰۰۰۰۰۰
      M_msgC COPYrt2,11,10,0EH; ۰۰۰۰۰۰۰۰
      M_msgC COPYrt3,12,10,0EH; ۰۰۰۰۰۰۰۰
      M_msgC DEMO_01,11,38,0FH; ۰۰۰۰۰۰۰۰۰
                              ; ۰۰۰۰۰۰
                              ; ۰
                              ; 
                              ; ---------------------------------------------
        CALL  KeyWait

_OUT:   PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;

                              ;/---------------------------------------------\
                              ;|        Creazione  dei  NUOVI  CARATTERI     |
                              ;\---------------------------------------------/
FontBUF DB    000H            ; 00000000    /-----------------------\
        DB    07FH            ; 01111111    |                       |
        DB    040H            ; 01000000  ۰  |        ""        |
        DB    040H            ; 01000000  ۰  |                       |
        DB    040H            ; 01000000  ۰  |                       |
        DB    047H            ; 01000111  ۰  |       CARATTERE       |
        DB    048H            ; 01001000  ۰۰  |         ASCII         |
        DB    048H            ; 01001000  ۰۰  |                       |
        DB    049H            ; 01001001  ۰۰  |         n 220        |
        DB    048H            ; 01001000  ۰۰  |         n DCH        |
        DB    047H            ; 01000111  ۰  |          /---\        |
        DB    040H            ; 01000000  ۰  |          |""|        |
        DB    040H            ; 01000000  ۰  |          \---/        |
        DB    040H            ; 01000000  ۰  |                       |
        DB    07FH            ; 01111111    \-----------------------/
        DB    000H            ; 00000000  questo  l'effetto a 9 bit
                                                   
        DB    000H            ; 00000000    /-----------------------\
        DB    0FFH            ; 11111111    |                       |
        DB    000H            ; 00000000    |        ""        |
        DB    000H            ; 00000000    |                       |
        DB    000H            ; 00000000    |                       |
        DB    00EH            ; 00001110  ۰  |       CARATTERE       |
        DB    084H            ; 10000100  ۰۰  |         ASCII         |
        DB    004H            ; 00000100  ۰  |                       |
        DB    084H            ; 10000100  ۰۰  |         n 221        |
        DB    084H            ; 10000100  ۰۰  |         n DDH        |
        DB    00EH            ; 00001110  ۰  |          /---\        |
        DB    000H            ; 00000000    |          |""|        |
        DB    000H            ; 00000000    |          \---/        |
        DB    000H            ; 00000000    |                       |
        DB    0FFH            ; 11111111    \-----------------------/
        DB    000H            ; 00000000  questo  l'effetto a 9 bit
                                                   
        DB    000H            ; 00000000    /-----------------------\
        DB    0FFH            ; 11111111    |                       |
        DB    000H            ; 00000000    |        ""        |
        DB    000H            ; 00000000    |                       |
        DB    000H            ; 00000000    |                       |
        DB    03CH            ; 00111100  ۰  |       CARATTERE       |
        DB    042H            ; 01000010  ۰۰  |         ASCII         |
        DB    042H            ; 01000010  ۰۰  |                       |
        DB    042H            ; 01000010  ۰۰  |         n 222        |
        DB    042H            ; 01000010  ۰۰  |         n DEH        |
        DB    03CH            ; 00111100  ۰  |          /---\        |
        DB    000H            ; 00000000    |          |""|        |
        DB    000H            ; 00000000    |          \---/        |
        DB    000H            ; 00000000    |                       |
        DB    0FFH            ; 11111111    \-----------------------/
        DB    000H            ; 00000000  questo  l'effetto a 9 bit
                                                   
        DB    000H            ; 00000000    /-----------------------\
        DB    0FFH            ; 11111111    |                       |
        DB    000H            ; 00000000    |        ""        |
        DB    000H            ; 00000000    |                       |
        DB    000H            ; 00000000    |                       |
        DB    07CH            ; 01111100  ۰  |       CARATTERE       |
        DB    042H            ; 01000010  ۰۰  |         ASCII         |
        DB    042H            ; 01000010  ۰۰  |                       |
        DB    07CH            ; 01111100  ۰  |         n 223        |
        DB    042H            ; 01000010  ۰۰  |         n DFH        |
        DB    07CH            ; 01111100  ۰  |          /---\        |
        DB    000H            ; 00000000    |          |""|        |
        DB    000H            ; 00000000    |          \---/        |
        DB    000H            ; 00000000    |                       |
        DB    0FFH            ; 11111111    \-----------------------/
        DB    000H            ; 00000000  questo  l'effetto a 9 bit
                                                   
        DB    000H            ; 00000000    /-----------------------\
        DB    0FFH            ; 11111111  ۱  |                       |
        DB    001H            ; 00000001  ۱  |        ""        |
        DB    001H            ; 00000001  ۱  |                       |
        DB    001H            ; 00000001  ۱  |                       |
        DB    079H            ; 01111001  ۰۱  |       CARATTERE       |
        DB    041H            ; 01000001  ۰۱  |         ASCII         |
        DB    041H            ; 01000001  ۰۱  |                       |
        DB    071H            ; 01110001  ۰۱  |         n 224        |
        DB    041H            ; 01000001  ۰۱  |         n E0H        |
        DB    079H            ; 01111001  ۰۱  |          /---\        |
        DB    001H            ; 00000001  ۱  |          |""|        |
        DB    001H            ; 00000001  ۱  |          \---/        |
        DB    001H            ; 00000001  ۱  |                       |
        DB    0FFH            ; 11111111  ۱  \-----------------------/
        DB    000H            ; 00000000  questo  l'effetto a 9 bit
                              ; [Questo carattere NON  duplica  l'ottavo  bit]
                              ; [perch  NON  appartiene  al gruppo (C0hDFH)]

B10_1110 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
