PAGE 66,132
TITLE ** B10_1123.ASM - Caricatore di FONT predisposto direttamente nel progr.
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1123.ASM                         (INT 10H, Funzione 11H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Organizza il caricamento della Tabella ROM BIOS 8*8 a doppio|
;|               punto di default per la definizione di 256 caratteri CGA.   |
;|                                                                           |
;|               Per rendere attivo il  nuovo  FONT   necessario indicare il|
;|               numero di Righe  di testo  che  possono  essere visualizzate|
;|               sullo schermo (con BL=00H tale numero va posto in DL).      |
;|                                                                           |
;|               Il FONT  "visto" dal GENERATORE SOFTWARE dei  MODI  GRAFICI|
;|               per il fatto che il suo  puntatore  poi copiato dalla  Sot-|
;|               toFunzione 22H nelle locazioni  della Tabella dei Vettori (a|
;|               partire dall'indirizzo 0000:010CH) corrispondenti a INT 43H.|
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CambiaCol:NEAR
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   KEYwait:NEAR

; DICHIARAZIONI PER I PROGRAMMI ESTERNI:
        PUBLIC  ATTRIB
        PUBLIC  B10_1123


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog

        ORG     0100H
INIZIO: JMP     B10_1123


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB DB 0FH
TESTO1 DB "Ŀ",00H
TESTO2 DB "                                                             ",00H
TESTO3 DB "",00H
TESTO4 DB  "B10_1123 - Caricatore FONT GRAFICO di default ROM BIOS  8*8"   ,00H
TESTO5 DB    "vers.2.0                           by ing. Giorgio OBER"     ,00H
TESTO6 DB    "    I nuovi caratteri sono regolarmente disponibili"         ,00H


;*****************************************************************************
                              ; ----------------------------------------------
B10_1123 proc  NEAR           ;|      AREA DEDICATA AL MAIN PROGRAM         ||
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        ;/[NB:]--------------\;\/--------*-----*----*-------*------------*---\
        ;|Naturalmente  per i|;||MODO 04H|40x25|8x8 |320x200| 4 colori   |CGA|
        ;|MODI a  40  colonne|;||MODO 05H|40x25|8x8 |320x200| 4 colori   |CGA|
        ;| necessario    ri-|;||MODO 0DH|40x25|8x8 |320x200|bianco/nero |EGA|
        ;|strutturare i testi|;||MODO 13H|40x25|8x8 |320x200|256 colori  |VGA|
        ;\-------------------/;/\--------*-----*----*-------*------------*---/

        ;/-------------------\;\/--------*-----*----*-------*------------*---\
        ;|Provare  anche  con|;||MODO 06H|80x25|8x8 |640x200|16 colori   |CGA|
        ;|gli    altri   MODI|;||MODO 0EH|80x25|8x8 |640x200|16 colori   |EGA|
        ;\-----------------/;||MODO 0FH|80x25|8x14|640x350|monocrimatic|EGA|
        MOV     AL,12H        ;||MODO 10H|80x25|8x14|640x350|16 colori   |EGA|
        MOV     AH,00H        ;||MODO 11H|80x30|8x16|640x480|monocromatic|VGA|
        INT     10H           ;||MODO 12H|80x30|8x16|640x480|16 colori   |VGA|
                              ;/\--------*-----*----*-------*------------*---/
                              ;/---------------------------------------------\
                              ;|   CARICA il FONT standard 8*8 Double Dot    |
                              ;\---------------------------------------------/
                              ; SottoFunzione che consente (nei  MODI GRAFICI)
        MOV     BL,00H        ; di caricare la Tabella 8*8  di default; il nu-
        MOV     DL,30;NumRighe; mero di righe di testo possibili sullo schermo
        MOV     AL,23H        ;  passato in DL (essendo BL=00H). Il puntatore
        MOV     AH,11H        ; alla Tabella 8*8   poi copiato nelle locazio-
        INT     10H           ; ni della Tabella  dei  Vettori (da 0000:010CH)
                              ; corrispondenti all'INT 43H
        M_msgC TESTO1,1,10,0EH;/---------------------------------------------\
        M_msgC TESTO2,2,10,0EH;|                                             |
        M_msgC TESTO2,3,10,0EH;|Organizza il piano di presentazione          |
        M_msgC TESTO3,4,10,0EH;|                                             |
        M_msgC TESTO4,2,12,0FH;|                                             |
        M_msgC TESTO5,3,14,0FH;\---------------------------------------------/
        M_msgC TESTO6,6,14,0EH;I nuovi caratteri sono regolarmente disponibili

        CALL    KEYwait
_OUT:   MOV     AL,03H        ;
        MOV     AH,00H        ; Ripristina in uscita il  MODO  TESTO  standard
        INT     10H           ;

        PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;

B10_1123 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
