PAGE 66,132
TITLE ** B10_11x2.ASM - Caricatore di FONT di default 8*8 DOUBLE-DOT ROM  BIOS
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_11x2.ASM                         (INT 10H, Funzione 11H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Nei MODI TESTO organizza il caricamento del FONT 8*8 "a dop-|
;|               pio punto" della ROM BIOS nella Prima Tabella della RAM  in-|
;|               terna alla scheda Video, a disposizione del GENERATORE HARD-|
;|               WARE di CARATTERI.                                          |
;|                                                                           |
;|               La prova  condotta con entrambe le SottoFunzioni 02H e  12H|
;|               per verificarne l'attivit ricordando che la seconda rispet-|
;|               to alla prima provvede alla riprogrammazione del  Controller|
;|               CRT, permettendo anche la gestione dell'altezza dei caratte-|
;|               ri visualizzati.                                            |
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CambiaCol:NEAR
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   BIOchr1:NEAR
        EXTRN   KEYwait:NEAR


; DICHIARAZIONI PER I PROGRAMMI ESTERNI:
        PUBLIC  ATTRIB
        PUBLIC  B10_11x2


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog

        ORG     0100H
INIZIO: JMP     B10_11x2

;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB DB 0FH
TESTO1 DB "Ŀ",00H
TESTO2 DB "                                                             ",00H
TESTO3 DB "",00H
TESTO4 DB    "B10_11x2 - Caricatore del FONT  di default ROM BIOS 8*8"     ,00H
TESTO5 DB    "vers.2.0                           by ing. Giorgio OBER"     ,00H
TESTO6 DB    "I Caratteri sono disposti a Video ",00H
TESTO7 DB    "I Caratteri sono ora disposti a Video ",00H
TESTO8 DB    "SENZA",00H
TESTO9 DB    "CON",00H
TESTOA DB    " controllo sull'altezza",00H



;*****************************************************************************
                              ; ----------------------------------------------
B10_11x2 proc  NEAR           ;       AREA DEDICATA AL MAIN PROGRAM
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        MOV     AL,03H        ;/[ Con  ClearScreen]*------*-----*----*-------\
        MOV     AH,00H        ;|MODO TESTO STANDARD|AL=03H|80x25|8x16|640x400|
        INT     10H           ;\-------------------*------*-----*----*-------/
        CALL    VIA_cur       ; Rende il  cursore invisibile

                              ;/---------------------------------------------\
                              ;|   CARICA il FONT di default ROM BIOS 8*8    |
                              ;\---------------------------------------------/
        MOV     BL,00H        ; SottoFunzione che consente (nei MODI TESTO) di
        MOV     AL,02H        ; caricare la Tabella 8*8  di default nella Pri-
        MOV     AH,11H        ; ma Tabella nella RAM del  GENERATORE  HARDWARE
        INT     10H           ; [senza   controllo   automatico  sull'altezza]
        M_msgC TESTO1,1,10,0EH;/---------------------------------------------\
        M_msgC TESTO2,2,10,0EH;|                                             |
        M_msgC TESTO2,3,10,0EH;|                                             |
        M_msgC TESTO3,4,10,0EH;|                                             |
        M_msgC TESTO4,2,14,0FH;|     Organizza la presentazione del TEST     |
        M_msgC TESTO5,3,14,0FH;|                nel primo caso               |
        M_CURSOR 2,20         ;|                                             |
        MOV     AL,"0"        ;|                                             |
        CALL    BIOchr1       ;\---------------------------------------------/
        M_msgC TESTO6,6,10,0EH;/---------------------------------------------\
        M_COLOR 8EH           ;|                                             |
        M_msgN  TESTO8        ;|Caratteri disponibili SENZA controllo altezza|
        M_COLOR 0EH           ;|                                             |
        M_msgN  TESTOA        ;\---------------------------------------------/
        CALL    KEYwait       ; Aspetta la pressione  di  un  tasto  qualunque

                              ;/---------------------------------------------\
                              ;| RICARICA il FONT di default ROM BIOS 8*8    |
                              ;\---------------------------------------------/
        MOV     BL,00H        ; SottoFunzione che consente (nei MODI TESTO) di
        MOV     AL,12H        ; caricare la Tabella 8*8  di default nella Pri-
        MOV     AH,11H        ; ma Tabella nella RAM del  GENERATORE  HARDWARE
        INT     10H           ; [con     controllo   automatico  sull'altezza]
        M_msgC TESTO1,8,10,0EH;/---------------------------------------------\
        M_msgC TESTO2,9,10,0EH;|                                             |
       M_msgC TESTO2,10,10,0EH;|                                             |
       M_msgC TESTO3,11,10,0EH;|                                             |
        M_msgC TESTO4,9,14,0FH;|     Organizza la presentazione del TEST     |
       M_msgC TESTO5,10,14,0FH;|              nel secondo caso               |
        M_CURSOR 9,20         ;|                                             |
        MOV     AL,"1"        ;|                                             |
        CALL    BIOchr1       ;\---------------------------------------------/
        M_msgC TESTO7,13,9,0EH;/---------------------------------------------\
        M_COLOR 8EH           ;|                                             |
        M_msgN  TESTO9        ;|Caratteri disponibili  CON  controllo altezza|
        M_COLOR 0EH           ;|                                             |
        M_msgN  TESTOA        ;\---------------------------------------------/

        PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;

B10_11x2 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
