PAGE 66,132
TITLE ** B10_1210.ASM -  Programma  per  l'acquisizione di informazioni su EGA
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1210.ASM                         (INT 10H, Funzione 12H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Verifica l'effetto della Funzione; in base al contenuto  dei|
;|               registri BH (tipo di MODO configurato), BL (quantit di  me-|
;|               moria RAM installata sulla scheda EGA), CH (valore di deter-|
;|               minate linee sul  connettore  EGA)  e  CL (disposizione  dei|
;|               quattro Commutatori di Configurazione EGA) viene composta la|
;|               seguente Tabella, con lettura anche delle Variabili  di  Si-|
;|               stema corrispondenti nell'Area di Comunicazione BIOS:       |
;|                                                                           |
;|    /---------------------------------------------------------------------\|
;|    |Il sistema  configurato in un MODO  a   COLORI   (CRT 03DxH, BH=00H)||
;|    |    Sulla scheda EGA sono installati 256k di memoria RAM (BL=03H)    ||
;|    |                                                                     ||
;|    |         Stato  del    connettore   EGA:    CH = 0000 0000           ||
;|    |         Codice di  Configurazione  EGA:    CL = 0000 1001           ||
;|    |                                                                     ||
;|    |                                               BL-*\    /-BH         ||
;|    |         Contenuto della Variabile 0000:0487H =  0110 0000           ||
;|    |                                                 7654 3210           ||
;|    |         Contenuto della Variabile 0000:0488H =  0000 1001           ||
;|    |                                              CH-***/ \***-CL        ||
;|    \---------------------------------------------------------------------/|
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CambiaCol:NEAR  ;usata da M_COLOR
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   BIOchr1:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   KEYwait:NEAR
        PUBLIC  ATTRIB        ;Attributo di colore


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_1210


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB  DB      00H           ;Attributo di Colore
Testo00 DB "La scheda installata NON  di tipo EGA"                       ,00H
Testo01 DB "Il sistema  configurato in un MODO "                         ,00H
Testo02 DB "MONOCROMATICO (CRT 03BxH, BH=0 H)"                            ,00H
Testo03 DB " a   COLORI   (CRT 03DxH, BH=0 H)"                            ,00H
Testo16 DB "non valutabile (Codice in BH=0 H)"                            ,00H
Testo04 DB "La scheda EGA non  disponibile"                              ,00H
Testo05 DB "Sulla scheda EGA sono installati    k di memoria RAM (BL=0 H)",00H
Testo06 DB " 64"                                                          ,00H
Testo07 DB "128"                                                          ,00H
Testo08 DB "192"                                                          ,00H
Testo09 DB "256"                                                          ,00H
Testo17 DB "???"                                                          ,00H
Testo10 DB "Stato  del    connettore   EGA:    CH = 0000 "                ,00H
Testo11 DB "Codice di  Configurazione  EGA:    CL = 0000 "                ,00H
Testo12 DB "Contenuto della Variabile 0000:048 H ="                       ,00H
Testo13 DB                                      "BL¿    BH"           ,00H
;       DB "Contenuto della Variabile 0000:0487H = xxxx xxxx"             ,00H
Testo14 DB                                        "7654 3210"             ,00H
;       DB "Contenuto della Variabile 0000:0488H = xxxx xxxx"             ,00H
Testo15 DB                                     "CH CL"          ,00H


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURE   : STAbit                                                      |
;| DESCRIZIONE : Stampa l'interpretazione ASCII della  sequenza  dei  quattro|
;|               bit meno significativi (bit3bit0) di CH.                   |
;\---------------------------------------------------------------------------/
STAbit: PUSH    CX            ;
        MOV     BH,CH         ; Stampa il Mesaggio puntato  in  ingresso da SI
        CALL    BIOSmsg       ;
        MOV     AL,"0"        ;
        TEST    BH,08H        ; Analizza il valore del bit3 di CH e lo traduce
        JZ      STAbi1        ; in ASCII, stampandolo nella posizione di stam-
        MOV     AL,"1"        ; pa corrente
STAbi1: CALL    BIOchr1       ;
        MOV     AL,"0"        ;
        TEST    BH,04H        ; Analizza il valore del bit2 di CH e lo traduce
        JZ      STAbi2        ; in ASCII, stampandolo nella posizione di stam-
        MOV     AL,"1"        ; pa corrente
STAbi2: CALL    BIOchr1       ;
        MOV     AL,"0"        ;
        TEST    BH,02H        ; Analizza il valore del bit1 di CH e lo traduce
        JZ      STAbi3        ; in ASCII, stampandolo nella posizione di stam-
        MOV     AL,"1"        ; pa corrente
STAbi3: CALL    BIOchr1       ;
        MOV     AL,"0"        ;
        TEST    BH,01H        ; Analizza il valore del bit0 di CH e lo traduce
        JZ      STAbi4        ; in ASCII, stampandolo nella posizione di stam-
        MOV     AL,"1"        ; pa corrente
STAbi4: CALL    BIOchr1       ;
        POP     CX
        RET
                        
;/---------------------------------------------------------------------------\
;| PROCEDURE   : STAbyt                                                      |
;| DESCRIZIONE : Stampa l'interpretazione ASCII della sequenza degli otto bit|
;|               (bit7bit0) di CH, a quattro a quattro.                     |
;\---------------------------------------------------------------------------/
STAbyt: PUSH    CX            ;
        SHR     CH,1          ;
        SHR     CH,1          ; Stampa dei quattro bit  pi significativi
        SHR     CH,1          ;
        SHR     CH,1          ;
        CALL    STAbit        ;
        MOV     AL," "        ; Stampa uo spazio di separazione
        CALL    BIOchr1       ;
        POP     CX            ;
        CALL    STAbit        ; Stampa dei quattro bit meno significativi
        RET                   ;


;*****************************************************************************
                              ; ----------------------------------------------
B10_1210 proc   NEAR          ;       AREA DEDICATA AL MAIN PROGRAM
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        MOV     CH,00         ;
        MOV     CL,00         ;
        MOV     DH,24         ; Produce un ClearScreen con aiuto della Funzio-
        MOV     DL,79         ; ne 06H dell'INT 10H BIOS (NB:CH=RigaAlto,  CL=
        MOV     BH,0FH        ; =ColnAlto, DH=RigaBass, DL=ColnBass, BH=Colore
        MOV     AL,00         ; e AL=0 (scorrere TUTTE le righe dello schermo)
        MOV     AH,06H        ;
        INT     10H           ;
  MOV Byte Ptr CS:[ATTRIB],0FH; Prepara la stampa in BIANCO BRILLANTE su  NERO
        CALL    VIA_cur       ; ed evita la visualizzazione del Cursore

        MOV  BH,0FFH;eventuale; Fornisce informazioni sulla configurazione  di
        MOV     BL,10H        ; un eventuale sottosistema EGA; si possono cos
        MOV     AH,12H        ; ottenere   informazioni   sull'adattatore  EGA
        INT     10H           ; attualmente installato.
        PUSH    CX            ; Salvaguarda i valori significativi del test

                              ;/---------------------------------------------\
                              ;|Analisi sul TIPO di scheda                   |
                              ;\---------------------------------------------/
                              ; MOV     DH,03     Predispone la posizione
        M_CURSOR 03,01        ; MOV     DL,01           di Stampa
                              ; CALL    SET_cur
        LEA     SI,Testo00    ;
        CMP     BH,0FFH       ; "La scheda installata NON  di tipo EGA"
        JZ      XXX00         ;
        LEA     SI,Testo01    ; "Il sistema  configurato in MODO "
        CALL    BIOSmsg       ;
        LEA     SI,Testo03    ;
        CMP     BH,00H        ; "a COLORI (CRT 03DxH), BH=00H)"
        JZ      XXX00         ;
        LEA     SI,Testo02    ;
        CMP     BH,01H        ; "MONOCROMATICO (CRT 03BxH, BH=01H)"
        JZ      XXX00         ;
        MOV     BH,0FH        ; "non valutabile (Codice  in BH=0?H)"
        LEA     SI,Testo16    ; (NB: BH=0FH consente 0FH+30H = 7FH = "?")
XXX00:  CALL    BIOSmsg       ;
        M_CURSOR 03,67        ;
        MOV     AL,BH         ; Aggiunge la cifra mancante al dato BH=0xH
        ADD     AL,30H        ;
        CALL    BIOchr1       ;

                              ;/---------------------------------------------\
                              ;|Analisi sulla QUANTITA` di RAM installata    |
                              ;\---------------------------------------------/
        M_CURSOR 04,05        ; Predispone la posizione di Stampa
        LEA     SI,Testo04    ;
        CMP     BL,10H        ; "La scheda EGA non  disponibile"
        JZ      XXX01         ;
        LEA     SI,Testo05    ; "Sulla scheda EGA sono installati 256k di
        CALL    BIOSmsg       ;                                   memoria RAM"
        M_CURSOR 04,38        ; Predispone la posizione di Stampa
        LEA     SI,Testo06    ;
        CMP     BL,00H        ; " 64"
        JZ      XXX01         ;
        LEA     SI,Testo07    ;
        CMP     BL,01H        ; "128"
        JZ      XXX01         ;
        LEA     SI,Testo08    ;
        CMP     BL,02H        ; "192"
        JZ      XXX01         ;
        LEA     SI,Testo09    ;
        CMP     BL,03H        ; "256"
        JZ      XXX01         ;
        LEA     SI,Testo17    ; "???"
XXX01:  CALL    BIOSmsg       ;
        M_CURSOR 04,63        ;
        MOV     AL,BL         ; Aggiunge la cifra mancante al dato BL=0xH
        ADD     AL,30H        ;
        CALL    BIOchr1       ;

                              ;/---------------------------------------------\
                              ;|Analisi sullo STATO del CONNETTORE EGA       |
                              ;\---------------------------------------------/
        M_CURSOR 08,10        ; Predispone la posizione di Stampa
        LEA     SI,Testo10    ; "Stato del connettore EGA: CH=0000xxxx"
        POP     CX            ; Interpreta in modo ASCII la  parte  bassa  del
        CALL    STAbit        ; contenuto di CH, stampando i quattro bit

                              ;/---------------------------------------------\
                              ;|Analisi sul Codice di CONFIGURAZIONE         |
                              ;\---------------------------------------------/
        M_CURSOR 09,10        ; Predispone la posizione di Stampa
        LEA     SI,Testo11    ; "Codice di Configurazione EGA CL=0000xxxx"
        MOV     CH,CL         ; Interpreta in modo ASCII la  parte  bassa  del
        CALL    STAbit        ; contenuto di CL, stampando i quattro bit

      M_msgC Testo13,12,48,0FH;/---------------------------------------------\
      M_msgC Testo14,14,50,0FH;|Analisi delle Variabili 0000:0487H/0000:0488H|
      M_msgC Testo15,16,47,0FH;\---------------------------------------------/
  MOV Byte Ptr CS:[ATTRIB],0EH;
        M_CURSOR 13,10        ;
        LEA     SI,Testo12    ; Stampa in GIALLO su NERO la frase per la   vi-
        CALL    BIOSmsg       ; sualizzazione del:
        M_CURSOR 15,10        ; "Contenuto della Variabile 0000:048xH, "
        LEA     SI,Testo12    ;
        CALL    BIOSmsg       ;
        M_CURSOR 13,44        ;
        MOV     AL,"7"        ;
        CALL    BIOchr1       ; Aggiunge  la  cifra  mancante  dell'indirizzo
        M_CURSOR 15,44        ; segmentato, 0000 048xH
        MOV     AL,"8"        ;
        CALL    BIOchr1       ;
        MOV     AX,0000H      ;
        MOV     ES,AX         ;
        MOV     DI,0487H      ; Preleva e stampa il contenuto di 0000:0487H
        MOV     CH,ES:[DI]    ;
        M_CURSOR 13,50        ;
        CALL    STAbyt        ;
        INC     DI            ;
        MOV     CH,ES:[DI]    ; Preleva e stampa il contenuto di 0000:0488H
        M_CURSOR 15,50        ;
        CALL    STAbyt        ;
        CALL    KeyWait

        PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;

B10_1210 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
