PAGE 66,132
TITLE ** B10_13gr.ASM - Programma per la stampa di  stringhe  a  livello  BIOS
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_13gr.ASM                         (INT 10H, Funzione 13H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Verifica l'effetto della Funzione in ambiente GRAFICO  ; da-|
;|               ta la diversit dei MODI GRAFICI possibili il  colore  usato|
;|               per il test viene cambiato ogni volta:                      |
;|                                                                           |
;|                    BIANCO   per quelli monocromatici                      |
;|                    ROSA     per quelli a    4 colori                      |
;|                    ROSSO    per quelli a   16 colori                      |
;|                    VIOLETTO per quello a  256 colori.                     |
;|                                                                           |
;|             /------*------------------*-----*-----*-----------*------*---\|
;|             | MODO |   RISOLUZIONE    |ORIZ.|VERT.|   COLORE  |PAGINA|   ||
;|             |      |     GRAFICA      | CX  | DX  | AL        |BH    |   ||
;|             *------*-----*----*-------*-----*-----*-----*-----*---*--*---*|
;|             |AL=04H|40x25|8x8 |320x200|0-319|0-199|0-3  | 4   | 0 |1 |CGA||
;|             |AL=05H|40x25|8x8 |320x200|0-319|0-199|0-3  | 4   | 0 |1 |CGA||
;|             |AL=06H|80x25|8x8 |640x200|0-639|0-199|0-1  |mono | 0 |1 |CGA||
;|             |AL=0DH|40x25|8x8 |320x200|0-319|0-199|0-15 | 16  |0-7|8 |EGA||
;|             |AL=0EH|80x25|8x8 |640x200|0-639|0-199|0-15 | 16  |0-3|4 |EGA||
;|             |AL=0FH|80x25|8x14|640x350|0-639|0-349|0-1  |mono |0-1|2 |EGA||
;|             |AL=10H|80x25|8x14|640x350|0-639|0-349|0-15 | 16  |0-1|2 |EGA||
;|             |AL=11H|80x30|8x16|640x480|0-639|0-479|0-1  |mono |0-1|2 |VGA||
;|             |AL=12H|80x30|8x16|640x480|0-639|0-479|0-15 | 16  |0-1|2 |VGA||
;|             |AL=13H|40x25|8x8 |320x200|0-319|0-199|0-255| 256 | 0 |1 |VGA||
;|             \------*-----*----*-------*-----*-----*-----*-----*---*--*---/|
;|               Naturalmente le differenze tra SottoServizi che  controllano|
;|               il Cursore e quelle che non lo fanno, pur essendo efficienti|
;|               non mostrano effetto(il Cursore in MODO GRAFICO non si vede)|
;\---------------------------------------------------------------------------/

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN    KEYwait:NEAR

;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_13gr


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
; Notare come  possibile lasciare al compilatore  il compito di calcolare  la
; LUNGHEZZA del messaggio che si desidera stampare !

Testo1  DB "*** Prova con Colore assunto  da BL ***"
Tst1LEN EQU  $-OFFSET Testo1

;Testo2 DB "Prova con Colore assunto  dalla stringa"
Testo2  DB "P",02H,"r",02H,"o",02H,"v",02H,"a",02H," ",02H,"c",03H,"o",03H
        DB "n",03H," ",03H,"C",04H,"o",04H,"l",04H,"o",04H,"r",04H,"e",04H
        DB " ",04H,"a",05H,"s",05H,"s",05H,"u",05H,"n",05H,"t",05H,"o",05H
        DB " ",05H," ",05H,"d",0EH,"a",0EH,"l",0EH,"l",0EH,"a",0EH," ",0EH
        DB "s",0FH,"t",0FH,"r",0FH,"i",0FH,"n",0FH,"g",0FH,"a",0FH
Tst2LEN EQU  $-OFFSET Testo2
NumPix  DW 0000H              ;Numero di Pixel adatto al MODO GRAFICO corrente


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : SETmodo                                                     |
;| DESCRIZIONE : Predispone il MODO GRAFICO desiderato, assumendone il numero|
;|               dal registro AL; data la diversit dei MODI GRAFICI possibi-|
;|               li assume da AH un colore di volta in volta diverso, in modo|
;|               coerente (BIANCO/monocromatico; ROSA/4 colori;  ROSSO/16 co-|
;|               lori e VIOLETTO/256 colori); dopo aver stampati le  previste|
;|               stringhe rimane in attesa della pressione di un  tasto  qua-|
;|               lunque, per tornare al programma chiamante.                 |
;\---------------------------------------------------------------------------/
SETmodo:PUSH    ES            ;
        PUSH    AX            ;
        MOV     AH,00H        ; Fissa il MODO VIDEO GRAFICO desiderato  e pre-
        INT     10H           ; para  il  Puntatore  alla stringa  ES:BP=CS:BP
        MOV     AX,CS         ;
        MOV     ES,AX         ;
        POP     AX            ;
        MOV     DH,02         ; Fissa una posizione per le successive chiamate
        MOV     DL,00         ; della Funzione sotto test, in modo da centrare
  CMP Word Ptr CS:[NumPix],320; il messaggio (la posizione che dipende dal nu-
        JZ      SETmod0       ; mero di colonne del MODO GRAFICO corrente)
        ADD     DL,20         ;
SETmod0:MOV     BL,AH ;Colore ; Predispone in BL il codice Colore e in  BH  la
        MOV     BH,00H ;Pagina; Pagina attiva per le successive chiamete della
                              ; Funzione  sotto test
                              ; Funzione BIOS che stampa la stringa puntata da
                              ; ES:BP nel punto DH=riga, DL=colonna, nella pa-
        MOV     CX,Tst1LEN    ; gina indicata da BH e con colore BL; la strin-
        LEA     BP,Testo1     ; ga  lunga CX caratteri
        MOV     AL,00H ;SottoF; /--------------------------------------------\
        MOV     AH,13H        ; |Collaudo della  Prima  SottoFunzione, AL=00H|
        INT     10H           ; *--------------------------------------------*
        CALL    KEYwait       ; |1) assume il colore direttamente da BL      |
                              ; |2) NON aggiorna la posizione del Cursore    |
                              ; \--------------------------------------------/
                              ; Funzione BIOS che stampa la stringa puntata da
                              ; ES:BP nel punto DH=riga, DL=colonna, nella pa-
        MOV     CX,Tst1LEN    ; gina indicata da BH e con colore BL; la strin-
        LEA     BP,Testo1     ; ga  lunga CX caratteri
        ADD     DH,02H ;Riga  ; /--------------------------------------------\
        MOV     AL,01H ;SottoF; |Collaudo della  Prima  SottoFunzione, AL=01H|
        MOV     AH,13H        ; *--------------------------------------------*
        INT     10H           ; |1) assume il colore direttamente da BL      |
        CALL    KEYwait       ; |2) aggiorna la posizione del Cursore        |
                              ; \--------------------------------------------/
                              ; Funzione BIOS che stampa la stringa puntata da
                              ; ES:BP nel punto DH=riga, DL=colonna, nella pa-
        MOV     CX,Tst2LEN    ; gina indicata da BH e con colore BL; la strin-
        SHR     CX,1          ; ga  lunga CX caratteri (i byte  di  attributo
        LEA     BP,Testo2     ; non contano per cui Tst2LEN va diviso per 2!!)
        ADD     DH,02H ;Riga  ; /--------------------------------------------\
        MOV     AL,02H ;SottoF; |Collaudo della  Prima  SottoFunzione, AL=02H|
        MOV     AH,13H        ; *--------------------------------------------*
        INT     10H           ; |1) assume colore direttamente dalla stringa |
        CALL    KEYwait       ; |2) NON aggiorna la posizione del Cursore    |
                              ; \--------------------------------------------/
                              ; Funzione BIOS che stampa la stringa puntata da
                              ; ES:BP nel punto DH=riga, DL=colonna, nella pa-
        MOV     CX,Tst2LEN    ; gina indicata da BH e con colore BL; la strin-
        SHR     CX,1          ; ga  lunga CX caratteri (i byte  di  attributo
        LEA     BP,Testo2     ; non contano per cui Tst2LEN va diviso per 2!!)
        ADD     DH,02H ;Riga  ; /--------------------------------------------\
        MOV     AL,03H ;SottoF; |Collaudo della  Prima  SottoFunzione, AL=03H|
        MOV     AH,13H        ; *--------------------------------------------*
        INT     10H           ; |1) assume colore direttamente dalla stringa |
        CALL    KEYwait       ; |2) aggiorna la posizione del Cursore        |
                              ; \--------------------------------------------/
        POP     ES
        RET


;*****************************************************************************
                              ; ----------------------------------------------
B10_13gr proc   NEAR          ;       AREA DEDICATA AL MAIN PROGRAM
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        MOV    CS:[NumPix],320; Inizializza Numero Colonna per MODI a 40 colon
        MOV     AL,04H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,02H        ; |MODO 04H|40x25|8x8 |320x200| 4 colori   |CGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,05H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,02H        ; |MODO 05H|40x25|8x8 |320x200| 4 colori   |CGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,0DH        ; /--------*-----*----*-------*------------*---\
        MOV     AH,04H        ; |MODO 0DH|40x25|8x8 |320x200|16 colori   |EGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV    CS:[NumPix],640; Inizializza Numero Colonna per MODI a 80 colon
        MOV     AL,06H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,01H        ; |MODO 06H|80x25|8x8 |640x200|bianco/nero |CGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,0EH        ; /--------*-----*----*-------*------------*---\
        MOV     AH,04H        ; |MODO 0EH|80x25|8x8 |640x200|16 colori   |EGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,0FH        ; /--------*-----*----*-------*------------*---\
        MOV     AH,01H        ; |MODO 0FH|80x25|8x14|640x350|monocrimatic|EGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,10H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,04H        ; |MODO 10H|80x25|8x14|640x350|16 colori   |EGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,11H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,01H        ; |MODO 11H|80x30|8x16|640x480|monocromatic|VGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,12H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,04H        ; |MODO 12H|80x30|8x16|640x480|16 colori   |VGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV    CS:[NumPix],320; Inizializza Numero Colonna per MODI a 40 colon
        MOV     AL,13H        ; /--------*-----*----*-------*------------*---\
        MOV     AH,3AH        ; |MODO 13H|40x25|8x8 |320x200|256 colori  |VGA|
        CALL    SETmodo       ; \--------*-----*----*-------*------------*---/
        MOV     AL,03H        ;
        MOV     AH,00H        ; Ripristina in uscita il  MODO  TESTO  standard
        INT     10H           ;
                              
        MOV     AH,4CH        ;Torna al DOS
        INT     21H           

B10_13gr ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
