PAGE 66,132
TITLE ** B10_1A00.ASM - Fornisce informazioni  sul Sistema  di Visualizzazione
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1A00.ASM                         (INT 10H, Funzione 1AH)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Assume da una Tabella ROM BIOS interna i due valori numerici|
;|               che identificano l'Adattatore e il Monitor ad esso collegato|
;|               relativi sia al Sistema di Visualizzazione  attualmente "at-|
;|               tivo"  sia all'eventuale secondo Sistema di Visualizzazione,|
;|               "disattivo", disponibile su taluni computer come per esempio|
;|               i PS/2; la coppia serve per fissare  il "codice  di combina-|
;|               zione" associato al Sistema (globale) di Visualizzazione.   |
;\---------------------------------------------------------------------------/

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN   SET_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   Byt2Asc:NEAR
        EXTRN   KEYwait:NEAR
        EXTRN   RIP_cur:NEAR
        PUBLIC  ATTRIB        ;Attributo di colore


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_1A00

;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB  DB      0FH           ;Attributo di Colore

Testo0  DB "Informazioni sul Sistema di Visualizzazione  (Scheda+Monitor)",00H
Testo1 DB " La funzione NON  supportata o ha provocato malfunzionamento ",00H
Cornic0 DB "Ŀ",00H
Cornic1 DB " Cod.   Codice Combinazione Visualizzatore  ~attivo~      ",00H
Cornic2 DB " Cod.   Codice Combinazione Visualizzatore ~disattivo~    ",00H
Cornic3 DB "Ĵ",00H
        DB " 00H                  Nessun Monitor                      ",00H
        DB " 01H    Adattatore MDA con Monitor monocromatico (5151)   ",00H
        DB " 02H   Adattatore CGA con Monitor a colori (5153 o 5154)  ",00H
        DB " 03H                 Codice Riservato                     ",00H
        DB " 04H   Adattatore EGA con Monitor a colori (5153 o 5154)  ",00H
        DB " 05H    Adattatore EGA con Monitor monocromatico (5151)   ",00H
        DB " 06H       Adattatore PGA con Monitor a colori (5175)     ",00H
        DB " 07H Adattatore VGA  con Monitor monocromatico (analogico)",00H
        DB " 08H    Adattatore VGA con Monitor a colori (analogico)   ",00H
        DB " 09H                 Codice Riservato                     ",00H
        DB " 0AH    Adattatore MCGA con Monitor a colori (digitale)   ",00H
        DB " 0BH Adattatore MCGA con Monitor monocromatico (analogico)",00H
        DB " 0CH    Adattatore MCGA con Monitor a colori (analogico)  ",00H
Testo2  DB "   H        Codice Riservato  (valore non ammesso)        ",00H
Testo3  DB " FFH Sistema di Visualizzaz.  (Scheda+Monitor) sconosciuto",00H
Cornic4 DB "",00H
;Cornic0 DB"Ŀ",00H
Testo4  DB "    La  Variabile di Sistema  0000:048AH dell'Area di  ",00H
Testo5  DB "    Comunicazione BIOS  contiene  il valore   H,  che  ",00H
Testo6  DB "    corrisponde esattamente alla coppia ora indicata,  ",00H
Testo7  DB "    ed   detto ~Codice di Combinazione~  del Sistema  ",00H
;Cornic4 DB"",00H

;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : STAmess                                                     |
;| DESCRIZIONE : Organizza la stampa a livello BIOS della stringa ASCIIZ pun-|
;|               tata in ingresso da SI con l'attributo di Colore specificato|
;|               nella variabile [ATTRIB] e nella posizione di stampa succes-|
;|               siva alla riga precedentemente stampata.                    |
;\---------------------------------------------------------------------------/
STAmess:MOV     DL,09         ;
        INC     DH            ;
STAmes_:CALL    SET_cur       ; Stampa il messaggio
        CALL    BIOSmsg       ;
        RET                   ;

;/---------------------------------------------------------------------------\
;| PROCEDURA   : Prova                                                       |
;| DESCRIZIONE : Interpreta e organizza la stampa del Dato fornito in ingres-|
;|               do in AH con il corretto messaggio puntato in ingresso da SI|
;\---------------------------------------------------------------------------/
Prova:  PUSH    AX            ;
        PUSH    SI            ;
        LEA     SI,Cornic0    ; /-----*--------------------------------------\
        CALL    STAmess       ; | Cod.|Codice Combinazione del Visualizzatore|
        POP     SI            ; *-----*--------------------------------------*
        CALL    STAmess       ; | 00H |Nessun Monitor                        |
        LEA     SI,Cornic3    ; | 01H |Adattatore MDA+Monitor monocromatico  |
        CALL    STAmess       ; | 02H |Adattatore CGA+Monitor a colori       |
        INC     SI            ; | 03H |Codice Riservato                      |
        POP     AX            ; | 04H |Adattatore EGA+Monitor a colori       |
        CMP     AH,0FFH       ; | 05H |Adattatore EGA+Monitor monocromatico  |
        JZ      XXX02         ; | 06H |Adattatore PGA+Monitor a colori       |
        MOV     AL,00H        ; | 07H |Adattatore VGA+Monitor monocromatico  |
        MOV     CX,13         ; | 08H |Adattatore VGA+Monitor a colori       |
XXX01:  CMP     AH,AL         ; | 09H |Codice Riservato                      |
        JZ      XXX03         ; | 0AH |Adattatore MCGA+Monitor a colori      |
        ADD     SI,62         ; | 0BH |Adattatore MCGA+Monitor monocromatico |
        INC     AL            ; | 0CH |Adattatore MCGA+Monitor a colori      |
        LOOP    XXX01         ; *-----*--------------------------------------*
        LEA     SI,Testo2     ; |     |                                      |
        CALL    STAmess       ; |     |                                      |
        MOV     DL,11         ; |     |                                      |
        CALL    SET_cur       ; | ??H |Codice Riservato                      |
        MOV     AL,AH         ; |     |                                      |
        CALL    Byt2Asc       ; |     |                                      |
        JMP     SHORT XXX04   ; *-----*--------------------------------------*
XXX02:  LEA     SI,Testo3     ; | FFH |Sistema di Visualizzazione sconosciuto|
XXX03:  CALL    STAmess       ; \-----*--------------------------------------/
XXX04:  LEA     SI,Cornic4    ;
        CALL    STAmess       ;
        RET                   ;


;*****************************************************************************
                              ; ----------------------------------------------
B10_1A00 proc   NEAR          ;|      AREA DEDICATA AL MAIN PROGRAM         ||
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        MOV     CH,00         ; /--------------------------------------------\
        MOV     CL,00         ; |       Prima FASE: Prepara il DeskTop       |
        MOV     DH,24         ; \--------------------------------------------/
        MOV     DL,79         ;
        MOV     BH,0FH        ; Produce un ClearScreen con aiuto della Funzio-
        MOV     AL,00         ; ne 06H dell'INT 10H BIOS (NB:CH=RigaAlto,  CL=
        MOV     AH,06H        ; =ColnAlto, DH=RigaBass, DL=ColnBass, BH=Colore
        INT     10H           ; e AL=0 (scorrere TUTTE le righe dello schermo)
  MOV Byte Ptr CS:[ATTRIB],0EH;
        MOV     DH,03         ;
        MOV     DL,09         ;
        LEA     SI,Testo0     ; Messaggio  di Presentazione del test
        CALL    STAmes_       ;
        INC     DH            ;
  MOV Byte Ptr CS:[ATTRIB],0FH;
        ;---------------------- ----------------------------------------------
                              ; /--------------------------------------------\
        PUSH    DX            ; |Seconda FASE: Punta il BUFFER con i due byts|
        MOV     AL,00H        ; \--------------------------------------------/
        MOV     AH,1AH        ; Assume in BL il "codice di combinazione" asso-
        INT     10H           ; ciato all'Adattatore e al Monitor collegato al
        POP     DX            ; Sistema di Visualizzazione  attualmente "atti-
                              ; vo" e in BH quello dell'eventuale secondo Si-
                              ; stema di Visualizzazione, "disattivo"
        CMP     AL,1AH        ;
        JZ      XXX00         ;
        LEA     SI,Testo1     ;
        MOV     DH,09         ;
        MOV     DL,09         ; Stampa l'eventuale messaggio d'ERRORE
        CALL    SET_cur       ;
 MOV Byte Ptr CS:[ATTRIB],0CFH;
        CALL    BIOSmsg       ;
        JMP     _OUT          ;
        ;---------------------- ----------------------------------------------
XXX00:                        ; /--------------------------------------------\
        MOV     AH,BL         ; |      Terza FASE: Esegue il test            |
        LEA     SI,Cornic1    ; \--------------------------------------------/
        CALL    Prova         ; /-----*--------------------------------------\
        INC     DH            ; | Cod.|Codice Combinaz.Visualizzat.~attivo~  |
        MOV     AH,BH         ; \-----*--------------------------------------/
        LEA     SI,Cornic2    ; /-----*--------------------------------------\
        CALL    Prova         ; | Cod.|Codice Combinaz.Visualiz.~disattivo~  |
        INC     DH            ; \-----*--------------------------------------/
        LEA     SI,Cornic0    ; /-----*--------------------------------------\
        CALL    STAmess       ; |  | La Variabile di Sistema 0000:048AH   |
        LEA     SI,Testo4     ; |  | dell'Area  di  Comunicazione  BIOS   |
        CALL    STAmess       ; |  | contiene il valore xxH, che corri-   |
        LEA     SI,Testo5     ; |  | sponde esattamente alla coppia ora   |
        CALL    STAmess       ; |  | indicata  ed   detto  "Codice  di   |
        LEA     SI,Testo6     ; |  | Combinazione" del Sistema            |
        CALL    STAmess       ; \-----*--------------------------------------/
        LEA     SI,Testo7     ; Per poter condurre  quest'indagine la Funzione
        CALL    STAmess       ; sotto  test  utilizza  il byte contenuto nella
        LEA     SI,Cornic4    ; Variabile di Sistema 0000:048AH  dell'Area  di
        CALL    STAmess       ; Comunicazione BIOS; con esso punta la  Tabella
        PUSH    ES            ; interna e ne estrae i due Codici (uno per ogni
        MOV     AX,0000H      ; Sistema  eventualmente  presente sul Computer)
        MOV     ES,AX         ; e li copia in BL e BH
        MOV     DI,048AH      ;
        SUB     DH,3          ;
        MOV     DL,58         ;
        CALL    SET_cur       ; Localizza e scrive il dato della Variabile di
        MOV     AL,ES:[DI]    ; Siatema 0000:048AH
        CALL    Byt2Asc       ;
        POP     ES            ;
        CALL    KeyWait
_OUT:
        PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;
 
B10_1A00 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
