; Lo scopo della SottoFunzione 01H della Funzione 1AH di INT 10H  quello di
; verificare la possibilit di disporre di determinati Sottosistemi di
; Visualizzazione, di norma ben noti e comunque appartenenti al gruppo
; elencato nella Tabella:
;
;      /-----*-------------------------------------------------------\
;      | Cod.|Codice Combinazione Visualizzatore ~attivo~/~disattivo~|
;      *-----*-------------------------------------------------------*
;      | 00H |                  Nessun Monitor                       |
;      | 01H |    Adattatore MDA con Monitor monocromatico (5151)    |
;      | 02H |   Adattatore CGA con Monitor a colori (5153 o 5154)   |
;      | 03H |                 Codice Riservato                      |
;      | 04H |   Adattatore EGA con Monitor a colori (5153 o 5154)   |
;      | 05H |    Adattatore EGA con Monitor monocromatico (5151)    |
;      | 06H |       Adattatore PGA con Monitor a colori (5175)      |
;      | 07H | Adattatore VGA  con Monitor monocromatico (analogico) |
;      | 08H |    Adattatore VGA con Monitor a colori (analogico)    |
;      | 09H |                 Codice Riservato                      |
;      | 0AH |    Adattatore MCGA con Monitor a colori (digitale)    |
;      | 0BH | Adattatore MCGA con Monitor monocromatico (analogico) |
;      | 0CH |    Adattatore MCGA con Monitor a colori (analogico)   |
;      \-----*-------------------------------------------------------/
;
; L'uso di questa Funzione pu ingenerare confusione dato che possiamo essere
; indotti a confondere il Numero di questi accoppiamenti Scheda+Monitor con
; quello del "Codice di Combinazione" che invece  riferito ad una coppia dei
; primi; cos il Codice di Combinazione 0BH (comune nei moderni Personal
; Computer a colori) NON deve essere confuso con il Numero 0BH dell'Adattatore
; MCGA con Monitor monocromatico analogico, poich si riferisce in realt alla
; coppia ~VGA analogico a colori "attivo"+ Nessun Monitor "disattivo"~.
;
; L'elenco completo degli accoppiamenti possibili, indicati dal "Codice di
; Combinazione" viene infatti specificato da questa seconda Tabella, che come
;  noto,  contenuta dentro la ROM BIOS della Scheda Video:
;
;    /----*--------*------------------------*----------------------------\
;    |Cod.| Tabella|Sistema di Visualizzaz. |Sistema  di  Visualizzazione|
;    |Comb|ROM BIOS|BH = Sistema "disattivo"|   BL = Sistema "attivo"    |
;    *----*--------*------------------------*----------------------------*
;    |00H | 00H 00H|Nessun Monitor          |Nessun Monitor              |
;    |01H | 00H 01H|Nessun Monitor          |MDA +monocromatico 5151     |
;    |02H | 00H 02H|Nessun Monitor          |CGA +colori 5153/5154       |
;    |03H | 02H 01H|CGA +colori 5153/5154   |MDA +monocromatico 5151     |
;    |04H | 00H 04H|Nessun Monitor          |EGA +colori 5153/5154       |
;    |05H | 04H 01H|EGA +colori 5153/5154   |MDA +monocromatico 5151     |
;    |06H | 00H 05H|Nessun Monitor          |EGA +monocromatico  5151    |
;    |07H | 02H 05H|CGA +colori 5153/5154   |EGA +monocromatico  5151    |
;    |08H | 00H 06H|Nessun Monitor          |PGA +colori 5175            |
;    |09H | 01H 06H|MDA +monocromatico 5151 |PGA +colori 5175            |
;    |0AH | 05H 06H|EGA +monocromatico  5151|PGA +colori 5175            |
;    |0BH | 00H 08H|Nessun Monitor          |VGA +colori analogico       |
;    |0CH | 01H 08H|MDA +monocromatico 5151 |VGA +colori analogico       |
;    |0DH | 00H 07H|Nessun Monitor          |VGA +monocromatico analogico|
;    |0EH | 02H 07H|CGA +colori 5153/5154   |VGA +monocromatico analogico|
;    |0FH | 06H 07H|PGA +colori 5175        |VGA +monocromatico analogico|
;    \----*--------*------------------------*----------------------------/
;
; Il programma che segue ne verifica la validit fornendo in sequenza tutti
; i (11*11)=121 i possibili accoppiamenti, inclusi nelle (13*13)=169
; combinazioni, dato che si  volutamente evitato di proporre i Numeri 03H e
; 09H, dichiarati "Codice Riservato"; quando l'accoppiamento  ammesso viene
; restituito uno dei 16 "Codici di Combinazione" inclusi nella Tabella ROM
; BIOS; viceversa viene restituito il Codice 0FFH.
;
; L'esecuzione del programma  utile per capire il modo con cui viene
; interpretato questo "Codice di Combinazione"; la Tabella successiva mostra
; i risultati della prova:
;
;/--------------------------------*---*---*---*---*---*---*---*---*---*---*---\
;|         Scheda+Monitor         |00H|01H|02H|04H|05H|06H|07H|08H|0AH|0BH|0CH|
;*---*----------------------------*---*---*---*---*---*---*---*---*---*---*---*
;|00H|Nessun Monitor              |00H|01H|02H|04H|06H|08H|0DH|0BH|FFH|FFH|FFH|
;|01H|MDA +monocromatico 5151     |01H|FFH|03H|05H|FFH|09H|FFH|0CH|FFH|FFH|FFH|
;|02H|CGA +colori 5153/5154       |02H|03H|FFH|FFH|07H|FFH|0EH|FFH|FFH|FFH|FFH|
;|04H|EGA +colori 5153/5154       |04H|05H|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|
;|05H|EGA +monocromatico  5151    |06H|FFH|07H|FFH|FFH|0AH|FFH|FFH|FFH|FFH|FFH|
;|06H|PGA +colori 5175            |08H|09H|FFH|FFH|0AH|FFH|0FH|FFH|FFH|FFH|FFH|
;|07H|VGA +monocromatico analogico|0DH|FFH|0EH|FFH|FFH|0FH|FFH|FFH|FFH|FFH|FFH|
;|08H|VGA +colori analogico       |0BH|0CH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|
;|0AH|VGA +colori analogico       |FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|
;|0BH|VGA +monocromatico analogico|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|
;|0CH|VGA +monocromatico analogico|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|FFH|
;\---*----------------------------*---*---*---*---*---*---*---*---*---*---*---/

; Si nota, anzitutto che ogni coppia ammessa produce lo stesso "Codice di
; Combinazione" anche se i Sistemi ad esso associati si scambiano il ruolo
; di "attivo" con "disattivo" (e viceversa); questo concorre a determinare
; 32 coincidenze tra le 121 coppie proposte e le 16 Voci della Tabella interna.
;
; Inoltre si osserva che in nessun caso l'Adattatore MCGA con qualunque tipo
; di Monitor (a colori, digitale o analogico, o monocromatico analogico) si
; combina con gli altri tipi.

PAGE 66,132
TITLE ** B10_1A01.ASM - Modifica configurazione del Sistema di Visualizzazione
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1A01.ASM                         (INT 10H, Funzione 1AH)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Modifica il "codice di combinazione"  associato  al  Sistema|
;|               (globale) di Visualizzazione cercando nella Tabella ROM BIOS|
;|               interna i due valori numerici che  identificano l'Adattatore|
;|               e il Monitor relativi sia al Sistema di Visualizzazione  at-|
;|               tualmente "attivo" sia all'eventuale secondo Sistema di  Vi-|
;|               sualizzazione, "disattivo".                                 |
;\---------------------------------------------------------------------------/


; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   SET_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   BIOchr1:NEAR
        EXTRN   Byt2Asc:NEAR
        EXTRN   KEYwait:NEAR
        PUBLIC  ATTRIB        ;Attributo di colore

;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_1A01


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB  DB      0FH           ;Attributo di Colore
                              ; Tien conto delle Concorrenze tra  le  combina-
                              ; zioni fornite e le Voci della Tabella ROM BIOS
                              ; interna; notare che si parte da  1  per  tener
trovato DB      01H           ; conto della combinazione 00H/00H  fornita  una
                              ; volta sola ma computabile due volte, come suc-
                              ; cede in tutti gli altri casi quando un numero
                              ; si scambia con l'altro (es: 02H/07H e 07H/02H)
Testo01 DB "  INCLUSA  ",00H
Testo02 DB "NON INCLUSA",00H
Testo0  DB "Combinazione di Sistemi di Visualizzazione             in ROM",00H
Testo1 DB " La funzione NON  supportata o ha provocato malfunzionamento ",00H
Cornic0 DB "Ŀ",00H
Cornic1 DB " Cod.   Codice Combinazione Visualizzatore  ~attivo~      ",00H
Cornic2 DB " Cod.   Codice Combinazione Visualizzatore ~disattivo~    ",00H
Cornic3 DB "Ĵ",00H
Dati    DB " 00H                  Nessun Monitor                      ",00H
        DB " 01H    Adattatore MDA con Monitor monocromatico (5151)   ",00H
        DB " 02H   Adattatore CGA con Monitor a colori (5153 o 5154)  ",00H
        DB " 03H                 Codice Riservato                     ",00H
        DB " 04H   Adattatore EGA con Monitor a colori (5153 o 5154)  ",00H
        DB " 05H    Adattatore EGA con Monitor monocromatico (5151)   ",00H
        DB " 06H       Adattatore PGA con Monitor a colori (5175)     ",00H
        DB " 07H Adattatore VGA  con Monitor monocromatico (analogico)",00H
        DB " 08H    Adattatore VGA con Monitor a colori (analogico)   ",00H
        DB " 09H                 Codice Riservato                     ",00H
        DB " 0AH    Adattatore MCGA con Monitor a colori (digitale)   ",00H
        DB " 0BH Adattatore MCGA con Monitor monocromatico (analogico)",00H
        DB " 0CH    Adattatore MCGA con Monitor a colori (analogico)  ",00H
Testo2  DB "   H        Codice Riservato  (valore non ammesso)        ",00H
Testo3  DB " FFH Sistema di Visualizzaz.  (Scheda+Monitor) sconosciuto",00H
Cornic4 DB "",00H
;Cornic0 DB"Ŀ",00H
Testo4  DB "   La coppia di bytes  sopra indicata   stata  usata  ",00H
Testo5  DB "   per creare il ~Codice di Combinazione~ del Sistema  ",00H
Testo6  DB "   (valore   H)  ora  disponibile nella Variabile  di  ",00H
Testo7  DB "   Sistema 0000:048AH dell'Area di Comunicazione BIOS  ",00H
;Cornic4 DB"",00H
Testo8  DB "Premere un tasto qualunque per continuare, ~Q~ per terminare ",00H
Testo9  DB "Al termine della prova sono state riscontrate   H concorrenze",00H


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : STAmess                                                     |
;| DESCRIZIONE : Organizza la stampa a livello BIOS della stringa ASCIIZ pun-|
;|               tata in ingresso da SI con l'attributo di Colore specificato|
;|               nella variabile [ATTRIB] e nella posizione di stampa succes-|
;|               siva alla riga precedentemente stampata.                    |
;\---------------------------------------------------------------------------/
STAmess:MOV     DL,09         ;
        INC     DH            ;
STAmes_:CALL    SET_cur       ; Stampa il messaggio
        CALL    BIOSmsg       ;
        RET                   ;

;/---------------------------------------------------------------------------\
;| PROCEDURA   : Tabelle                                                     |
;| DESCRIZIONE : Prepara la zona di visualizzazione                          |
;\---------------------------------------------------------------------------/
Tabelle:PUSH    SI
        LEA     SI,Cornic0    ;
        CALL    STAmess       ; /-----*--------------------------------------\
        POP     SI            ; | Cod.|Codice Combinazione del Visualizzatore|
        CALL    STAmess       ; *-----*--------------------------------------*
        LEA     SI,Cornic3    ; |     |                                      |
        CALL    STAmess       ; |     |                                      |
        INC     DH            ; |     |                                      |
        LEA     SI,Cornic4    ; |     |                                      |
        CALL    STAmess       ; \-----*--------------------------------------/
        RET                   ;

;/---------------------------------------------------------------------------\
;| PROCEDURA   : Prova                                                       |
;| DESCRIZIONE : Interpreta e organizza la stampa del Dato fornito in ingres-|
;|               do in AH                                                    |
;\---------------------------------------------------------------------------/
Prova:  ADD     DH,04         ;
        LEA     SI,Dati       ; /-----*--------------------------------------\
        CMP     AH,0FFH       ; | Cod.|Codice Combinazione del Visualizzatore|
        JZ      Prov2         ; *-----*--------------------------------------*
        MOV     AL,00H        ; | 00H |Nessun Monitor                        |
        MOV     CX,13         ; | 01H |Adattatore MDA+Monitor monocromatico  |
Prov1:  CMP     AH,AL         ; | 02H |Adattatore CGA+Monitor a colori       |
        JZ      Prov3         ; | 03H |Codice Riservato                      |
        ADD     SI,62         ; | 04H |Adattatore EGA+Monitor a colori       |
        INC     AL            ; | 05H |Adattatore EGA+Monitor monocromatico  |
        LOOP    Prov1         ; | 06H |Adattatore PGA+Monitor a colori       |
        LEA     SI,Testo2     ; | 07H |Adattatore VGA+Monitor monocromatico  |
        CALL    STAmess       ; | 08H |Adattatore VGA+Monitor a colori       |
        MOV     DL,11         ; | 09H |Codice Riservato                      |
        CALL    SET_cur       ; | 0AH |Adattatore MCGA+Monitor a colori      |
        MOV     AL,AH         ; | 0BH |Adattatore MCGA+Monitor monocromatico |
        CALL    Byt2Asc       ; | 0CH |Adattatore MCGA+Monitor a colori      |
        JMP     SHORT Prov4   ; *-----*--------------------------------------*
Prov2:  LEA     SI,Testo3     ; | ??H |Codice Riservato                      |
Prov3:  CALL    STAmess       ; *-----*--------------------------------------*
Prov4:  LEA     SI,Cornic4    ; | FFH |Sistema di Visualizzazione sconosciuto|
        CALL    STAmess       ; \-----*--------------------------------------/
        RET                   ;


;*****************************************************************************
                              ; ----------------------------------------------
B10_1A01 proc   NEAR          ;|      AREA DEDICATA AL MAIN PROGRAM         ||
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
                              ; Inizializza a 1 il  numero  delle  Concorrenze
                              ; tra le combinazioni fornite e  le  Voci  della
                              ; Tabella ROM BIOS interna; come gi  detto pre-
   MOV Byte Ptr CS:[trovato],1; cedentemente si parte da 1 per tener conto del
                              ; fatto che la combinazione 00H/00H viene forni-
                              ; ta una sola volta, ma  deve  essere  computata
                              ; due volte come succede in tutti gli altri casi
                              ; tra coppie ammesse: infatti la variabile viene
                              ; incrementata sia (per esempio) con 02H/07H sia
                              ; con 07H/02H
        MOV     CH,00         ; /--------------------------------------------\
        MOV     CL,00         ; |       Prima FASE: Prepara il DeskTop       |
        MOV     DH,24         ; \--------------------------------------------/
        MOV     DL,79         ;
        MOV     BH,0FH        ; Produce un ClearScreen con aiuto della Funzio-
        MOV     AL,00         ; ne 06H dell'INT 10H BIOS (NB:CH=RigaAlto,  CL=
        MOV     AH,06H        ; =ColnAlto, DH=RigaBass, DL=ColnBass, BH=Colore
        INT     10H           ; e AL=0 (scorrere TUTTE le righe dello schermo)
        CALL    VIA_cur       ;
  MOV Byte Ptr CS:[ATTRIB],0EH;
        MOV     DH,01         ;
        LEA     SI,Testo0     ; Messaggio  di Presentazione del test
        CALL    STAmess       ;
        INC     DH            ;
  MOV Byte Ptr CS:[ATTRIB],0FH;
        LEA     SI,Cornic1    ;
        CALL    Tabelle       ;
        INC     DH            ; **** Prepara la zona  di  visualizzazione ****
        LEA     SI,Cornic2    ;
        CALL    Tabelle       ; /-----*--------------------------------------\
        INC     DH            ; | Cod.|Codice Combinaz.Visualizzat.~attivo~  |
        LEA     SI,Cornic0    ; \-----*--------------------------------------/
        CALL    STAmess       ; /-----*--------------------------------------\
        LEA     SI,Testo4     ; | Cod.|Codice Combinaz.Visualiz.~disattivo~  |
        CALL    STAmess       ; \-----*--------------------------------------/
        LEA     SI,Testo5     ; /-----*--------------------------------------\
        CALL    STAmess       ; |  | La Variabile di Sistema 0000:048AH   |
        LEA     SI,Testo6     ; |  | dell'Area  di  Comunicazione  BIOS   |
        CALL    STAmess       ; |  | contiene il valore xxH, che corri-   |
        LEA     SI,Testo7     ; |  | sponde esattamente alla coppia ora   |
        CALL    STAmess       ; |  | indicata  ed   detto  "Codice  di   |
        LEA     SI,Cornic4    ; |  | Combinazione" del Sistema            |
        CALL    STAmess       ; \-----*--------------------------------------/
        INC     DH            ;
        LEA     SI,Testo8     ;
        CALL    STAmess       ;
        ;---------------------- ----------------------------------------------
                              ; /--------------------------------------------\
        MOV     BL,00         ; |Seconda FASE: Punta il BUFFER con i due byts|
        MOV     BH,00         ; \--------------------------------------------/
XXX00:  PUSH    BX            ; Crea il "codice di combinazione" associato al-
        MOV     AL,01H        ; l'Adattatore e al Monitor collegato al  Siste-
        MOV     AH,1AH        ; ma di Visualizzazione "attivo" specificato  da
        INT     10H           ; BL e a quello dell'eventuale  secondo  Sistema
                              ; di Visualizzazione, "disattivo", passato in BH
        CMP     AL,1AH        ;
        JZ      XXX01         ;
        LEA     SI,Testo1     ;
        MOV     DH,09         ;
        MOV     DL,09         ; Stampa l'eventuale messaggio d'ERRORE
        CALL    SET_cur       ;
 MOV Byte Ptr CS:[ATTRIB],0CFH;
        CALL    BIOSmsg       ;
        POP     BX            ; (Recupera la posizione pendente dello  stack)
        JMP     _OUT          ;
        ;---------------------- ----------------------------------------------
                              ; /--------------------------------------------\
XXX01:  MOV     DH,02         ; |      Terza FASE: Esegue il test            |
        MOV     AH,BL         ; \--------------------------------------------/
        CALL    Prova         ; /-----*--------------------------------------\
        MOV     AH,BH         ; | xxH |Codice Combinaz.Visualizzat.~attivo~  |
        CALL    Prova         ; *-----*--------------------------------------*
        ADD     DH,5          ; | yyH |Codice Combinaz.Visualiz.~disattivo~  |
                              ; \-----*--------------------------------------/
  MOV Byte Ptr CS:[ATTRIB],8FH; Questa Funzione carica il byte che punta i due
        PUSH    ES            ; Codici nella Tabella ROM BIOS interna (uno per
        MOV     AX,0000H      ; ogni Sistema eventualmente presente sul Compu-
        MOV     ES,AX         ; ter)  nella  Variabile  di  Sistema 0000:048AH
        MOV     DI,048AH      ; dell'Area di Comunicazione BIOS; con esso con-
        MOV     DL,25         ; trolla l'esito del nostro test
        CALL    SET_cur       ;
        MOV     AL,ES:[DI]    ; Localizza e scrive il dato della Variabile di
        CALL    Byt2Asc       ; Sistema 0000:048AH
        POP     ES            ;
        MOV     DH,02         ;
        MOV     DL,52         ; Completa  le  segnalazioni  con  i  messaggi:
        CALL    SET_cur       ; /--------------------------------------------\
        LEA     SI,Testo02    ; |             "NON INCLUSA"                  |
        CMP     AL,0FFH       ; \--------------------------------------------/
        JZ      XXX02         ; /--------------------------------------------\
     INC Byte Ptr CS:[trovato]; |             "  INCLUSA  "                  |
        LEA     SI,Testo01    ; \--------------------------------------------/
XXX02:  CALL    BIOSmsg       ;
  MOV Byte Ptr CS:[ATTRIB],0FH;
                              ; ---------------------------------------------\
                              ; Attesa decisioni                             |
                              ; ---------------------------------------------/
        CALL    KEYwait       ; Rimane  in  attesa di  tasti premuti e, se ri-
        AND     AL,11011111B  ; sulta  premuto il tasto "Q",  viene imposto un
        POP     BX            ; ritorno  immediato  al  sistema  operativo; in
        CMP     AL,'Q'        ; BX si Recupera il valore corrente  dei  Numeri
        JZ      _OUT          ; associati  ai  SottoSistemi  sotto  prova
        INC     BL            ; /--------------------------------------------\
        CMP     BL,03H        ; |                                            |
        JNZ     XXX03         ; |                                            |
        INC     BL            ; |                                            |
XXX03:  CMP     BL,09H        ; |                                            |
        JNZ     XXX04         ; |                                            |
        INC     BL            ; |                                            |
XXX04:  CMP     BL,0DH        ; |Predispone la prova per un'altra combinazio-|
        JNZ     XXX07         ; |ne di  SottoSistemi  di  Visualizzazione; da|
        MOV     BL,00H        ; |notare che i "Codici Riservati", 03H e  09H,|
        INC     BH            ; |sono stati esclusi dalla prova              |
        CMP     BH,03H        ; |                                            |
        JNZ     XXX05         ; |      Sono previste 121 proposte            |
        INC     BH            ; |                                            |
XXX05:  CMP     BH,09H        ; |                                            |
        JNZ     XXX06         ; |                                            |
        INC     BH            ; |                                            |
XXX06:  CMP     BH,0DH        ; |                                            |
        JZ      _OUT          ; |                                            |
XXX07:  JMP     XXX00         ; \--------------------------------------------/
        ;---------------------- ----------------------------------------------
_OUT:   MOV     DH,22         ;
        CALL    SET_cur       ;
        LEA     SI,Testo9     ; Mostra il Numero di concorrenze riscontrate al
        CALL    STAmess       ; termine della prova
        MOV     DL,55         ;
        CALL    SET_cur       ;
        MOV    AL,CS:[trovato];
        CALL    Byt2Asc       ;

        PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;
 
B10_1A01 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
