
; Nel seguente programma  prodotto un notevole sforzo per rendere "dinamica"
; la procedura di stampa dei dati prelevati dal Buffer, cio per renderla
; indipendente dal numero di voci in essa contenute e dalle quantit di bytes
; per ciascuna di esse. Il lettore potr apprezzare la tecnica usata per
; raggiungere questo scopo, basata sull'uso di MACRO e PROCEDURE dedicate.

; La strategia per l'interpretazione e la stampa dei dati prelevati dal Buffer
; si basa sulle seguenti strutture: 1) il puntatore CS:DI  dedicato al
; prelievo dei dati dal Buffer; 2) il puntatore CS:SI  dedicato alla
; localizzazione della Tabella principale dei messaggi ("Testo1" o "Testo2" );
; essa contiene, per ogni voce del Buffer, la stringa che ne documenta la
; funzione, ma anche (oltre al solito terminatore 00H) il Numero di Bytes che
; sono previsti per essa e un codice tipologico APPOSITAMENTE CREATO per
; stabilire cosa fare sulla riga succesiva; 3) il codice tipologico pu essere
; di tre tipi: se vale "0" la stampa sulla riga successiva prosegue con
; l'interpretazione della prossima voce; se vale "FFH" la riga successiva
; viene lasciata vuota (per consentire di equalizzare la distribuzione delle
; informazioni al fine di garantire una piacevole lettura dentro il riquadro)
; (NB!!! in questo caso  NECESSARIO scegliere voci CON UN SOLO byte di dato);
; qualunque altro numero impone la stampa di SottoTabelle dedicate
; specificatamente alla voce appena descritta.

;/---------------------------------------------------------------------------\
;|NB: Vale la pena sottolineare che le stringhe dedicate ai messaggi di
;|questo programma sono spesso ridondanti, nel senso che dentro di essi sono
;|frequentemente contenuti delle frasi presenti anche in altri messaggi; per
;|esempio la parola "riservato"  citata spesso; naturalmente per risparmiare
;|(anche notevolmente) memoria di programma sarebbe opportuno frazionare ogni
;|testo nelle sue parti minime, associando a ciascuna di esse un'etichetta e
;|organizzando poi le combinazioni desiderate; nel caso di questo programma
;|si  volutamente evitato di seguire questa strategia al fine di renderlo
;|pi leggibile
;\---------------------------------------------------------------------------/

PAGE 66,132
TITLE ** B10_1B__.ASM - Fornisce informazioni sul Sistema di Visualizzazione
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1B__.ASM                         (INT 10H, Funzione 1CH)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Copia in un Buffer le informazioni legate al tipo e alle ca-|
;|               ratteristiche del  Sistema  di  Visualizzazione  corrente in|
;|               possesso del BIOS; la prima di esse  l'indirizzo segmentato|
;|               di un ulteriore zona Dati, interna alla ROM BIOS  del VIDEO;|
;|               anche di questa viene proposta l'analisi dettagliata.       |
;\---------------------------------------------------------------------------/
;/---------------------------------------------------------------------------\
;| MACRO       : M_msg0.MAC                                                  |
;| SINTASSI    : M_msg0 Testo1,Testo2                                        |
;| DESCRIZIONE : Organizza la stampa a livello BIOS della stringa ASCIIZ pun-|
;|               tata dal parametro "Testo", con l'attributo di Colore speci-|
;|               ficato nella variabile [ATTRIB] e nella  posizione di stampa|
;|               successiva alla riga precedentemente stampata.              |
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

M_msg0  MACRO   Testo1,Testo2
        PUSH    SI            ;\
        INC     DH            ;|
        MOV     DL,01         ;|Stampa i due messaggi relativi alla prova cor-
        CALL    SET_cur       ;|rente, lasciando intatto  SI,  che  in  questo
        LEA     SI,Testo1     ;|punto del programma conserva  l'indirizzo  del
        CALL    BIOSmsg       ;|primo dei messaggi interni  della Tabella Dati
        LEA     SI,Testo2     ;|
        CALL    BIOSmsg       ;|
        POP     SI            ;/
        ENDM


; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB
 
;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   BIOSmsg:NEAR
        EXTRN   BIOchr1:NEAR
        EXTRN   Wor2Asc:NEAR
        EXTRN   Byt2Asc:NEAR
        EXTRN   KEYwait:NEAR
        PUBLIC  ATTRIB        ;Attributo di colore

;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog
        ORG     0100H
INIZIO: JMP     B10_1B__

;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
Buffer  DB    64 DUP (00H)    ;Buffer di deposito DATI
ATTRIB  DB      0FH           ;Attributo di Colore
ELENCO1 DW  Tabl_01           ; Dettagli Voci 0025H/0026H /------------------\
        DB    0DH             ;                           |                  |
        DW  Tabl_02           ; Dettagli Voce 002AH       |    Voci della    |
        DB    07H             ;                           | TABELLA DINAMICA |
        DW  Tabl_03           ; Dettagli Voce 0031H,      |                  |
        DB    04H             ;                           \------------------/
Cornic0 DB "",00H
Cornic1 DB "OffstN Descrizione                               ",00H
Cornic2 DB "",00H
Cornic3 DB "",00H
Cornic4 DB "-------------------------------------------",00H
Cornic5 DB "",00H

           ;00 00 00 00 00 00 00 00                              
ENDtab0 DB "Ŀ",00H
ENDtab1 DB "   Valore esadecimle   ",00H
ENDtab2 DB "Ĵ",00H
ENDtab3 DB "",00H
Data___ DB "                                                  "
ENDtab4 DB "                       ",00H
ENDtab5 DB " trovato a ",00H 

Testo0 DB "Informazioni sul Tipo e sulle Caratteristiche del Sistema di "
       DB                                                "Visualizzazione",00H
Testo4 DB " La funzione NON  supportata o ha provocato malfunzionamento ",00H

;1) Dettaglio sulle Voci offerte dalla Tabella  Informazioni  Dati  DINAMICI
;   fornita dalla Funzione 1BH dell'INT 10H                                 
;-----------------------------------------------------------------------------
Testo1   DB "** TABELLA DATI di tipo DINAMICO assunta con la Funzione 1BH "
         DB                                              "dell'INT 10H **",00H
;Cornic0 DB "",00H
;Cornic1 DB "OffstN Descrizione                               ",00H
;Cornic2 DB "",00H
         DB "0000H 4Puntatore Tabella INFORMAZIONI STATICHE    ",00H, 4, 0
         DB "0004H 1Numero del MODO VIDEO corrente             ",00H, 1, 0
         DB "0005H 2Numero colonne nel MODO VIDEO corrente     ",00H, 2, 0
         DB "0007H 2Lunghezza Buffer Video visibile su schermo ",00H, 2, 0
         DB "0009H 2Indirizzo iniziale del Buffer Video        ",00H, 2, 0
         DB "000BH 2Posizione Cursore (Colonna,Riga) in Pagina0",00H, 2, 0
         DB "000DH 2Posizione Cursore (Colonna,Riga) in Pagina1",00H, 2, 0
         DB "000FH 2Posizione Cursore (Colonna,Riga) in Pagina2",00H, 2, 0
         DB "0011H 2Posizione Cursore (Colonna,Riga) in Pagina3",00H, 2, 0
         DB "0013H 2Posizione Cursore (Colonna,Riga) in Pagina4",00H, 2, 0
         DB "0015H 2Posizione Cursore (Colonna,Riga) in Pagina5",00H, 2, 0
         DB "0017H 2Posizione Cursore (Colonna,Riga) in Pagina6",00H, 2, 0
         DB "0019H 2Posizione Cursore (Colonna,Riga) in Pagina7",00H, 2, 0
         DB "001BH 1Linea di scansione iniziale del Cursore    ",00H, 1, 0
         DB "001CH 1Linea di scansione  finale  del Cursore    ",00H, 1, 0
         DB "001DH 1Numero Pagina Video attualmente attiva     ",00H, 1, 0
         DB "001EH 2N Registro Indirizzo Controller RTC, 03x4H",00H, 2, 0
         DB "0020H 1Contenuto Registr Controllo di Modo [03x8H]",00H,1,0FFH
         DB "0021H 1Contenuto Registr Colore Selezionato[03x9H]",00H,1,0FFH
         DB "0022H 1Numero di Righe di caratteri visualizzate  ",00H, 1, 0
         DB "0023H 2Altezza caratteri (in linee di scansione)  ",00H, 2, 0
         DB "0025H 1Codice Combinazione Visualizzatore ~attivo~",00H, 1, 1
         DB "0026H 1Codice Combinaz. Visualizzatore ~disattivo~",00H, 1, 1
         DB "0027H 2Numero Colori visualizzabili MODO corrente ",00H, 2, 0
         DB "0029H 1Numero Pagine supportate dal MODO corrente ",00H, 1, 0
         DB "002AH 1Numero linee di scansione attive su schermo",00H, 1, 2
         DB "002BH 1Tabella  primaria  Generatore chr HARDWARE ",00H, 1, 0
         DB "002CH 1Tabella secondaria Generatore chr HARDWARE ",00H, 1, 0
         DB "002DH 1Informazioni varie                         ",00H, 1, 4
         DB "002EH 3Riservati (di norma a 00H)                 ",00H, 3, 0
         DB "0031H 1Numero Blocchi di 64k di memoria disponibil",00H, 1, 3
         DB "0032H 1Stato dell'Area di salvataggio attuale     ",00H, 1, 5
         DB "0033H13Riservati (di norma tutti a 00H)           ",00H,13, 0
;Cornic3 DB "",00H

;*****************************************************************************
;2) Dettaglio  sulle Voci  offerte dalla  Tabella  Informazioni Dati STATICI
;   fornita dal  puntatore  scritto  nelle  prime  quattro  locazioni  della
;   Tabella precedente                                                      
;-----------------------------------------------------------------------------
Testo2  DB "** TABELLA DATI di tipo  STATICO interna alla ROM BIOS della "
        DB                                               "Scheda VIDEO **",00H
;Cornic0 DB "",00H
;Cornic1 DB "OffstN Descrizione                               ",00H
;Cornic2 DB "",00H
         DB "0000H 1 Primo  Elenco dei MODI VIDEO supportati   ",00H, 1, 6
         DB "0001H 1Secondo Elenco dei MODI VIDEO supportati   ",00H, 1, 7
         DB "0002H 1 Terzo  Elenco dei MODI VIDEO supportati   ",00H, 1, 8
         DB "0003H 1Quarto  Elenco dei MODI VIDEO supportati   ",00H, 1, 9
         DB "0004H 1Quinto  Elenco dei MODI VIDEO supportati   ",00H, 1,10
         DB "0005H 1 Sesto  Elenco dei MODI VIDEO supportati   ",00H, 1,11
         DB "0006H 1Settimo Elenco dei MODI VIDEO supportati   ",00H, 1,12
         DB "0007H 1Linee scansione  disponibili nei MODI TESTO",00H, 1,13
         DB "0008H 1Numero massimo Set  visualizzab. MODO TESTO",00H, 1, 0
         DB "0009H 1Numero massimo Tabelle GENERATORE HARDWARE ",00H, 1, 0
         DB "000AH 1Funzioni BIOS VIDEO disponibili se bitX=1  ",00H, 1,14
         DB "000BH 1Funzioni BIOS VIDEO disponibili se bitX=1  ",00H, 1,15
         DB "000CH 2Riservati (di norma a 00H)                 ",00H, 2, 0
         DB "000EH 1Stato dell'Area di salvataggio attuale     ",00H, 1,16
         DB "000FH 1Riservato (di norma a 00H)                 ",00H, 1, 0
;Cornic3 DB "",00H

;*****************************************************************************
;3) SottoTabelle con le descrizioni delle Voci che richiedono pi Dettaglio 
;-----------------------------------------------------------------------------
;Dettaglio Voci 0025H/0026H Cod.Combinaz.Visualiz.attivo/disatt.  TAB.DINAM.
;-----------------------------------------------------------------------------
Tabl_01  DB " ĳ00Nessun Monitor                             ",00H
         DB " ĳ01Adattatore MDA Monitor monocromatico       ",00H
         DB " ĳ02Adattatore CGA Monitor a colori            ",00H
         DB " ĳ03Codice Riservato                           ",00H
         DB " ĳ04Adattatore EGA Monitor a colori            ",00H
         DB " ĳ05Adattatore EGA Monitor monocromatico       ",00H
         DB " ĳ06Adattatore PGA Monitor a colori            ",00H
         DB " ĳ07Adattatore VGA Monitor monocrom. analogico ",00H
         DB " ĳ08Adattatore VGA Monitor a colori  analogico ",00H
         DB " ĳ09Codice Riservato                           ",00H
         DB " ĳ0AAdattatore MCGA Monitor a colori digitale  ",00H
         DB " ĳ0BAdattatore MCGA Monitor monocrom. analogico",00H
         DB " ĳ0CAdattatore MCGA Monitor a colori  analogico",00H
Tabl__0  DB " ĳ  Codice Riservato (Valore non attendibile)  ",00H
Tabl__1  DB " ĳFFSistema di Visualizzazione sconosciuto     ",00H

;Dettaglio Voce 002AH, Numero linee scans.attive su schermo TABELLA DINAMICA
;-----------------------------------------------------------------------------
Tabl_02  DB " ĳ00         per 200 linee di scansione        ",00H
         DB " ĳ01         per 350 linee di scansione        ",00H
         DB " ĳ02         per 400 linee di scansione        ",00H
         DB " ĳ03         per 480 linee di scansione        ",00H
         DB " ĳ04         per 512 linee di scansione        ",00H
         DB " ĳ05         per 600 linee di scansione        ",00H
         DB " ĳ06         per 768 linee di scansione        ",00H
      ;  DB " ĳ           07HFFH numeri riservati

;Dettaglio Voce 0031H, Numero Blocchi 64k memoria dispon.   TABELLA DINAMICA
;-----------------------------------------------------------------------------
Tabl_03  DB " ĳ00      64K  di memoria RAM per il Video     ",00H
         DB " ĳ01     128K  di memoria RAM per il Video     ",00H
         DB " ĳ02     192K  di memoria RAM per il Video     ",00H
         DB " ĳ03   256K o pi di memoria RAM per il Video  ",00H
;Tabl__0 DB " ĳ  Codice Riservato                           ",00H

;Dettaglio Voce 002DH, Informazioni varie                   TABELLA DINAMICA
;-----------------------------------------------------------------------------
Tabl_04  DB "  bit7=0 Riservato (di norma 0)                     bit7",00H
         DB "  bit6=0 Riservato (di norma 0)                     bit6",00H
         DB "  bit5=0 Abilita alta intensit;1=abilita lampeggio bit5",00H
         DB "  bit4=1 Abilita emulazione del Cursore             bit4",00H
         DB "  bit3=1 Caricamento tavolozza di default disabilit.bit3",00H
         DB "  bit2=1 Collegato Monitor monocromatico            bit2",00H
         DB "  bit1=1 Abilitato calcolo della scala dei grigi    bit1",00H
         DB "  bit0=1 Tutti i MODI sono attivi su tutti i Sistemibit0",00H

;Dettaglio Voce 0032H, Stato sull'Area Salvataggio attuale  TABELLA DINAMICA
;-----------------------------------------------------------------------------
Tabl_05  DB "  bit7=0 Riservato (di norma 0)                     bit7",00H
         DB "  bit6=0 Riservato (di norma 0)                     bit6",00H
         DB "  bit5=1 Estensione Cod.Combinaz.Visualizzat. attivabit5",00H
         DB "  bit4=1 Override di Tavolozza attivo               bit4",00H
         DB "  bit3=1 Override del Set Caratteri GRAFICI attivo  bit3",00H
         DB "  bit2=1 Override del Set Caratteri ALFANUM. attivo bit2",00H
         DB "  bit1=1 Area di salvataggio dinamico attiva        bit1",00H
         DB "  bit0=1 Sono attivi DUE set (512 caratteri)        bit0",00H

;Dettaglio Voce 0000H, Primo Elenco MODI VIDEO supportati    TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_06  DB "  bit7=1 Modo 07H supportato,  Testo,  80x25,  mono bit7",00H
         DB "  bit6=1 Modo 06H supportato, Grafico, 640x200, B&W bit6",00H
         DB "  bit5=1 Modo 05H supportato, Grafico, 320x200,  4  bit5",00H
         DB "  bit4=1 Modo 04H supportato, Grafico, 320x200,  4  bit4",00H
         DB "  bit3=1 Modo 03H supportato,  Testo,  80x25,   16  bit3",00H
         DB "  bit2=1 Modo 02H supportato,  Testo,  80x25,   16  bit2",00H
         DB "  bit1=1 Modo 01H supportato,  Testo,  40x25,   16  bit1",00H
         DB "  bit0=1 Modo 00H supportato,  Testo,  40x25,   16  bit0",00H

;Dettaglio Voce 0001H, Secondo Elenco MODI VIDEO supportati  TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_07  DB "  bit7=1 Modo 0FH supportato, Grafico, 640x350, monobit7",00H
         DB "  bit6=1 Modo 0EH supportato, Grafico, 640x200,  16 bit6",00H
         DB "  bit5=1 Modo 0DH supportato, Grafico, 320x200,  16 bit5",00H
         DB "  bit4=1 Modo 0CH supportato, ......................bit4",00H
         DB "  bit3=1 Modo 0BH supportato, ......................bit3",00H
         DB "  bit2=1 Modo 0AH supportato, Grafico, 640x200,   4 bit2",00H
         DB "  bit1=1 Modo 09H supportato, Grafico, 320x200,  16 bit1",00H
         DB "  bit0=1 Modo 08H supportato, Grafico, 160x200,  16 bit0",00H

;Dettaglio Voce 0002H, Terzo Elenco MODI VIDEO supportati    TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_08  DB "  bit7=0 Riservato (di norma 0)                     bit7",00H
         DB "  bit6=0 Riservato (di norma 0)                     bit6",00H
         DB "  bit5=0 Riservato (di norma 0)                     bit5",00H
         DB "  bit4=0 Riservato (di norma 0)                     bit4",00H
         DB "  bit3=1 Modo 13H supportato, Grafico, 320x200, 256 bit3",00H
         DB "  bit2=1 Modo 12H supportato, Grafico, 640x480, 16  bit2",00H
         DB "  bit1=1 Modo 11H supportato, Grafico, 640x480, monobit1",00H
         DB "  bit0=1 Modo 10H supportato, Grafico, 640x350, 16  bit0",00H

;Dettaglio Voce 0003H, Quarto Elenco MODI VIDEO supportati   TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_09  DB "  bit7=0 Riservato (altrimenti Modo 1FH supportato) bit7",00H
         DB "  bit6=0 Riservato (altrimenti Modo 1EH supportato) bit6",00H
         DB "  bit5=0 Riservato (altrimenti Modo 1DH supportato) bit5",00H
         DB "  bit4=0 Riservato (altrimenti Modo 1CH supportato) bit4",00H
         DB "  bit3=0 Riservato (altrimenti Modo 1BH supportato) bit3",00H
         DB "  bit2=0 Riservato (altrimenti Modo 1AH supportato) bit2",00H
         DB "  bit1=0 Riservato (altrimenti Modo 19H supportato) bit1",00H
         DB "  bit0=0 Riservato (altrimenti Modo 18H supportato) bit0",00H

;Dettaglio Voce 0004H, Quinto Elenco MODI VIDEO supportati   TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_10  DB "  bit7=0 Riservato (altrimenti Modo 27H supportato) bit7",00H
         DB "  bit6=0 Riservato (altrimenti Modo 26H supportato) bit6",00H
         DB "  bit5=0 Riservato (altrimenti Modo 25H supportato) bit5",00H
         DB "  bit4=0 Riservato (altrimenti Modo 24H supportato) bit4",00H
         DB "  bit3=0 Riservato (altrimenti Modo 23H supportato) bit3",00H
         DB "  bit2=0 Riservato (altrimenti Modo 22H supportato) bit2",00H
         DB "  bit1=0 Riservato (altrimenti Modo 21H supportato) bit1",00H
         DB "  bit0=0 Riservato (altrimenti Modo 20H supportato) bit0",00H

;Dettaglio Voce 0005H, Sesto Elenco MODI VIDEO supportati    TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_11  DB "  bit7=0 Riservato (altrimenti Modo 2FH supportato) bit7",00H
         DB "  bit6=0 Riservato (altrimenti Modo 2EH supportato) bit6",00H
         DB "  bit5=0 Riservato (altrimenti Modo 2DH supportato) bit5",00H
         DB "  bit4=0 Riservato (altrimenti Modo 2CH supportato) bit4",00H
         DB "  bit3=0 Riservato (altrimenti Modo 2BH supportato) bit3",00H
         DB "  bit2=0 Riservato (altrimenti Modo 2AH supportato) bit2",00H
         DB "  bit1=0 Riservato (altrimenti Modo 29H supportato) bit1",00H
         DB "  bit0=0 Riservato (altrimenti Modo 28H supportato) bit0",00H

;Dettaglio Voce 0006H, Settimo Elenco MODI VIDEO supportati  TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_12  DB "  bit7=0 Riservato (altrimenti Modo 37H supportato) bit7",00H
         DB "  bit6=0 Riservato (altrimenti Modo 36H supportato) bit6",00H
         DB "  bit5=0 Riservato (altrimenti Modo 35H supportato) bit5",00H
         DB "  bit4=0 Riservato (altrimenti Modo 34H supportato) bit4",00H
         DB "  bit3=0 Riservato (altrimenti Modo 33H supportato) bit3",00H
         DB "  bit2=0 Riservato (altrimenti Modo 32H supportato) bit2",00H
         DB "  bit1=0 Riservato (altrimenti Modo 31H supportato) bit1",00H
         DB "  bit0=0 Riservato (altrimenti Modo 30H supportato) bit0",00H

;Dettaglio Voce 0007H, Linee scans. disponibili MODI TESTO   TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_13  DB "  bit7=0 Riservato (di norma 0)                     bit7",00H
         DB "  bit6=0 Riservato (di norma 0)                     bit6",00H
         DB "  bit5=0 Riservato (di norma 0)                     bit5",00H
         DB "  bit4=0 Riservato (di norma 0)                     bit4",00H
         DB "  bit3=0 Riservato (di norma 0)                     bit3",00H
         DB "  bit2=1 Disponibili 200 linee di scansione         bit2",00H
         DB "  bit1=1 Disponibili 350 linee di scansione         bit1",00H
         DB "  bit0=1 Disponibili 400 linee di scansione         bit0",00H

;Dettaglio Voce 000AH, Funz.BIOS VIDEO disponibili se bitX=1 TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_14  DB "  bit7=1 Controllo DAC con Registro Selezione Colorebit7",00H
         DB "  bit6=1 Disponib.  caricamento colori nei DAC videobit6",00H
         DB "  bit5=1 Disponibile tavolozza EGA a 64 colori      bit5",00H
         DB "  bit4=1 Possibile l'emulazione del Cursore         bit4",00H
         DB "  bit3=1 Possibile caricamento tavolozza di default bit3",00H
         DB "  bit2=1 Possibile caricamento dei FONT di caratteribit2",00H
         DB "  bit1=1 Possibile il calcolo della scala dei grigi bit1",00H
         DB "  bit0=1 Tutti i MODI sono attivi su tutti i Sistemibit0",00H

;Dettaglio Voce 000BH, Funz.BIOS VIDEO disponibili se bitX=1 TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_15  DB "  bit7=0 Riservato (di norma 0)                     bit7",00H
         DB "  bit6=0 Riservato (di norma 0)                     bit6",00H
         DB "  bit5=0 Riservato (di norma 0)                     bit5",00H
         DB "  bit4=0 Riservato (di norma 0)                     bit4",00H
         DB "  bit3=1 Possibile la gestione del Codice Combinaz. bit3",00H
         DB "  bit2=1 Possibile lampeggio/alta intensit sfondo  bit2",00H
         DB "  bit1=1 Possibile salvatagg./ripristino stato videobit1",00H
         DB "  bit0=1 Utilizzabile la penna ottica               bit0",00H

;Dettaglio Voce 000EH, Stato dell'Area Salvataggio attuale   TABELLA STATICA
;-----------------------------------------------------------------------------
Tabl_16  DB "  bit7=0 Riservato (di norma 0)                     bit7",00H
         DB "  bit6=0 Riservato (di norma 0)                     bit6",00H
         DB "  bit5=1 Utilizzab.estens. Cod.Combinaz.Visualizzat.bit5",00H
         DB "  bit4=1 Utilizzabile override di Tavolozza         bit4",00H
         DB "  bit3=1 Utilizzabile override Set Caratteri GRAFICIbit3",00H
         DB "  bit2=1 Utilizzabile override Set Caratteri ALFANUMbit2",00H
         DB "  bit1=1 Utilizzabile Area di salvataggio dinamico  bit1",00H
         DB "  bit0=1 Utilizzabili DUE set (512 caratteri)       bit0",00H


;AREA DESTINATA ALLE PROCEDURE DEL PROGRAMMA
;/---------------------------------------------------------------------------\
;| PROCEDURA   : STAdati                                                     |
;| DESCRIZIONE : Organizza la stampa "dinamica" della Tabella dei Dati, asso-|
;|               ciando ad ogni voce i relativi bytes, eventualmente su pagi-|
;|               ne multiple.                                                |
;\---------------------------------------------------------------------------/
STAdati:INC     DH            ;
        CMP     DH,23         ;
        JB      STAdat2       ;
        PUSH    SI            ;
        CALL    KEYwait       ;
        POP     SI            ; Se le righe della tabella superano la  Pagina
        MOV     DH,6          ; corrente se ne inizializza una nuova
        PUSH    DX            ;
        MOV     CX,16         ;
STAdat1:CALL    STAvuot       ;
        LOOP    STAdat1       ;
        POP     DX            ;
STAdat2:MOV     DL,01         ; In ingresso SI punta l'indirizzo del messaggio
        CALL    SET_cur       ; interno corrente
        CALL    BIOSmsg       ;
        PUSH    SI            ; Stampa la zona in cui verranno inseriti "dina-
        LEA     SI,ENDtab4    ; micamente" i bytes di ogni voce della  Tabella
        CALL    BIOSmsg       ;
        POP     SI            ; Il messaggio di ogni voce della Tabella porta,
        INC     SI            ; dopo il terminatore, il numero di bytes di da-
        MOV     CL,CS:[SI]    ; to previsti per essa; con esso carica il  con-
        INC     SI            ; tatore CX
        MOV     BL,CS:[SI]    ; Interpreta il codice di tipologia posto subito
        INC     SI            ; dopo il numero di bytes di dato  previsti  per
        CMP     BL,00H        ; la voce corrente della Tabella porta; se  esso
        JNZ     STAdatA       ;  "0" non  necessario alcun servizio partico-
        JMP     STAdatC       ; lare e si rientra nella stampa Normale
STAdatA:CALL    STAdat7       ;
        CMP     BL,0FFH       ; Se si tratta  del  codice  FFH   prevista  la
        JNZ     STAdatB       ; stampa di una riga vuota  dopo  la  precedente
        JMP     STAvuot       ;
STAdatB:CMP     BL,03H        ; Altrimenti attiva o il servizio bit per bit o
        JA      SERVbit       ; quello di  interpretazione  dell'intero bytes
        JMP     SERVchk       ;
        ;---------------------- ----------------------------------------------
SERVbit:PUSH    SI            ; /--------------------------------------------\
        M_msg0 Cornic4,ENDtab4; |Interpreta la Voce corrente bit per bit     |
        DEC     DI            ; \--------------------------------------------/
        MOV     BH,CS:[DI]    ; Riprende in BH  il  valore  esadecimale  sotto
        INC     DI            ; test
        PUSH    BX            ;
        PUSH    DX            ; Ciascun messaggio   lungo  esattamente 59 ca-
        LEA     SI,Tabl_04    ; ratteri, quindi ciascun gruppo ne occupa 59*8;
        MOV     AX,59*8       ; in BL c' il numero della  tabella (certamente
        SUB     BL,04H        ; maggiore o uguale a 4)  per cui si  prepara il
        MOV     BH,00H        ; moltiplicatore BX=(4-BL) di AX al fine di pre-
        MUL     BX            ; di sporre il puntatore al gruppo  di  messaggi
        ADD     SI,AX         ; associato alla Voce corrente
        POP     DX            ;
        POP     BX            ;
        MOV     CX,0008H      ;
SERVbi0:INC     DH            ;
        MOV     DL,01         ;
        CALL    SET_cur       ;
        CALL    BIOSmsg       ;
        PUSH    SI            ;
        LEA     SI,ENDtab5    ; Stampa ogni testo del gruppo  e  gli  aggiunge
        CALL    BIOSmsg       ; l'interpretazione numerica del bit corrente
        MOV     AL,"1"        ;
        SHL     BH,1          ;
        JC      SERVbi1       ;
        DEC     AL            ;
SERVbi1:CALL    BIOchr1       ;
        POP     SI            ;
        INC     SI            ;
        LOOP    SERVbi0       ;
        M_msg0 Cornic5,ENDtab4;
        MOV     DL,54         ;
        CALL    SET_cur       ; Chiude il pacchetto di otto  stringhe  con  le
        MOV     AL,"*"        ; operazioni graficamente necessarie
        CALL    BIOchr1       ;
        MOV     CX,0006       ;
        CMP     BL,06         ;
        JB      SERVbi3       ;
        CMP     BL,15         ; Integra la pagina con  eventuali  righe  vuote
        JZ      SERVbi2       ; (il cui  numero   stabilito  sperimentalmente
        SUB     CX,0002       ; per garantire una piacevole presentazione del-
        CMP     BL,14         ; le informazioni); da  notare che  BH  conserva
        JZ      SERVbi2       ; ancora il valore esadecimale sotto test  e  BL
        ADD     CX,0002       ; il numero di Tabella-Dati da  trattare,  sulla
        CMP     BL,14         ; base del quale verr stabilito  il  numero  di
        JA      SERVbi3       ; righe vuote necessarie
SERVbi2:CALL    STAvuot       ;
        LOOP    SERVbi2       ;
SERVbi3:POP     SI            ;
        RET                   ;
        ;---------------------- ----------------------------------------------
                              ; /--------------------------------------------\
SERVchk:PUSH    SI            ; |Interpreta la Voce corrente in funzione  del|
                              ; |suo valore, scegliendo il significato       |
                              ; \--------------------------------------------/
        LEA     SI,ELENCO1    ; Con l'aiuto dei una Tabella di Vettori (ELENC-
        DEC     BL            ; O1) in BL c' il numero della  Tabella-Dati da
        MOV     BH,BL         ; localizzare (certamente compreso  tra  1  e 3)
        SHL     BL,1          ; per cui si prepara in BX  lo  spiazzamento per
        ADD     BL,BH         ; puntare la terna di bytes che  ci  interessano
        MOV     BH,00H        ; (ogni Voce di ELENCO1  costituita  dall'indi-
        ADD     SI,BX         ; rizzo della Tabella-Dati  seguita  dal  numero
        MOV     AX,CS:[SI]    ; che rappresenta la quantit di  possibili  al-
        MOV     BL,CS:[SI+2]  ; ternative: il primo viene lasciato in SI e  il
        MOV     SI,AX         ; secondo viene lasciato in BL
                              ; Riprende in BH  il  valore  esadecimale  sotto
        DEC     DI            ; test, da confrontare con BL al fine di  stabi-
        MOV     BH,CS:[DI]    ; lire quale tra i possibili messaggi  sar  ef-
        INC     DI            ; fettivamente proposto a video
        CMP     BH,0FFH       ; Nel caso particolare i BH=0FFH   previsto  un
        JNZ     SERVck0       ; messaggio dedicato:
        M_msg0 Tabl__1,ENDtab4; "Sistema di Visualizzazione sconosciuto"
        JMP     SHORT SERVck2 ;
SERVck0:CMP     BH,BL         ; Nel caso in cui il valore di BH sia maggiore o
        JB      SERVck1       ; uguale al primo Codice non ammesso si  propone
        M_msg0 Tabl__0,ENDtab4; il messaggio: "Codice Riservato"
        MOV     DL,08         ;
        CALL    SET_cur       ;
        MOV     AL,BH         ;
        CALL    Byt2Asc       ;
        JMP     SHORT SERVck2 ;
SERVck1:PUSH    DX            ;
        MOV     AX,54         ;
        MOV     BL,BH         ;
        MOV     BH,00H        ; In tutti gli altri casi si ricava il puntatore
        MUL     BX            ; al corretto messaggio sapendo che ciascuno  di
        ADD     SI,AX         ; essi  lungo esattamente 54 caratteri; per mo-
        POP     DX            ; tivi si  deciso di aggiungere  una riga vuota
        INC     DH            ;
        MOV     DL,01         ;
        CALL    SET_cur       ;
        CALL    BIOSmsg       ;
SERVck2:CALL    STAvuot       ;
        POP     SI            ;
        RET                   ;
        ;---------------------- ----------------------------------------------
                              ; /--------------------------------------------\
                              ; |Organizza la stampa NORMALE delle Voci      |
                              ; \--------------------------------------------/
STAdatC:MOV     CH,00H        ; Controlla la quantit di dati  da  stampare e,
        CMP     CX,0008H      ; se sono pi di otto gli organizza su righe di-
        JA      STAdat3       ; verse successsive;  altrimenti  provvede  alla
        CALL    STAdat7       ; stampa direttamente sulla riga corrente
        RET                   ;
        ;---------------------- ----------------------------------------------
STAdat3:MOV     AX,CX         ; A partire dal numero di Dati previsti,  dispo-
        MOV     BL,08H        ; nibile in CX, calcola  il  contatore "esterno"
        DIV     BL            ; necessario per organizzare la stampa dei grup-
        MOV     CL,AL         ; pi di (almeno) otto Dati, lasciato in  CX (non
        MOV     CH,00H        ; c' il pericolo che  questo  numero sia zero!)
STAdat4:PUSH    CX            ; Sono stati rilevati CX gruppi completi da otto
        MOV     CX,0008H      ; dati ciascuno
        PUSH    AX            ; Vengono stampati singolarmente in sequenza nel
        CALL    STAdat7       ; Box dati predisposto in precedenza (notare che
        POP     AX            ; il valore del resto AH viene salvaguardato)
        POP     CX            ; Se non si tratta dell'ultimo  gruppo  di  otto
        CMP     CL,01H        ; dati, si predispone la riga vuota per inserire
        JNZ     STAdat5       ; i successivi, a meno che la cosa non  sia  ne-
        CMP     AH,00H        ; cessaria, perch il "resto"  della  precedente
        JZ      STAdat6       ; divisione  zero (e quindi non ci sono pi da-
STAdat5:CALL    STAvuot       ; ti relativi alla voce corrente); notare che il
        LOOP    STAdat4       ; valore del resto AH viene ancora salvaguardato
STAdat6:MOV     CL,AH         ; Recupera in AH il "resto" della divisione pre-
        MOV     CH,00H        ; cedente, cio il numero di Dati che  rimangono
        CMP     CX,0000H      ; da stampare. ATTENZIONE:  se  questo  numero 
        JZ      STAdat9       ; zero si DEVE tornare  immediatamente  al chia-
                              ; mante, altrimenti vengono stampati 65536 bytes
        ;---------------------- ----------------------------------------------
STAdat7:MOV     DL,55         ; Fissa la posizione di stampa
        CALL    SET_cur       ;
STAdat8:MOV     AL,CS:[DI]    ;
        INC     DI            ; Stampa tutti i dati di un gruppo di almeno ot-
        CALL    Byt2Asc       ; to consecutivi; ognuno di  essi   seguito  da
        CMP     CL,01H        ; uno spazio, a meno che non  sia  l'ultimo egli
        JZ      STAdat9       ; otto; da notare che se il numero del contatore
        MOV     AL," "        ; interno  minore di otto viene imposta l'usci-
        CALL    BIOchr1       ; ta immediata dal Loop
        LOOP    STAdat8       ;
STAdat9:RET

;/---------------------------------------------------------------------------\
;| PROCEDURA   : STAvuot                                                     |
;| DESCRIZIONE : Stampa una riga vuota della Tabella                         |
;\---------------------------------------------------------------------------/
STAvuot:PUSH    AX            ;
        PUSH    SI            ;
        INC     DH            ;
        MOV     DL,01         ;
        CALL    SET_cur       ; Stampa una riga vuota sulla riga  successiva a
        LEA     SI,Data___    ; quella attualmente posta a video
        CALL    BIOSmsg       ;
        POP     SI            ;
        POP     AX            ;
        RET                   ;

;/---------------------------------------------------------------------------\
;| PROCEDURA   : DeskTop                                                     |
;| DESCRIZIONE : Stampa una riga vuota della Tabella                         |
;\---------------------------------------------------------------------------/
DeskTop:PUSH    SI            ;
  MOV Byte Ptr CS:[ATTRIB],0EH;
        MOV     DH,01         ;
        MOV     DL,02         ;
        CALL    SET_cur       ;
        LEA     SI,Testo0     ; Messaggi di Presentazione del test; in  uscita
        CALL    BIOSmsg       ; SI punta l'indirizzo del  primo  messaggio in-
        POP     SI            ; terno
        INC     DH            ;
        CALL    SET_cur       ;
        CALL    BIOSmsg       ;
        INC     SI            ;
  MOV Byte Ptr CS:[ATTRIB],0FH;
        M_msg0 Cornic0,ENDtab0; /--*---*-----------------------*------------\
        M_msg0 Cornic1,ENDtab1; |N|OFS| Descrizione           |  Valore    |
        M_msg0 Cornic2,ENDtab2; *--*---*-----------------------*------------*
        MOV     CX,17         ; |  |   |                       |            |
XXX00:  CALL    STAvuot       ; |  |   |                       |            |
        LOOP    XXX00         ; |  |   |                       |            |
        M_msg0 Cornic3,ENDtab3; \--*---*-----------------------*------------/
        RET                   ;


;*****************************************************************************
                              ; ----------------------------------------------
B10_1B__ proc   NEAR          ;     AREA DEDICATA AL MAIN PROGRAM        
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        MOV     CH,00         ; /--------------------------------------------\
        MOV     CL,00         ; |Prima FASE: Prepara il BUFFER e il DeskTop  |
        MOV     DH,24         ; \--------------------------------------------/
        MOV     DL,79         ;
        MOV     BH,0FH        ; Produce un ClearScreen con aiuto della Funzio-
        MOV     AL,00         ; ne 06H dell'INT 10H BIOS (NB:CH=RigaAlto,  CL=
        MOV     AH,06H        ; =ColnAlto, DH=RigaBass, DL=ColnBass, BH=Colore
        INT     10H           ; e AL=0 (scorrere TUTTE le righe dello schermo)
        ;---------------------- ----------------------------------------------
        PUSH    ES            ; /--------------------------------------------\
        PUSH    CS            ; |Seconda FASE: Scrive i Dati nel BUFFER      |
        POP     ES            ; \--------------------------------------------/
        LEA     DI,Buffer     ;
        MOV     BX,0000H;Tipo ;
        MOV     AH,1BH        ;
        INT     10H           ;
        POP     ES            ;
        CMP     AL,1BH        ;
        JZ      XXX01         ;
        LEA     SI,Testo4     ;
        MOV     DH,12         ;
        MOV     DL,09         ; Stampa l'eventuale messaggio d'ERRORE
        CALL    SET_cur       ;
 MOV Byte Ptr CS:[ATTRIB],0CFH;
        CALL    BIOSmsg       ;
        JMP     _OUT          ;
        ;---------------------- ----------------------------------------------
XXX01:  CALL    VIA_cur       ; /--------------------------------------------\
        LEA     SI,Testo1     ; |Terza FASE: Organizza i Dati DINAMICI       |
        CALL    DeskTop       ; \--------------------------------------------/
        MOV     DH,5          ;
        MOV     CX,33         ;
        LEA     DI,Buffer     ;
XXX02:  PUSH    CX            ;
        CALL    STAdati       ; Inizializza il puntatore al  Buffer dei Dati e
        POP     CX            ; provvede alla stampa delle voci previste nella
        LOOP    XXX02         ; Tabella
        CALL    KEYwait       ; Aspetta la pressione di un tasto e poi esce
                              ;
        CALL    VIA_cur       ; /--------------------------------------------\
        LEA     SI,Testo2     ; |Quarta FASE: Organizza i Dati STATICI       |
        CALL    DeskTop       ; \--------------------------------------------/
        PUSH    DS            ;
        PUSH    ES            ;
        PUSH    SI            ;
        PUSH    CS            ;
        POP     ES            ; Carica il Buffer di deposito dei  dati  con  i
        LEA     DI,Buffer     ; valori prelevati dalla Tabella  Interna  della
        MOV     SI,CS:[DI]    ; ROM BIOS sulla Scheda Video
        MOV     DS,CS:[DI+2]  ;
        MOV     CX,16         ; /--------------------------------------------\
        REP     MOVSW         ; |   NB:    MOVSW =/ ES:[DI]    DS:[SI]      |
        POP     SI            ; |                 \ ES:[DI+1]  DS:[SI+1]    |
        POP     ES            ; \--------------------------------------------/
        POP     DS            ;
        MOV     DH,5          ;
        MOV     CX,15         ;
        LEA     DI,Buffer     ; Inizializza il puntatore al  Buffer dei Dati e
XXX03:  PUSH    CX            ; provvede alla stampa delle voci previste nella
        CALL    STAdati       ; Tabella
        POP     CX            ;
        LOOP    XXX03         ;
        CALL    KEYwait       ; Aspetta la pressione di un tasto e poi esce
                              ;
        ;---------------------------------------------------------------------
_OUT:    
        PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;
 
B10_1B__ ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
