PAGE 66,132
TITLE ** B10_1121.ASM - Caricatore di FONT predisposto direttamente nel progr.
SUBTTL** Raccolta MASTER di programmi - copyright ing. Giorgio OBER  (01/1997)
;/---------------------------------------------------------------------------\
;| NOME        : B10_1121.ASM                         (INT 10H, Funzione 11H)|
;| AUTORE      : Giorgio OBER                                                |
;| VERSIONE    : gennaio 1997                                                |
;| DESCRIZIONE : Organizza il caricamento di una Tabella  creata  dall'Utente|
;|               costituita da 256 Caratteri da 00H a FFH, puntata in ingres-|
;|               so dall'indirizzo segmentato ES:BP  e  usata  dal GENERATORE|
;|               SOFTWARE del BIOS nei MODI GRAFICI esclusi quelli CGA COMPA-|
;|               TIBILI, 04H e 05H (40x25, 8x8, 320x200  a  quattro colori) e|
;|               06H (80x25, 8x8, 640x200, a due colori), per i quali possono|
;|               esser definiti solo i primi 128 Caratteri (00H7FH).        |
;|                                                                           |
;|               Per rendere attivo il  nuovo  FONT   necessario indicare il|
;|               numero di Righe  di testo  che  possono  essere visualizzate|
;|               sullo schermo (con BL=00H tale numero va posto in DL); biso-|
;|               gna poi costruire una Tabella inserendovi CX bytes per  ogni|
;|               carattere (CX  dunque l'altezza di ciascuno di essi).      |
;|                                                                           |
;|               Il nuovo FONT  "visto" dal GENERATORE di Caratteri  per  il|
;|               fatto che il suo puntatore (ES:BP)  poi copiato dalla  Sot-|
;|               toFunzione 21H nelle locazioni  della Tabella dei Vettori (a|
;|               partire dall'indirizzo 0000:010CH) corrispondenti a INT 43H.|
;\---------------------------------------------------------------------------/
;/---------------------------------------------------------------------------\
;|               Questo programma installa "MioFont" disponibile nel pacchet-|
;|               to sotto forma di File sorgente (.ASM); inoltre  sostituisce|
;|               cinque ASCII ESTESI (da 128132, """") per dare la possi-|
;|               bilit di inserire nei testi un piccolo  Logo;  il  problema|
;|               causato dal GENERATORE HARDWARE dei MODI TESTO, trattato nel|
;|               sorgente del programma "B10_1100.ASM", ora non c' pi (cio|
;|               in GRAFICA NON esiste duplicazione dell'ottavo bit).        |
;\---------------------------------------------------------------------------/

; MACRO UTILIZZATE DAL PROGRAMMA:
        include         c:\arch-lab\bin\GIOBE.MAC

; LIBRERIA UTILIZZATA DAL PROGRAMMA [opzione WinASM altrimenti non necessaria]
        includelib      c:\arch-lab\bin\GIOBE.LIB

;PROCEDURE ESTERNE UTILIZZATE dal PROGRAMMA [NEAR, dalla LIBRERIA ~GIOBE.LIB~]
;-----------------------------------------------------------------------------
        EXTRN CambiaCol:NEAR
        EXTRN   SET_cur:NEAR
        EXTRN   VIA_cur:NEAR
        EXTRN   RIP_cur:NEAR
        EXTRN   KEYwait:NEAR
        EXTRN   BIOSmsg:NEAR

; DICHIARAZIONI PER I PROGRAMMI ESTERNI:
        PUBLIC  ATTRIB
        PUBLIC  B10_1121


;DEFINIZIONE DEL SEGMENTO DEL CODICE
;-----------------------------------------------------------------------------
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog

        ORG     0100H
INIZIO: JMP     B10_1121


;AREA DESTINATA AI DATI DEL PROGRAMMA
;-----------------------------------------------------------------------------
ATTRIB DB 0FH
TESTO1 DB "Ŀ",00H
TESTO2 DB "                                                             ",00H
TESTO3 DB "",00H
TESTO4 DB  "B10_1121 - Caricatore  di  FONT ALTERNATIVO in MODO GRAFICO"   ,00H
TESTO5 DB    "vers.2.0                           by ing. Giorgio OBER"     ,00H
TESTO6 DB    "    I nuovi caratteri sono regolarmente disponibili"         ,00H
DEMO_1 DB                       ""                                    ,00H


;*****************************************************************************
                              ; ----------------------------------------------
B10_1121 proc  NEAR           ;|      AREA DEDICATA AL MAIN PROGRAM         ||
                              ; ----------------------------------------------
;-----------------------------------------------------------------------------
        ;/[NB:]--------------\;\/--------*-----*----*-------*------------*---\
        ;|Naturalmente  per i|;||MODO 04H|40x25|8x8 |320x200| 4 colori   |CGA|
        ;|MODI a  40  colonne|;||MODO 05H|40x25|8x8 |320x200| 4 colori   |CGA|
        ;| necessario    ri-|;||MODO 0DH|40x25|8x8 |320x200|bianco/nero |EGA|
        ;|strutturare i testi|;||MODO 13H|40x25|8x8 |320x200|256 colori  |VGA|
        ;\-------------------/;/\--------*-----*----*-------*------------*---/

        ;/-------------------\;\/--------*-----*----*-------*------------*---\
        ;|Provare  anche  con|;||MODO 06H|80x25|8x8 |640x200|16 colori   |CGA|
        ;|gli    altri   MODI|;||MODO 0EH|80x25|8x8 |640x200|16 colori   |EGA|
        ;\-----------------/;||MODO 0FH|80x25|8x14|640x350|monocrimatic|EGA|
        MOV     AL,12H        ;||MODO 10H|80x25|8x14|640x350|16 colori   |EGA|
        MOV     AH,00H        ;||MODO 11H|80x30|8x16|640x480|monocromatic|VGA|
        INT     10H           ;||MODO 12H|80x30|8x16|640x480|16 colori   |VGA|
                              ;/\--------*-----*----*-------*------------*---/
                              ;/---------------------------------------------\
                              ;|   CARICA  I   NUOVI  CARATTERI  ORIGINALI   |
                              ;\---------------------------------------------/
        PUSH    ES            ; Predispone il segmento ES a  puntare  la  zona
        PUSH    CS            ; dei nostri dati, a beneficio della  successiva
        POP     ES            ; operazione di trasferimento  TABELLA caratteri
        MOV     AX,CS         ; SottoFunzione che consente (nei  MODI GRAFICI)
        MOV     ES,AX         ; di caricare  una Tabella definizione Caratteri
        LEA     BP,TabFONT    ; creata dall'utente per gli ASCII da 00H a FFH,
        MOV     CX,16;AltzChar; alti CX bytes, puntata da ES:BP; il numero  di
        MOV     BL,00H        ; righe di testo possibili sullo schermo   pas-
        MOV     DL,30;NumRighe; sato in DL (essendo BL=00H).Il puntatore ES:BP
        MOV     AL,21H        ;  poi copiato  nelle  locazioni  della Tabella
        MOV     AH,11H        ; dei Vettori (da 0000:010CH)  corrispondenti  a
        INT     10H           ; INT 43H
        POP     ES            ;
        M_msgC TESTO1,1,10,0EH; ---------------------------------------------
        M_msgC TESTO2,2,10,0EH;
        M_msgC TESTO2,3,10,0EH; Organizza il piano di presentazione
        M_msgC TESTO3,4,10,0EH;
        M_msgC TESTO4,2,12,0FH;
        M_msgC TESTO5,3,14,0FH; ---------------------------------------------
        M_msgC TESTO6,6,14,0EH;I nuovi caratteri sono regolarmente disponibili
                              ; ---------------------------------------------
                              ; 
                              ; ۰
                              ; ۰۰۰۰۰۰
       M_msgC TESTO1,10,10,0EH; ۰۰۰۰۰۰۰۰۰
       M_msgC TESTO2,11,10,0EH; ۰۰۰۰۰۰۰۰
       M_msgC TESTO3,12,10,0EH; ۰۰۰۰۰۰۰۰
       M_msgC DEMO_1,11,38,0FH; ۰۰۰۰۰۰۰۰۰
                              ; ۰۰۰۰۰۰
                              ; ۰
                              ; 
                              ; ---------------------------------------------
        CALL    KEYwait
_OUT:   MOV     AL,03H        ;
        MOV     AH,00H        ; Ripristina in uscita il  MODO  TESTO  standard
        INT     10H           ;

        PUSH    AX            ; Torna al DOS con la memoria liberata e con la
        CALL    RIP_cur       ; chiusura di tutti i file; cede  il  controllo
        MOV     DH,23         ; al processo padre (generalmente COMMAND.COM);
        MOV     DL,0          ; il valore posto eventualmente  in AL prima di
        CALL    SET_cur       ; uscire pu essere testato in  uscita  con  la
        POP     AX            ; funzione 4DH  o  mediante  la  lettura  della
        MOV     AH,4CH        ; variabile DOS "ERRORLEVEL"
        INT     21H           ;

                              ;/---------------------------------------------\
                              ;|       Creazione NUOVO FONT CARATTERI        |
                              ;\---------------------------------------------/
TabFONT DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 000        |
        DB    000H            ; 00000000     |         n 00H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |" "|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    081H            ; 10000001  ۰   |                       |
        DB    0A5H            ; 10100101  ۰۰۰   |                       |
        DB    081H            ; 10000001  ۰   |       CARATTERE       |
        DB    081H            ; 10000001  ۰   |         ASCII         |
        DB    0BDH            ; 10111101  ۰۰   |                       |
        DB    099H            ; 10011001  ۰۰   |         n 001        |
        DB    081H            ; 10000001  ۰   |         n 01H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0DBH            ; 11011011  ۰۰   |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    0FFH            ; 11111111     |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0E7H            ; 11100111  ۰   |         n 002        |
        DB    0FFH            ; 11111111     |         n 02H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    07FH            ; 01111111     |                       |
        DB    07FH            ; 01111111     |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    07FH            ; 01111111     |                       |
        DB    03EH            ; 00111110  ۰   |         n 003        |
        DB    01CH            ; 00011100  ۰   |         n 03H        |
        DB    008H            ; 00001000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    008H            ; 00001000  ۰   |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    03EH            ; 00111110  ۰   |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    01CH            ; 00011100  ۰   |         n 004        |
        DB    008H            ; 00001000  ۰   |         n 04H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    0E7H            ; 11100111  ۰   |       CARATTERE       |
        DB    0E7H            ; 11100111  ۰   |         ASCII         |
        DB    0E7H            ; 11100111  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 005        |
        DB    018H            ; 00011000  ۰   |         n 05H        |
        DB    03CH            ; 00111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    0FFH            ; 11111111     |         ASCII         |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 006        |
        DB    018H            ; 00011000  ۰   |         n 06H        |
        DB    03CH            ; 00111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    03CH            ; 00111100  ۰   |         ASCII         |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 007        |
        DB    000H            ; 00000000     |         n 07H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    0FFH            ; 11111111     /-----------------------\
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0E7H            ; 11100111  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0E7H            ; 11100111  ۰   |         n 008        |
        DB    0FFH            ; 11111111     |         n 08H        |
        DB    0FFH            ; 11111111     |          /---\        |
        DB    0FFH            ; 11111111     |          |""|        |
        DB    0FFH            ; 11111111     |          \---/        |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |       CARATTERE       |
        DB    042H            ; 01000010  ۰۰   |         ASCII         |
        DB    042H            ; 01000010  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |         n 009        |
        DB    03CH            ; 00111100  ۰   |         n 09H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |" "|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    0FFH            ; 11111111     /-----------------------\
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    099H            ; 10011001  ۰۰   |       CARATTERE       |
        DB    0BDH            ; 10111101  ۰۰   |         ASCII         |
        DB    0BDH            ; 10111101  ۰۰   |                       |
        DB    099H            ; 10011001  ۰۰   |         n 010        |
        DB    0C3H            ; 11000011  ۰   |         n 0AH        |
        DB    0FFH            ; 11111111     |          /---\        |
        DB    0FFH            ; 11111111     |          |" "|        |
        DB    0FFH            ; 11111111     |          \---/        |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    00FH            ; 00001111     |                       |
        DB    007H            ; 00000111     |                       |
        DB    00DH            ; 00001101  ۰   |                       |
        DB    019H            ; 00011001  ۰   |       CARATTERE       |
        DB    03CH            ; 00111100  ۰   |         ASCII         |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |         n 011        |
        DB    066H            ; 01100110  ۰۰   |         n 0BH        |
        DB    03CH            ; 00111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |       CARATTERE       |
        DB    03CH            ; 00111100  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |         n 012        |
        DB    018H            ; 00011000  ۰   |         n 0CH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03FH            ; 00111111     |                       |
        DB    033H            ; 00110011  ۰   |                       |
        DB    03FH            ; 00111111     |                       |
        DB    030H            ; 00110000  ۰   |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    070H            ; 01110000  ۰   |         n 013        |
        DB    0F0H            ; 11110000  ۰   |         n 0DH        |
        DB    0E0H            ; 11100000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |" "|        |                                       
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    07FH            ; 01111111     |                       |
        DB    063H            ; 01100011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    067H            ; 01100111  ۰   |         n 014        |
        DB    0E7H            ; 11100111  ۰   |         n 0EH        |
        DB    0E6H            ; 11100110  ۰۰   |          /---\        |
        DB    0C0H            ; 11000000  ۰   |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    0DBH            ; 11011011  ۰۰   |                       |
        DB    03CH            ; 00111100  ۰   |       CARATTERE       |
        DB    0E7H            ; 11100111  ۰   |         ASCII         |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    0DBH            ; 11011011  ۰۰   |         n 015        |
        DB    018H            ; 00011000  ۰   |         n 0FH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    040H            ; 01000000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    070H            ; 01110000  ۰   |                       |
        DB    07CH            ; 01111100  ۰   |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    07CH            ; 01111100  ۰   |                       |
        DB    070H            ; 01110000  ۰   |         n 016        |
        DB    060H            ; 01100000  ۰   |         n 10H        |
        DB    040H            ; 01000000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    001H            ; 00000001     |                       |
        DB    003H            ; 00000011     |                       |
        DB    007H            ; 00000111     |                       |
        DB    01FH            ; 00011111     |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    01FH            ; 00011111     |                       |
        DB    007H            ; 00000111     |         n 017        |
        DB    003H            ; 00000011     |         n 11H        |
        DB    001H            ; 00000001     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |         n 018        |
        DB    03CH            ; 00111100  ۰   |         n 12H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    033H            ; 00110011  ۰   |                       |
        DB    033H            ; 00110011  ۰   |                       |
        DB    033H            ; 00110011  ۰   |                       |
        DB    033H            ; 00110011  ۰   |       CARATTERE       |
        DB    033H            ; 00110011  ۰   |         ASCII         |
        DB    033H            ; 00110011  ۰   |                       |
        DB    000H            ; 00000000     |         n 019        |
        DB    033H            ; 00110011  ۰   |         n 13H        |
        DB    033H            ; 00110011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    0DBH            ; 11011011  ۰۰   |                       |
        DB    0DBH            ; 11011011  ۰۰   |                       |
        DB    0DBH            ; 11011011  ۰۰   |       CARATTERE       |
        DB    07BH            ; 01111011  ۰   |         ASCII         |
        DB    01BH            ; 00011011  ۰   |                       |
        DB    01BH            ; 00011011  ۰   |         n 020        |
        DB    01BH            ; 00011011  ۰   |         n 14H        |
        DB    01BH            ; 00011011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    03EH            ; 00111110  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 021        |
        DB    01CH            ; 00011100  ۰   |         n 15H        |
        DB    006H            ; 00000110  ۰   |          /---\        |
        DB    063H            ; 01100011  ۰   |          |""|        |
        DB    03EH            ; 00111110  ۰   |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |         n 022        |
        DB    07FH            ; 01111111     |         n 16H        |
        DB    07FH            ; 01111111     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |         n 023        |
        DB    03CH            ; 00111100  ۰   |         n 17H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    07EH            ; 01111110  ۰   |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 024        |
        DB    018H            ; 00011000  ۰   |         n 18H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |         n 025        |
        DB    03CH            ; 00111100  ۰   |         n 19H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    006H            ; 00000110  ۰   |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    006H            ; 00000110  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |         n 026        |
        DB    000H            ; 00000000     |         n 1AH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 027        |
        DB    000H            ; 00000000     |         n 1BH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    060H            ; 01100000  ۰   |       CARATTERE       |
        DB    060H            ; 01100000  ۰   |         ASCII         |
        DB    060H            ; 01100000  ۰   |                       |
        DB    07FH            ; 01111111     |         n 028        |
        DB    000H            ; 00000000     |         n 1CH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    024H            ; 00100100  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |       CARATTERE       |
        DB    0FFH            ; 11111111     |         ASCII         |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    024H            ; 00100100  ۰۰   |         n 029        |
        DB    000H            ; 00000000     |         n 1DH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    008H            ; 00001000  ۰   |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    01CH            ; 00011100  ۰   |       CARATTERE       |
        DB    03EH            ; 00111110  ۰   |         ASCII         |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    07FH            ; 01111111     |         n 030        |
        DB    07FH            ; 01111111     |         n 1EH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    03EH            ; 00111110  ۰   |       CARATTERE       |
        DB    03EH            ; 00111110  ۰   |         ASCII         |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    01CH            ; 00011100  ۰   |         n 031        |
        DB    008H            ; 00001000  ۰   |         n 1FH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 032        |
        DB    000H            ; 00000000     |         n 20H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |" "|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |         n 033        |
        DB    018H            ; 00011000  ۰   |         n 21H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"!"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    022H            ; 00100010  ۰۰   |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 034        |
        DB    000H            ; 00000000     |         n 22H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    07FH            ; 01111111     |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    036H            ; 00110110  ۰۰   |         ASCII         |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    07FH            ; 01111111     |         n 035        |
        DB    036H            ; 00110110  ۰۰   |         n 23H        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    000H            ; 00000000     |          |"#"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    00CH            ; 00001100  ۰   /-----------------------\
        DB    00CH            ; 00001100  ۰   |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    061H            ; 01100001  ۰   |                       |
        DB    060H            ; 01100000  ۰   |       CARATTERE       |
        DB    03EH            ; 00111110  ۰   |         ASCII         |
        DB    003H            ; 00000011     |                       |
        DB    043H            ; 01000011  ۰   |         n 036        |
        DB    063H            ; 01100011  ۰   |         n 24H        |
        DB    03EH            ; 00111110  ۰   |          /---\        |
        DB    00CH            ; 00001100  ۰   |          |"$"|        |
        DB    00CH            ; 00001100  ۰   |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    061H            ; 01100001  ۰   |                       |
        DB    063H            ; 01100011  ۰   |       CARATTERE       |
        DB    006H            ; 00000110  ۰   |         ASCII         |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 037        |
        DB    033H            ; 00110011  ۰   |         n 25H        |
        DB    063H            ; 01100011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"%"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    01CH            ; 00011100  ۰   |       CARATTERE       |
        DB    03BH            ; 00111011  ۰   |         ASCII         |
        DB    06EH            ; 01101110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |         n 038        |
        DB    066H            ; 01100110  ۰۰   |         n 26H        |
        DB    03BH            ; 00111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"&"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 039        |
        DB    000H            ; 00000000     |         n 27H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"'"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |         n 040        |
        DB    018H            ; 00011000  ۰   |         n 28H        |
        DB    00CH            ; 00001100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"("|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    006H            ; 00000110  ۰   |                       |
        DB    006H            ; 00000110  ۰   |       CARATTERE       |
        DB    006H            ; 00000110  ۰   |         ASCII         |
        DB    006H            ; 00000110  ۰   |                       |
        DB    006H            ; 00000110  ۰   |         n 041        |
        DB    00CH            ; 00001100  ۰   |         n 29H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |")"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    03CH            ; 00111100  ۰   |       CARATTERE       |
        DB    0FFH            ; 11111111     |         ASCII         |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |         n 042        |
        DB    000H            ; 00000000     |         n 2AH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"*"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    0FFH            ; 11111111     |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 043        |
        DB    018H            ; 00011000  ۰   |         n 2BH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"+"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |         n 044        |
        DB    018H            ; 00011000  ۰   |         n 2CH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    030H            ; 00110000  ۰   |          |","|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    0FFH            ; 11111111     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 045        |
        DB    000H            ; 00000000     |         n 2DH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"-"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 046        |
        DB    018H            ; 00011000  ۰   |         n 2EH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"."|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    001H            ; 00000001     |                       |
        DB    003H            ; 00000011     |                       |
        DB    006H            ; 00000110  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |         n 047        |
        DB    040H            ; 01000000  ۰   |         n 2FH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"/"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    0C7H            ; 11000111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 048        |
        DB    0E3H            ; 11100011  ۰   |         n 30H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"0"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |       CARATTERE       |
        DB    00CH            ; 00001100  ۰   |         ASCII         |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |         n 049        |
        DB    00CH            ; 00001100  ۰   |         n 31H        |
        DB    00CH            ; 00001100  ۰   |          /---\        |
        DB    008H            ; 00001000  ۰   |          |"1"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    0C7H            ; 11000111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |       CARATTERE       |
        DB    02CH            ; 00101100  ۰۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |         n 050        |
        DB    061H            ; 01100001  ۰   |         n 32H        |
        DB    0FFH            ; 11111111     |          /---\        |
        DB    000H            ; 00000000     |          |"2"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    043H            ; 01000011  ۰   |                       |
        DB    003H            ; 00000011     |                       |
        DB    006H            ; 00000110  ۰   |       CARATTERE       |
        DB    03CH            ; 00111100  ۰   |         ASCII         |
        DB    006H            ; 00000110  ۰   |                       |
        DB    003H            ; 00000011     |         n 051        |
        DB    003H            ; 00000011     |         n 33H        |
        DB    003H            ; 00000011     |          /---\        |
        DB    046H            ; 01000110  ۰۰   |          |"3"|        |
        DB    03CH            ; 00111100  ۰   |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    006H            ; 00000110  ۰   |                       |
        DB    00EH            ; 00001110  ۰   |                       |
        DB    01EH            ; 00011110  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    066H            ; 01100110  ۰۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    006H            ; 00000110  ۰   |         n 052        |
        DB    006H            ; 00000110  ۰   |         n 34H        |
        DB    006H            ; 00000110  ۰   |          /---\        |
        DB    004H            ; 00000100  ۰   |          |"4"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    001H            ; 00000001     |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    078H            ; 01111000  ۰   |       CARATTERE       |
        DB    04CH            ; 01001100  ۰۰   |         ASCII         |
        DB    006H            ; 00000110  ۰   |                       |
        DB    003H            ; 00000011     |         n 053        |
        DB    003H            ; 00000011     |         n 35H        |
        DB    003H            ; 00000011     |          /---\        |
        DB    046H            ; 01000110  ۰۰   |          |"4"|        |
        DB    03CH            ; 00111100  ۰   |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |                       |
        DB    0DEH            ; 11011110  ۰۰   |       CARATTERE       |
        DB    0E3H            ; 11100011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 054        |
        DB    066H            ; 01100110  ۰۰   |         n 36H        |
        DB    03CH            ; 00111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"6"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    003H            ; 00000011     |                       |
        DB    006H            ; 00000110  ۰   |       CARATTERE       |
        DB    00CH            ; 00001100  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |         n 055        |
        DB    030H            ; 00110000  ۰   |         n 37H        |
        DB    030H            ; 00110000  ۰   |          /---\        |
        DB    020H            ; 00100000  ۰   |          |"7"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    0C7H            ; 11000111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |       CARATTERE       |
        DB    0E3H            ; 11100011  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |         ASCII         |
        DB    0C7H            ; 11000111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 056        |
        DB    0E3H            ; 11100011  ۰   |         n 38H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"8"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    067H            ; 01100111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    07BH            ; 01111011  ۰   |                       |
        DB    003H            ; 00000011     |         n 057        |
        DB    006H            ; 00000110  ۰   |         n 39H        |
        DB    07CH            ; 01111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"9"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |         n 058        |
        DB    018H            ; 00011000  ۰   |         n 3AH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |":"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |         n 059        |
        DB    018H            ; 00011000  ۰   |         n 3BH        |
        DB    030H            ; 00110000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |";"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    006H            ; 00000110  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |       CARATTERE       |
        DB    060H            ; 01100000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 060        |
        DB    00CH            ; 00001100  ۰   |         n 3CH        |
        DB    006H            ; 00000110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"<"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |         n 061        |
        DB    000H            ; 00000000     |         n 3DH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"="|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |       CARATTERE       |
        DB    006H            ; 00000110  ۰   |         ASCII         |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 062        |
        DB    030H            ; 00110000  ۰   |         n 3EH        |
        DB    060H            ; 01100000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |">"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    006H            ; 00000110  ۰   |       CARATTERE       |
        DB    00CH            ; 00001100  ۰   |         ASCII         |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    000H            ; 00000000     |         n 063        |
        DB    00CH            ; 00001100  ۰   |         n 3FH        |
        DB    00CH            ; 00001100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"?"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    06FH            ; 01101111  ۰   |       CARATTERE       |
        DB    06FH            ; 01101111  ۰   |         ASCII         |
        DB    06FH            ; 01101111  ۰   |                       |
        DB    06EH            ; 01101110  ۰۰   |         n 064        |
        DB    060H            ; 01100000  ۰   |         n 40H        |
        DB    03EH            ; 00111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"@"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    00FH            ; 00001111     |                       |
        DB    01BH            ; 00011011  ۰   |                       |
        DB    033H            ; 00110011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    0C3H            ; 11000011  ۰   |         n 065        |
        DB    0C3H            ; 11000011  ۰   |         n 41H        |
        DB    0C3H            ; 11000011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"A"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0DEH            ; 11011110  ۰۰   |                       |
        DB    0E3H            ; 11100011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    047H            ; 01000111  ۰   |       CARATTERE       |
        DB    07EH            ; 01111110  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    043H            ; 01000011  ۰   |         n 066        |
        DB    047H            ; 01000111  ۰   |         n 42H        |
        DB    0FEH            ; 11111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"B"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C1H            ; 11000001  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |       CARATTERE       |
        DB    0C0H            ; 11000000  ۰   |         ASCII         |
        DB    0C0H            ; 11000000  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |         n 067        |
        DB    0E1H            ; 11100001  ۰   |         n 43H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"C"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    080H            ; 10000000  ۰   |                       |
        DB    0FEH            ; 11111110  ۰   |                       |
        DB    003H            ; 00000011     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    0C7H            ; 11000111  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C2H            ; 11000010  ۰۰   |         n 068        |
        DB    064H            ; 01100100  ۰۰   |         n 44H        |
        DB    038H            ; 00111000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"D"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C1H            ; 11000001  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |       CARATTERE       |
        DB    0FCH            ; 11111100  ۰   |         ASCII         |
        DB    0C0H            ; 11000000  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |         n 069        |
        DB    061H            ; 01100001  ۰   |         n 45H        |
        DB    03EH            ; 00111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"E"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    061H            ; 01100001  ۰   |                       |
        DB    060H            ; 01100000  ۰   |       CARATTERE       |
        DB    07CH            ; 01111100  ۰   |         ASCII         |
        DB    060H            ; 01100000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |         n 070        |
        DB    060H            ; 01100000  ۰   |         n 46H        |
        DB    060H            ; 01100000  ۰   |          /---\        |
        DB    060H            ; 01100000  ۰   |          |"F"|        |
        DB    060H            ; 01100000  ۰   |          \---/        |
        DB    040H            ; 01000000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C1H            ; 11000001  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |       CARATTERE       |
        DB    0C0H            ; 11000000  ۰   |         ASCII         |
        DB    0CFH            ; 11001111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 071        |
        DB    063H            ; 01100011  ۰   |         n 47H        |
        DB    03FH            ; 00111111     |          /---\        |
        DB    003H            ; 00000011     |          |"G"|        |
        DB    003H            ; 00000011     |          \---/        |
        DB    002H            ; 00000010  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0E0H            ; 11100000  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |                       |
        DB    0DEH            ; 11011110  ۰۰   |                       |
        DB    0E3H            ; 11100011  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 072        |
        DB    0C6H            ; 11000110  ۰۰   |         n 48H        |
        DB    0CFH            ; 11001111  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"H"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 073        |
        DB    018H            ; 00011000  ۰   |         n 49H        |
        DB    03CH            ; 00111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"I"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 074        |
        DB    018H            ; 00011000  ۰   |         n 4AH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |"J"|        |
        DB    030H            ; 00110000  ۰   |          \---/        |
        DB    020H            ; 00100000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0E0H            ; 11100000  ۰   |                       |
        DB    067H            ; 01100111  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |       CARATTERE       |
        DB    06CH            ; 01101100  ۰۰   |         ASCII         |
        DB    07CH            ; 01111100  ۰   |                       |
        DB    06EH            ; 01101110  ۰۰   |         n 075        |
        DB    067H            ; 01100111  ۰   |         n 4BH        |
        DB    0E3H            ; 11100011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"K"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    070H            ; 01110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    031H            ; 00110001  ۰   |         n 076        |
        DB    033H            ; 00110011  ۰   |         n 4CH        |
        DB    07FH            ; 01111111     |          /---\        |
        DB    000H            ; 00000000     |          |"L"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0E3H            ; 11100011  ۰   |                       |
        DB    077H            ; 01110111  ۰   |                       |
        DB    07FH            ; 01111111     |                       |
        DB    06BH            ; 01101011  ۰۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 077        |
        DB    063H            ; 01100011  ۰   |         n 4DH        |
        DB    0E3H            ; 11100011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"M"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0E7H            ; 11100111  ۰   |                       |
        DB    071H            ; 01110001  ۰   |                       |
        DB    079H            ; 01111001  ۰   |                       |
        DB    07DH            ; 01111101  ۰   |       CARATTERE       |
        DB    06FH            ; 01101111  ۰   |         ASCII         |
        DB    067H            ; 01100111  ۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 078        |
        DB    061H            ; 01100001  ۰   |         n 4EH        |
        DB    0E1H            ; 11100001  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"N"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    0C7H            ; 11000111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C2H            ; 11000010  ۰۰   |         n 079        |
        DB    064H            ; 01100100  ۰۰   |         n 4FH        |
        DB    038H            ; 00111000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"O"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0DEH            ; 11011110  ۰۰   |                       |
        DB    0E7H            ; 11100111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0E3H            ; 11100011  ۰   |         n 080        |
        DB    0F3H            ; 11110011  ۰   |         n 50H        |
        DB    0DEH            ; 11011110  ۰۰   |          /---\        |
        DB    0C0H            ; 11000000  ۰   |          |"P"|        |
        DB    080H            ; 10000000  ۰   |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07BH            ; 01111011  ۰   |                       |
        DB    0E7H            ; 11100111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 081        |
        DB    0CFH            ; 11001111  ۰   |         n 51H        |
        DB    07BH            ; 01111011  ۰   |          /---\        |
        DB    003H            ; 00000011     |          |"Q"|        |
        DB    002H            ; 00000010  ۰   |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0EEH            ; 11101110  ۰۰   |                       |
        DB    073H            ; 01110011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    067H            ; 01100111  ۰   |       CARATTERE       |
        DB    07CH            ; 01111100  ۰   |         ASCII         |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 082        |
        DB    063H            ; 01100011  ۰   |         n 52H        |
        DB    063H            ; 01100011  ۰   |          /---\        |
        DB    001H            ; 00000001     |          |"R"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07DH            ; 01111101  ۰   |                       |
        DB    0E7H            ; 11100111  ۰   |                       |
        DB    0E3H            ; 11100011  ۰   |                       |
        DB    070H            ; 01110000  ۰   |       CARATTERE       |
        DB    03EH            ; 00111110  ۰   |         ASCII         |
        DB    007H            ; 00000111     |                       |
        DB    0C3H            ; 11000011  ۰   |         n 083        |
        DB    0E2H            ; 11100010  ۰۰   |         n 53H        |
        DB    0BCH            ; 10111100  ۰۰   |          /---\        |
        DB    000H            ; 00000000     |          |"S"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    098H            ; 10011000  ۰۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |       CARATTERE       |
        DB    0C0H            ; 11000000  ۰   |         ASCII         |
        DB    0C0H            ; 11000000  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |         n 084        |
        DB    063H            ; 01100011  ۰   |         n 54H        |
        DB    03EH            ; 00111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"T"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0E3H            ; 11100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 085        |
        DB    067H            ; 01100111  ۰   |         n 55H        |
        DB    03BH            ; 00111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"U"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 086        |
        DB    01CH            ; 00011100  ۰   |         n 56H        |
        DB    008H            ; 00001000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"V"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0E7H            ; 11100111  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    06BH            ; 01101011  ۰۰   |                       |
        DB    07FH            ; 01111111     |         n 087        |
        DB    077H            ; 01110111  ۰   |         n 57H        |
        DB    0E2H            ; 11100010  ۰۰   |          /---\        |
        DB    000H            ; 00000000     |          |"W"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C1H            ; 11000001  ۰   |                       |
        DB    062H            ; 01100010  ۰۰   |                       |
        DB    03CH            ; 00111100  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    046H            ; 01000110  ۰۰   |         n 088        |
        DB    083H            ; 10000011  ۰   |         n 58H        |
        DB    0C3H            ; 11000011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"X"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0CFH            ; 11001111  ۰   |                       |
        DB    0C7H            ; 11000111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    03FH            ; 00111111     |                       |
        DB    086H            ; 10000110  ۰۰   |         n 089        |
        DB    0C6H            ; 11000110  ۰۰   |         n 59H        |
        DB    07CH            ; 01111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"Y"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    083H            ; 10000011  ۰   |                       |
        DB    003H            ; 00000011     |                       |
        DB    00EH            ; 00001110  ۰   |       CARATTERE       |
        DB    03CH            ; 00111100  ۰   |         ASCII         |
        DB    070H            ; 01110000  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |         n 090        |
        DB    0C1H            ; 11000001  ۰   |         n 5AH        |
        DB    0FFH            ; 11111111     |          /---\        |
        DB    000H            ; 00000000     |          |"Z"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |         n 091        |
        DB    030H            ; 00110000  ۰   |         n 5BH        |
        DB    03CH            ; 00111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"["|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    040H            ; 01000000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    070H            ; 01110000  ۰   |                       |
        DB    038H            ; 00111000  ۰   |       CARATTERE       |
        DB    01CH            ; 00011100  ۰   |         ASCII         |
        DB    00EH            ; 00001110  ۰   |                       |
        DB    007H            ; 00000111     |         n 092        |
        DB    003H            ; 00000011     |         n 5CH        |
        DB    001H            ; 00000001     |          /---\        |
        DB    000H            ; 00000000     |          |"\"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |       CARATTERE       |
        DB    00CH            ; 00001100  ۰   |         ASCII         |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |         n 093        |
        DB    00CH            ; 00001100  ۰   |         n 5DH        |
        DB    03CH            ; 00111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"]"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    008H            ; 00001000  ۰   /-----------------------\
        DB    01CH            ; 00011100  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 094        |
        DB    000H            ; 00000000     |         n 5EH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"^"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 095        |
        DB    000H            ; 00000000     |         n 5FH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"_"|        |
        DB    0FFH            ; 11111111     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 096        |
        DB    000H            ; 00000000     |         n 60H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"`"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07BH            ; 01111011  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 097        |
        DB    0E7H            ; 11100111  ۰   |         n 61H        |
        DB    07BH            ; 01111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"a"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0DEH            ; 11011110  ۰۰   |                       |
        DB    0E3H            ; 11100011  ۰   |                       |
        DB    043H            ; 01000011  ۰   |       CARATTERE       |
        DB    07EH            ; 01111110  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    043H            ; 01000011  ۰   |         n 098        |
        DB    047H            ; 01000111  ۰   |         n 62H        |
        DB    0FEH            ; 11111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"b"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |       CARATTERE       |
        DB    0E3H            ; 11100011  ۰   |         ASCII         |
        DB    0C0H            ; 11000000  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |         n 099        |
        DB    0E3H            ; 11100011  ۰   |         n 63H        |
        DB    07FH            ; 01111111     |          /---\        |
        DB    000H            ; 00000000     |          |"c"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07CH            ; 01111100  ۰   |                       |
        DB    0C6H            ; 11000110  ۰۰   |                       |
        DB    003H            ; 00000011     |                       |
        DB    07FH            ; 01111111     |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 100        |
        DB    0E3H            ; 11100011  ۰   |         n 64H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"d"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    0C0H            ; 11000000  ۰   |         n 101        |
        DB    0E1H            ; 11100001  ۰   |         n 65H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"e"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    007H            ; 00000111     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |         n 102        |
        DB    031H            ; 00110001  ۰   |         n 66H        |
        DB    0FFH            ; 11111111     |          /---\        |
        DB    030H            ; 00110000  ۰   |          |"f"|        |
        DB    030H            ; 00110000  ۰   |          \---/        |
        DB    030H            ; 00110000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 103        |
        DB    0E3H            ; 11100011  ۰   |         n 67H        |
        DB    07FH            ; 01111111     |          /---\        |
        DB    0C7H            ; 11000111  ۰   |          |"g"|        |
        DB    0E3H            ; 11100011  ۰   |          \---/        |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0C0H            ; 11000000  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |                       |
        DB    0DEH            ; 11011110  ۰۰   |       CARATTERE       |
        DB    0E3H            ; 11100011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 104        |
        DB    0C6H            ; 11000110  ۰۰   |         n 68H        |
        DB    0CFH            ; 11001111  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"h"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    038H            ; 00111000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 105        |
        DB    018H            ; 00011000  ۰   |         n 69H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"i"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    002H            ; 00000010  ۰   |       CARATTERE       |
        DB    002H            ; 00000010  ۰   |         ASCII         |
        DB    002H            ; 00000010  ۰   |                       |
        DB    042H            ; 01000010  ۰۰   |         n 106        |
        DB    066H            ; 01100110  ۰۰   |         n 6AH        |
        DB    07CH            ; 01111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"j"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |       CARATTERE       |
        DB    06CH            ; 01101100  ۰۰   |         ASCII         |
        DB    078H            ; 01111000  ۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |         n 107        |
        DB    066H            ; 01100110  ۰۰   |         n 6BH        |
        DB    063H            ; 01100011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"k"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    070H            ; 01110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |         n 108        |
        DB    032H            ; 00110010  ۰۰   |         n 6CH        |
        DB    03EH            ; 00111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"l"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0EEH            ; 11101110  ۰۰   |       CARATTERE       |
        DB    0DBH            ; 11011011  ۰۰   |         ASCII         |
        DB    0DBH            ; 11011011  ۰۰   |                       |
        DB    0DBH            ; 11011011  ۰۰   |         n 109        |
        DB    0DAH            ; 11011010  ۰۰۰   |         n 6DH        |
        DB    0DBH            ; 11011011  ۰۰   |          /---\        |
        DB    000H            ; 00000000     |          |"m"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0DEH            ; 11011110  ۰۰   |       CARATTERE       |
        DB    0E3H            ; 11100011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 110        |
        DB    0C6H            ; 11000110  ۰۰   |         n 6EH        |
        DB    0CFH            ; 11001111  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"n"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 111        |
        DB    0E3H            ; 11100011  ۰   |         n 6FH        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"o"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0BEH            ; 10111110  ۰۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 112        |
        DB    0E3H            ; 11100011  ۰   |         n 70H        |
        DB    0FEH            ; 11111110  ۰   |          /---\        |
        DB    0C0H            ; 11000000  ۰   |          |"p"|        |
        DB    0C0H            ; 11000000  ۰   |          \---/        |
        DB    0C0H            ; 11000000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 113        |
        DB    0E3H            ; 11100011  ۰   |         n 71H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    030H            ; 00110000  ۰   |          |"q"|        |
        DB    07EH            ; 01111110  ۰   |          \---/        |
        DB    003H            ; 00000011     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0DEH            ; 11011110  ۰۰   |       CARATTERE       |
        DB    0E3H            ; 11100011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0FEH            ; 11111110  ۰   |         n 114        |
        DB    0CCH            ; 11001100  ۰۰   |         n 72H        |
        DB    0C7H            ; 11000111  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"r"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C1H            ; 11000001  ۰   |         ASCII         |
        DB    0FEH            ; 11111110  ۰   |                       |
        DB    003H            ; 00000011     |         n 115        |
        DB    083H            ; 10000011  ۰   |         n 73H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"s"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    010H            ; 00010000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    0FCH            ; 11111100  ۰   |                       |
        DB    060H            ; 01100000  ۰   |       CARATTERE       |
        DB    060H            ; 01100000  ۰   |         ASCII         |
        DB    060H            ; 01100000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |         n 116        |
        DB    063H            ; 01100011  ۰   |         n 74H        |
        DB    03EH            ; 00111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"t"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0F3H            ; 11110011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 117        |
        DB    0C7H            ; 11000111  ۰   |         n 75H        |
        DB    07BH            ; 01111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"u"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0F6H            ; 11110110  ۰۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 118        |
        DB    0C6H            ; 11000110  ۰۰   |         n 76H        |
        DB    078H            ; 01111000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"v"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0DBH            ; 11011011  ۰۰   |       CARATTERE       |
        DB    05BH            ; 01011011  ۰۰   |         ASCII         |
        DB    0DBH            ; 11011011  ۰۰   |                       |
        DB    0DBH            ; 11011011  ۰۰   |         n 119        |
        DB    0DBH            ; 11011011  ۰۰   |         n 77H        |
        DB    03FH            ; 00111111     |          /---\        |
        DB    000H            ; 00000000     |          |"w"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    063H            ; 01100011  ۰   |       CARATTERE       |
        DB    034H            ; 00110100  ۰۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    01CH            ; 00011100  ۰   |         n 120        |
        DB    026H            ; 00100110  ۰۰   |         n 78H        |
        DB    0C3H            ; 11000011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"x"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0C7H            ; 11000111  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 121        |
        DB    01EH            ; 00011110  ۰   |         n 79H        |
        DB    00CH            ; 00001100  ۰   |          /---\        |
        DB    00CH            ; 00001100  ۰   |          |"y"|        |
        DB    098H            ; 10011000  ۰۰   |          \---/        |
        DB    0F0H            ; 11110000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    08EH            ; 10001110  ۰۰   |         ASCII         |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    038H            ; 00111000  ۰   |         n 122        |
        DB    070H            ; 01110000  ۰   |         n 7AH        |
        DB    0FFH            ; 11111111     |          /---\        |
        DB    000H            ; 00000000     |          |"z"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    00EH            ; 00001110  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    070H            ; 01110000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 123        |
        DB    018H            ; 00011000  ۰   |         n 7BH        |
        DB    00EH            ; 00001110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"{"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 124        |
        DB    018H            ; 00011000  ۰   |         n 7CH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"|"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    070H            ; 01110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    01EH            ; 00011110  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 125        |
        DB    018H            ; 00011000  ۰   |         n 7DH        |
        DB    070H            ; 01110000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |"}"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03BH            ; 00111011  ۰   |                       |
        DB    06EH            ; 01101110  ۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 126        |
        DB    000H            ; 00000000     |         n 7EH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"~"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    008H            ; 00001000  ۰   |                       |
        DB    01CH            ; 00011100  ۰   |       CARATTERE       |
        DB    036H            ; 00110110  ۰۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 127        |
        DB    07FH            ; 01111111     |         n 7FH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    07FH            ; 01111111     |                       |
        DB    040H            ; 01000000  ۰   |                       |
        DB    040H            ; 01000000  ۰   |                       |
        DB    040H            ; 01000000  ۰   |                       |
        DB    047H            ; 01000111  ۰   |       CARATTERE       |
        DB    048H            ; 01001000  ۰۰   |         ASCII         |
        DB    048H            ; 01001000  ۰۰   |                       |
        DB    048H            ; 01001000  ۰۰   |         n 128        |
        DB    048H            ; 01001000  ۰۰   |         n 80H        |
        DB    047H            ; 01000111  ۰   |          /---\        |
        DB    040H            ; 01000000  ۰   |          |""|        |
        DB    040H            ; 01000000  ۰   |          \---/        |
        DB    040H            ; 01000000  ۰   |                       |
        DB    07FH            ; 01111111     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    08EH            ; 10001110  ۰۰   |       CARATTERE       |
        DB    044H            ; 01000100  ۰۰   |         ASCII         |
        DB    004H            ; 00000100  ۰   |                       |
        DB    0C4H            ; 11000100  ۰۰   |         n 129        |
        DB    044H            ; 01000100  ۰۰   |         n 81H        |
        DB    08EH            ; 10001110  ۰۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03CH            ; 00111100  ۰   |       CARATTERE       |
        DB    042H            ; 01000010  ۰۰   |         ASCII         |
        DB    042H            ; 01000010  ۰۰   |                       |
        DB    042H            ; 01000010  ۰۰   |         n 130        |
        DB    042H            ; 01000010  ۰۰   |         n 82H        |
        DB    03CH            ; 00111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07CH            ; 01111100  ۰   |       CARATTERE       |
        DB    042H            ; 01000010  ۰۰   |         ASCII         |
        DB    042H            ; 01000010  ۰۰   |                       |
        DB    07CH            ; 01111100  ۰   |         n 131        |
        DB    042H            ; 01000010  ۰۰   |         n 83H        |
        DB    07CH            ; 01111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    0FFH            ; 11111111     |                       |
        DB    001H            ; 00000001     |                       |
        DB    001H            ; 00000001     |                       |
        DB    001H            ; 00000001     |                       |
        DB    079H            ; 01111001  ۰   |       CARATTERE       |
        DB    041H            ; 01000001  ۰   |         ASCII         |
        DB    041H            ; 01000001  ۰   |                       |
        DB    071H            ; 01110001  ۰   |         n 132        |
        DB    041H            ; 01000001  ۰   |         n 84H        |
        DB    079H            ; 01111001  ۰   |          /---\        |
        DB    001H            ; 00000001     |          |""|        |
        DB    001H            ; 00000001     |          \---/        |
        DB    001H            ; 00000001     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07BH            ; 01111011  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 133        |
        DB    0E7H            ; 11100111  ۰   |         n 85H        |
        DB    07BH            ; 01111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    01CH            ; 00011100  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07BH            ; 01111011  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 134        |
        DB    0E7H            ; 11100111  ۰   |         n 86H        |
        DB    07BH            ; 01111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    0E3H            ; 11100011  ۰   |       CARATTERE       |
        DB    0C0H            ; 11000000  ۰   |         ASCII         |
        DB    0E3H            ; 11100011  ۰   |                       |
        DB    07FH            ; 01111111     |         n 135        |
        DB    00CH            ; 00001100  ۰   |         n 87H        |
        DB    006H            ; 00000110  ۰   |          /---\        |
        DB    03CH            ; 00111100  ۰   |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    008H            ; 00001000  ۰   |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    0C0H            ; 11000000  ۰   |         n 136        |
        DB    0E1H            ; 11100001  ۰   |         n 88H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    0C0H            ; 11000000  ۰   |         n 137        |
        DB    0E1H            ; 11100001  ۰   |         n 89H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    0C0H            ; 11000000  ۰   |         n 138        |
        DB    0E1H            ; 11100001  ۰   |         n 8AH        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    038H            ; 00111000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 139        |
        DB    018H            ; 00011000  ۰   |         n 8BH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    038H            ; 00111000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 140        |
        DB    018H            ; 00011000  ۰   |         n 8CH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    060H            ; 01100000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    038H            ; 00111000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 141        |
        DB    018H            ; 00011000  ۰   |         n 8DH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    00FH            ; 00001111     |                       |
        DB    01BH            ; 00011011  ۰   |       CARATTERE       |
        DB    033H            ; 00110011  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    0FFH            ; 11111111     |         n 142        |
        DB    0C3H            ; 11000011  ۰   |         n 8EH        |
        DB    0C3H            ; 11000011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    01CH            ; 00011100  ۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    00FH            ; 00001111     |       CARATTERE       |
        DB    01BH            ; 00011011  ۰   |         ASCII         |
        DB    033H            ; 00110011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 143        |
        DB    0FFH            ; 11111111     |         n 8FH        |
        DB    0C3H            ; 11000011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    00CH            ; 00001100  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C1H            ; 11000001  ۰   |                       |
        DB    0FCH            ; 11111100  ۰   |         ASCII         |
        DB    0C0H            ; 11000000  ۰   |         n 144        |
        DB    061H            ; 01100001  ۰   |         n 90H        |
        DB    07FH            ; 01111111     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    06EH            ; 01101110  ۰۰   |                       |
        DB    03BH            ; 00111011  ۰   |       CARATTERE       |
        DB    01BH            ; 00011011  ۰   |         ASCII         |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    0D8H            ; 11011000  ۰۰   |         n 145        |
        DB    0DCH            ; 11011100  ۰۰   |         n 91H        |
        DB    077H            ; 01110111  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    01FH            ; 00011111     |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |         n 146        |
        DB    066H            ; 01100110  ۰۰   |         n 92H        |
        DB    067H            ; 01100111  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    008H            ; 00001000  ۰   |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 147        |
        DB    0E3H            ; 11100011  ۰   |         n 93H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 148        |
        DB    0E3H            ; 11100011  ۰   |         n 94H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 149        |
        DB    0E3H            ; 11100011  ۰   |         n 95H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    0F3H            ; 11110011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 150        |
        DB    0C7H            ; 11000111  ۰   |         n 96H        |
        DB    07BH            ; 01111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    0F3H            ; 11110011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 151        |
        DB    0C7H            ; 11000111  ۰   |         n 97H        |
        DB    07BH            ; 01111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    0C7H            ; 11000111  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 152        |
        DB    01EH            ; 00011110  ۰   |         n 98H        |
        DB    00CH            ; 00001100  ۰   |          /---\        |
        DB    098H            ; 10011000  ۰۰   |          |""|        |
        DB    0F0H            ; 11110000  ۰   |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    0C7H            ; 11000111  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |       CARATTERE       |
        DB    0C3H            ; 11000011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C2H            ; 11000010  ۰۰   |         n 153        |
        DB    064H            ; 01100100  ۰۰   |         n 99H        |
        DB    038H            ; 00111000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    0E3H            ; 11100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 154        |
        DB    067H            ; 01100111  ۰   |         n 9AH        |
        DB    03BH            ; 00111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    07FH            ; 01111111     |                       |
        DB    0E3H            ; 11100011  ۰   |                       |
        DB    0C0H            ; 11000000  ۰   |       CARATTERE       |
        DB    0C0H            ; 11000000  ۰   |         ASCII         |
        DB    0E3H            ; 11100011  ۰   |                       |
        DB    07FH            ; 01111111     |         n 155        |
        DB    018H            ; 00011000  ۰   |         n 9BH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    01CH            ; 00011100  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    032H            ; 00110010  ۰۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    078H            ; 01111000  ۰   |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |         n 156        |
        DB    073H            ; 01110011  ۰   |         n 9CH        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    0FFH            ; 11111111     |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    0FFH            ; 11111111     |         n 157        |
        DB    018H            ; 00011000  ۰   |         n 9DH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    0FCH            ; 11111100  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    07CH            ; 01111100  ۰   |                       |
        DB    062H            ; 01100010  ۰۰   |       CARATTERE       |
        DB    066H            ; 01100110  ۰۰   |         ASCII         |
        DB    06FH            ; 01101111  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |         n 158        |
        DB    066H            ; 01100110  ۰۰   |         n 9EH        |
        DB    0F3H            ; 11110011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    00EH            ; 00001110  ۰   |                       |
        DB    01BH            ; 00011011  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    07EH            ; 01111110  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 159        |
        DB    018H            ; 00011000  ۰   |         n 9FH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    0D8H            ; 11011000  ۰۰   |          |""|        |
        DB    070H            ; 01110000  ۰   |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    00CH            ; 00001100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07BH            ; 01111011  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 160        |
        DB    0E7H            ; 11100111  ۰   |         n A0H        |
        DB    07BH            ; 01111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    00CH            ; 00001100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    038H            ; 00111000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 161        |
        DB    018H            ; 00011000  ۰   |         n A1H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    00CH            ; 00001100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0C7H            ; 11000111  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 162        |
        DB    0E3H            ; 11100011  ۰   |         n A2H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    00CH            ; 00001100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    0F3H            ; 11110011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 163        |
        DB    0C7H            ; 11000111  ۰   |         n A3H        |
        DB    07BH            ; 01111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    03BH            ; 00111011  ۰   |                       |
        DB    06EH            ; 01101110  ۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    0DEH            ; 11011110  ۰۰   |       CARATTERE       |
        DB    0E3H            ; 11100011  ۰   |         ASCII         |
        DB    0C3H            ; 11000011  ۰   |                       |
        DB    0C3H            ; 11000011  ۰   |         n 164        |
        DB    0C6H            ; 11000110  ۰۰   |         n A4H        |
        DB    0CFH            ; 11001111  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    03BH            ; 00111011  ۰   /-----------------------\
        DB    06EH            ; 01101110  ۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    0E7H            ; 11100111  ۰   |                       |
        DB    071H            ; 01110001  ۰   |                       |
        DB    079H            ; 01111001  ۰   |       CARATTERE       |
        DB    07DH            ; 01111101  ۰   |         ASCII         |
        DB    06FH            ; 01101111  ۰   |                       |
        DB    067H            ; 01100111  ۰   |         n 165        |
        DB    063H            ; 01100011  ۰   |         n A5H        |
        DB    0E1H            ; 11100001  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    03CH            ; 00111100  ۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    07EH            ; 01111110  ۰   |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 166        |
        DB    000H            ; 00000000     |         n A6H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    038H            ; 00111000  ۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    038H            ; 00111000  ۰   |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    07CH            ; 01111100  ۰   |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 167        |
        DB    000H            ; 00000000     |         n A7H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 168        |
        DB    063H            ; 01100011  ۰   |         n A8H        |
        DB    03EH            ; 00111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    060H            ; 01100000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |         n 169        |
        DB    060H            ; 01100000  ۰   |         n A9H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    003H            ; 00000011     |                       |
        DB    003H            ; 00000011     |         n 170        |
        DB    003H            ; 00000011     |         n AAH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    060H            ; 01100000  ۰   |                       |
        DB    0E0H            ; 11100000  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    030H            ; 00110000  ۰   |                       |
        DB    06EH            ; 01101110  ۰۰   |         n 171        |
        DB    0C3H            ; 11000011  ۰   |         n ABH        |
        DB    006H            ; 00000110  ۰   |          /---\        |
        DB    00CH            ; 00001100  ۰   |          |""|        |
        DB    01FH            ; 00011111     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    060H            ; 01100000  ۰   |                       |
        DB    0E0H            ; 11100000  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    033H            ; 00110011  ۰   |                       |
        DB    067H            ; 01100111  ۰   |         n 172        |
        DB    0CFH            ; 11001111  ۰   |         n ACH        |
        DB    01FH            ; 00011111     |          /---\        |
        DB    003H            ; 00000011     |          |""|        |
        DB    003H            ; 00000011     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |         n 173        |
        DB    03CH            ; 00111100  ۰   |         n ADH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    01BH            ; 00011011  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    06CH            ; 01101100  ۰۰   |         ASCII         |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    01BH            ; 00011011  ۰   |         n 174        |
        DB    000H            ; 00000000     |         n AEH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    01BH            ; 00011011  ۰   |         ASCII         |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |         n 175        |
        DB    000H            ; 00000000     |         n AFH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    011H            ; 00010001  ۰   /-----------------------\
        DB    044H            ; 01000100  ۰۰   |                       |
        DB    011H            ; 00010001  ۰   |                       |
        DB    044H            ; 01000100  ۰۰   |                       |
        DB    011H            ; 00010001  ۰   |                       |
        DB    044H            ; 01000100  ۰۰   |       CARATTERE       |
        DB    011H            ; 00010001  ۰   |         ASCII         |
        DB    044H            ; 01000100  ۰۰   |                       |
        DB    011H            ; 00010001  ۰   |         n 176        |
        DB    044H            ; 01000100  ۰۰   |         n B0H        |
        DB    011H            ; 00010001  ۰   |          /---\        |
        DB    044H            ; 01000100  ۰۰   |          |" "|        |
        DB    011H            ; 00010001  ۰   |          \---/        |
        DB    044H            ; 01000100  ۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    055H            ; 01010101  ۰۰۰   /-----------------------\
        DB    0AAH            ; 10101010  ۰۰۰۰   |                       |
        DB    055H            ; 01010101  ۰۰۰   |                       |
        DB    0AAH            ; 10101010  ۰۰۰۰   |                       |
        DB    055H            ; 01010101  ۰۰۰   |                       |
        DB    0AAH            ; 10101010  ۰۰۰۰   |       CARATTERE       |
        DB    055H            ; 01010101  ۰۰۰   |         ASCII         |
        DB    0AAH            ; 10101010  ۰۰۰۰   |                       |
        DB    055H            ; 01010101  ۰۰۰   |         n 177        |
        DB    0AAH            ; 10101010  ۰۰۰۰   |         n B1H        |
        DB    055H            ; 01010101  ۰۰۰   |          /---\        |
        DB    0AAH            ; 10101010  ۰۰۰۰   |          |""|        |
        DB    055H            ; 01010101  ۰۰۰   |          \---/        |
        DB    0AAH            ; 10101010  ۰۰۰۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    0DDH            ; 11011101  ۰۰   /-----------------------\
        DB    077H            ; 01110111  ۰   |                       |
        DB    0DDH            ; 11011101  ۰۰   |                       |
        DB    077H            ; 01110111  ۰   |                       |
        DB    0DDH            ; 11011101  ۰۰   |                       |
        DB    077H            ; 01110111  ۰   |       CARATTERE       |
        DB    0DDH            ; 11011101  ۰۰   |         ASCII         |
        DB    077H            ; 01110111  ۰   |                       |
        DB    0DDH            ; 11011101  ۰۰   |         n 178        |
        DB    077H            ; 01110111  ۰   |         n B2H        |
        DB    0DDH            ; 11011101  ۰۰   |          /---\        |
        DB    077H            ; 01110111  ۰   |          |""|        |
        DB    0DDH            ; 11011101  ۰۰   |          \---/        |
        DB    077H            ; 01110111  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 179        |
        DB    018H            ; 00011000  ۰   |         n B3H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |"|"|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    0F8H            ; 11111000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 180        |
        DB    018H            ; 00011000  ۰   |         n B4H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |"*"|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    0F8H            ; 11111000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    0F8H            ; 11111000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 181        |
        DB    018H            ; 00011000  ۰   |         n B5H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |""|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    036H            ; 00110110  ۰۰   |         ASCII         |
        DB    0F6H            ; 11110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 182        |
        DB    036H            ; 00110110  ۰۰   |         n B6H        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0FEH            ; 11111110  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 183        |
        DB    036H            ; 00110110  ۰۰   |         n B7H        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0F8H            ; 11111000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    0F8H            ; 11111000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 184        |
        DB    018H            ; 00011000  ۰   |         n B8H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |""|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    0F6H            ; 11110110  ۰۰   |       CARATTERE       |
        DB    006H            ; 00000110  ۰   |         ASCII         |
        DB    0F6H            ; 11110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 185        |
        DB    036H            ; 00110110  ۰۰   |         n B9H        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    036H            ; 00110110  ۰۰   |         ASCII         |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 186        |
        DB    036H            ; 00110110  ۰۰   |         n BAH        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0FEH            ; 11111110  ۰   |       CARATTERE       |
        DB    006H            ; 00000110  ۰   |         ASCII         |
        DB    0F6H            ; 11110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 187        |
        DB    036H            ; 00110110  ۰۰   |         n BBH        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    0F6H            ; 11110110  ۰۰   |       CARATTERE       |
        DB    006H            ; 00000110  ۰   |         ASCII         |
        DB    0FEH            ; 11111110  ۰   |                       |
        DB    000H            ; 00000000     |         n 188        |
        DB    000H            ; 00000000     |         n BCH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    036H            ; 00110110  ۰۰   |         ASCII         |
        DB    0FEH            ; 11111110  ۰   |                       |
        DB    000H            ; 00000000     |         n 189        |
        DB    000H            ; 00000000     |         n BDH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    0F8H            ; 11111000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    0F8H            ; 11111000  ۰   |                       |
        DB    000H            ; 00000000     |         n 190        |
        DB    000H            ; 00000000     |         n BEH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0F8H            ; 11111000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 191        |
        DB    018H            ; 00011000  ۰   |         n BFH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |"\"|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    01FH            ; 00011111     |                       |
        DB    000H            ; 00000000     |         n 192        |
        DB    000H            ; 00000000     |         n C0H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"\"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |         n 193        |
        DB    000H            ; 00000000     |         n C1H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"*"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    018H            ; 00011000  ۰   |         n 184        |
        DB    018H            ; 00011000  ۰   |         n C2H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |"*"|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    01FH            ; 00011111     |                       |
        DB    018H            ; 00011000  ۰   |         n 195        |
        DB    018H            ; 00011000  ۰   |         n C3H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |"*"|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |         n 196        |
        DB    000H            ; 00000000     |         n C4H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"-"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    018H            ; 00011000  ۰   |         n 197        |
        DB    018H            ; 00011000  ۰   |         n C5H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |"*"|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    01FH            ; 00011111     |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    01FH            ; 00011111     |                       |
        DB    018H            ; 00011000  ۰   |         n 198        |
        DB    018H            ; 00011000  ۰   |         n C6H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |""|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    036H            ; 00110110  ۰۰   |         ASCII         |
        DB    037H            ; 00110111  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 199        |
        DB    036H            ; 00110110  ۰۰   |         n C7H        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    037H            ; 00110111  ۰   |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    03FH            ; 00111111     |                       |
        DB    000H            ; 00000000     |         n 200        |
        DB    000H            ; 00000000     |         n C8H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03FH            ; 00111111     |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    037H            ; 00110111  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 201        |
        DB    036H            ; 00110110  ۰۰   |         n C9H        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    0F7H            ; 11110111  ۰   |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |         n 202        |
        DB    000H            ; 00000000     |         n CAH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0F7H            ; 11110111  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 203        |
        DB    036H            ; 00110110  ۰۰   |         n CBH        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    037H            ; 00110111  ۰   |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    037H            ; 00110111  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 204        |
        DB    036H            ; 00110110  ۰۰   |         n CCH        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |         n 205        |
        DB    000H            ; 00000000     |         n CDH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    0F7H            ; 11110111  ۰   |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0F7H            ; 11110111  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 206        |
        DB    036H            ; 00110110  ۰۰   |         n CEH        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |         n 207        |
        DB    000H            ; 00000000     |         n CFH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    036H            ; 00110110  ۰۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    000H            ; 00000000     |         n 208        |
        DB    000H            ; 00000000     |         n D0H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    018H            ; 00011000  ۰   |         n 209        |
        DB    018H            ; 00011000  ۰   |         n D1H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |""|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    036H            ; 00110110  ۰۰   |         n 210        |
        DB    036H            ; 00110110  ۰۰   |         n D2H        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    036H            ; 00110110  ۰۰   |         ASCII         |
        DB    03FH            ; 00111111     |                       |
        DB    000H            ; 00000000     |         n 211        |
        DB    000H            ; 00000000     |         n D3H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    01FH            ; 00011111     |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    01FH            ; 00011111     |                       |
        DB    000H            ; 00000000     |         n 212        |
        DB    000H            ; 00000000     |         n D4H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    01FH            ; 00011111     |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    01FH            ; 00011111     |                       |
        DB    018H            ; 00011000  ۰   |         n 213        |
        DB    018H            ; 00011000  ۰   |         n D5H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |""|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    03FH            ; 00111111     |                       |
        DB    036H            ; 00110110  ۰۰   |         n 214        |
        DB    036H            ; 00110110  ۰۰   |         n D6H        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    036H            ; 00110110  ۰۰   /-----------------------\
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    036H            ; 00110110  ۰۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    036H            ; 00110110  ۰۰   |         n 215        |
        DB    036H            ; 00110110  ۰۰   |         n D7H        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    036H            ; 00110110  ۰۰   |          |""|        |
        DB    036H            ; 00110110  ۰۰   |          \---/        |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    018H            ; 00011000  ۰   |         n 216        |
        DB    018H            ; 00011000  ۰   |         n D8H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |""|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    0F8H            ; 11111000  ۰   |                       |
        DB    000H            ; 00000000     |         n 217        |
        DB    000H            ; 00000000     |         n D9H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |"/"|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    01FH            ; 00011111     |                       |
        DB    018H            ; 00011000  ۰   |         n 218        |
        DB    018H            ; 00011000  ۰   |         n DAH        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |"/"|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   \-----------------------/
                                                  
        DB    0FFH            ; 11111111     /-----------------------\
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    0FFH            ; 11111111     |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |         n 219        |
        DB    0FFH            ; 11111111     |         n DBH        |
        DB    0FFH            ; 11111111     |          /---\        |
        DB    0FFH            ; 11111111     |          |""|        |
        DB    0FFH            ; 11111111     |          \---/        |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |         n 220        |
        DB    0FFH            ; 11111111     |         n DCH        |
        DB    0FFH            ; 11111111     |          /---\        |
        DB    0FFH            ; 11111111     |          |""|        |
        DB    0FFH            ; 11111111     |          \---/        |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     \-----------------------/
        DB    0FFH            ; 11111111  
                                                  
        DB    0F0H            ; 11110000  ۰   /-----------------------\
        DB    0F0H            ; 11110000  ۰   |                       |
        DB    0F0H            ; 11110000  ۰   |                       |
        DB    0F0H            ; 11110000  ۰   |                       |
        DB    0F0H            ; 11110000  ۰   |                       |
        DB    0F0H            ; 11110000  ۰   |       CARATTERE       |
        DB    0F0H            ; 11110000  ۰   |         ASCII         |
        DB    0F0H            ; 11110000  ۰   |                       |
        DB    0F0H            ; 11110000  ۰   |         n 221        |
        DB    0F0H            ; 11110000  ۰   |         n DDH        |
        DB    0F0H            ; 11110000  ۰   |          /---\        |
        DB    0F0H            ; 11110000  ۰   |          |""|        |
        DB    0F0H            ; 11110000  ۰   |          \---/        |
        DB    0F0H            ; 11110000  ۰   |                       |
        DB    0F0H            ; 11110000  ۰   \-----------------------/
        DB    0F0H            ; 11110000  ۰
                                                  
        DB    00FH            ; 00001111     /-----------------------\
        DB    00FH            ; 00001111     |                       |
        DB    00FH            ; 00001111     |                       |
        DB    00FH            ; 00001111     |                       |
        DB    00FH            ; 00001111     |                       |
        DB    00FH            ; 00001111     |       CARATTERE       |
        DB    00FH            ; 00001111     |         ASCII         |
        DB    00FH            ; 00001111     |                       |
        DB    00FH            ; 00001111     |         n 222        |
        DB    00FH            ; 00001111     |         n DEH        |
        DB    00FH            ; 00001111     |          /---\        |
        DB    00FH            ; 00001111     |          |""|        |
        DB    00FH            ; 00001111     |          \---/        |
        DB    00FH            ; 00001111     |                       |
        DB    00FH            ; 00001111     \-----------------------/
        DB    00FH            ; 00001111  
                                                  
        DB    0FFH            ; 11111111     /-----------------------\
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    0FFH            ; 11111111     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 223        |
        DB    000H            ; 00000000     |         n DFH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
        DB    000H            ; 00000000  
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03BH            ; 00111011  ۰   |       CARATTERE       |
        DB    06EH            ; 01101110  ۰۰   |         ASCII         |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |         n 224        |
        DB    06EH            ; 01101110  ۰۰   |         n E0H        |
        DB    03BH            ; 00111011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
        DB    000H            ; 00000000  
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    063H            ; 01100011  ۰   |       CARATTERE       |
        DB    07EH            ; 01111110  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 225        |
        DB    07EH            ; 01111110  ۰   |         n E1H        |
        DB    060H            ; 01100000  ۰   |          /---\        |
        DB    060H            ; 01100000  ۰   |          |""|        |
        DB    020H            ; 00100000  ۰   |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    060H            ; 01100000  ۰   |       CARATTERE       |
        DB    060H            ; 01100000  ۰   |         ASCII         |
        DB    060H            ; 01100000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |         n 226        |
        DB    060H            ; 01100000  ۰   |         n E2H        |
        DB    060H            ; 01100000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    036H            ; 00110110  ۰۰   |       CARATTERE       |
        DB    036H            ; 00110110  ۰۰   |         ASCII         |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 227        |
        DB    036H            ; 00110110  ۰۰   |         n E3H        |
        DB    036H            ; 00110110  ۰۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    00CH            ; 00001100  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |         n 228        |
        DB    063H            ; 01100011  ۰   |         n E4H        |
        DB    07FH            ; 01111111     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03FH            ; 00111111     |       CARATTERE       |
        DB    06CH            ; 01101100  ۰۰   |         ASCII         |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |         n 229        |
        DB    06CH            ; 01101100  ۰۰   |         n E5H        |
        DB    038H            ; 00111000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    033H            ; 00110011  ۰   |                       |
        DB    033H            ; 00110011  ۰   |       CARATTERE       |
        DB    033H            ; 00110011  ۰   |         ASCII         |
        DB    033H            ; 00110011  ۰   |                       |
        DB    03EH            ; 00111110  ۰   |         n 230        |
        DB    030H            ; 00110000  ۰   |         n E6H        |
        DB    030H            ; 00110000  ۰   |          /---\        |
        DB    060H            ; 01100000  ۰   |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03BH            ; 00111011  ۰   |                       |
        DB    06EH            ; 01101110  ۰۰   |       CARATTERE       |
        DB    00CH            ; 00001100  ۰   |         ASCII         |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |         n 231        |
        DB    00CH            ; 00001100  ۰   |         n E7H        |
        DB    00CH            ; 00001100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    03CH            ; 00111100  ۰   |                       |
        DB    066H            ; 01100110  ۰۰   |       CARATTERE       |
        DB    066H            ; 01100110  ۰۰   |         ASCII         |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    03CH            ; 00111100  ۰   |         n 232        |
        DB    018H            ; 00011000  ۰   |         n E8H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 233        |
        DB    036H            ; 00110110  ۰۰   |         n E9H        |
        DB    01CH            ; 00011100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    036H            ; 00110110  ۰۰   |                       |
        DB    036H            ; 00110110  ۰۰   |         n 234        |
        DB    036H            ; 00110110  ۰۰   |         n EAH        |
        DB    077H            ; 01110111  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    01EH            ; 00011110  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |       CARATTERE       |
        DB    03EH            ; 00111110  ۰   |         ASCII         |
        DB    066H            ; 01100110  ۰۰   |                       |
        DB    066H            ; 01100110  ۰۰   |         n 235        |
        DB    066H            ; 01100110  ۰۰   |         n EBH        |
        DB    03CH            ; 00111100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07EH            ; 01111110  ۰   |       CARATTERE       |
        DB    0DBH            ; 11011011  ۰۰   |         ASCII         |
        DB    0DBH            ; 11011011  ۰۰   |                       |
        DB    07EH            ; 01111110  ۰   |         n 236        |
        DB    000H            ; 00000000     |         n ECH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    003H            ; 00000011     |                       |
        DB    006H            ; 00000110  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |                       |
        DB    0DBH            ; 11011011  ۰۰   |       CARATTERE       |
        DB    0DBH            ; 11011011  ۰۰   |         ASCII         |
        DB    0F3H            ; 11110011  ۰   |                       |
        DB    07EH            ; 01111110  ۰   |         n 237        |
        DB    060H            ; 01100000  ۰   |         n EDH        |
        DB    0C0H            ; 11000000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    01CH            ; 00011100  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |       CARATTERE       |
        DB    07CH            ; 01111100  ۰   |         ASCII         |
        DB    060H            ; 01100000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |         n 238        |
        DB    030H            ; 00110000  ۰   |         n EEH        |
        DB    01CH            ; 00011100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |       CARATTERE       |
        DB    063H            ; 01100011  ۰   |         ASCII         |
        DB    063H            ; 01100011  ۰   |                       |
        DB    063H            ; 01100011  ۰   |         n 239        |
        DB    063H            ; 01100011  ۰   |         n EFH        |
        DB    063H            ; 01100011  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    07FH            ; 01111111     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    07FH            ; 01111111     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 240        |
        DB    07FH            ; 01111111     |         n F0H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    0FFH            ; 11111111     |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 241        |
        DB    000H            ; 00000000     |         n F1H        |
        DB    0FFH            ; 11111111     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    006H            ; 00000110  ۰   |       CARATTERE       |
        DB    00CH            ; 00001100  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |         n 242        |
        DB    000H            ; 00000000     |         n F2H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |       CARATTERE       |
        DB    030H            ; 00110000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |         n 243        |
        DB    000H            ; 00000000     |         n F3H        |
        DB    07EH            ; 01111110  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    00EH            ; 00001110  ۰   |                       |
        DB    01BH            ; 00011011  ۰   |                       |
        DB    01BH            ; 00011011  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |         n 244        |
        DB    018H            ; 00011000  ۰   |         n F4H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    018H            ; 00011000  ۰   |          |""|        |
        DB    018H            ; 00011000  ۰   |          \---/        |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    018H            ; 00011000  ۰   /-----------------------\
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    0D8H            ; 11011000  ۰۰   |         n 245        |
        DB    0D8H            ; 11011000  ۰۰   |         n F5H        |
        DB    070H            ; 01110000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    0FFH            ; 11111111     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 246        |
        DB    018H            ; 00011000  ۰   |         n F6H        |
        DB    018H            ; 00011000  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03BH            ; 00111011  ۰   |                       |
        DB    06EH            ; 01101110  ۰۰   |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    03BH            ; 00111011  ۰   |                       |
        DB    06EH            ; 01101110  ۰۰   |         n 247        |
        DB    000H            ; 00000000     |         n F7H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    038H            ; 00111000  ۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    038H            ; 00111000  ۰   |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 248        |
        DB    000H            ; 00000000     |         n F8H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    018H            ; 00011000  ۰   |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |         n 249        |
        DB    000H            ; 00000000     |         n F9H        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    018H            ; 00011000  ۰   |                       |
        DB    000H            ; 00000000     |         n 250        |
        DB    000H            ; 00000000     |         n FAH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    00FH            ; 00001111     |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |                       |
        DB    00CH            ; 00001100  ۰   |       CARATTERE       |
        DB    00CH            ; 00001100  ۰   |         ASCII         |
        DB    0ECH            ; 11101100  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |         n 251        |
        DB    03CH            ; 00111100  ۰   |         n FBH        |
        DB    01CH            ; 00011100  ۰   |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    0D8H            ; 11011000  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |                       |
        DB    06CH            ; 01101100  ۰۰   |       CARATTERE       |
        DB    06CH            ; 01101100  ۰۰   |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 252        |
        DB    000H            ; 00000000     |         n FCH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    070H            ; 01110000  ۰   |                       |
        DB    0D8H            ; 11011000  ۰۰   |                       |
        DB    030H            ; 00110000  ۰   |                       |
        DB    060H            ; 01100000  ۰   |                       |
        DB    0C8H            ; 11001000  ۰۰   |       CARATTERE       |
        DB    0F8H            ; 11111000  ۰   |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 253        |
        DB    000H            ; 00000000     |         n FDH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    03EH            ; 00111110  ۰   |       CARATTERE       |
        DB    03EH            ; 00111110  ۰   |         ASCII         |
        DB    03EH            ; 00111110  ۰   |                       |
        DB    03EH            ; 00111110  ۰   |         n 254        |
        DB    03EH            ; 00111110  ۰   |         n FEH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
        DB    000H            ; 00000000     /-----------------------\
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |       CARATTERE       |
        DB    000H            ; 00000000     |         ASCII         |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |         n 255        |
        DB    000H            ; 00000000     |         n FFH        |
        DB    000H            ; 00000000     |          /---\        |
        DB    000H            ; 00000000     |          |""|        |
        DB    000H            ; 00000000     |          \---/        |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     |                       |
        DB    000H            ; 00000000     \-----------------------/
                                                  
B10_1121 ENDP                 ; Chiusura della Procedura "Main Program"
_prog   ENDS                  ; Chiusura del Segmento di CODICE
        END INIZIO            ; Indirizzo dell'ultima istruzione da compilare
